#!/bin/bash
# Install.sh - installation script for eye-opening package

# Initial sanity checks

if [ $UID != 0 ]; then
  echo ERROR : Must be root to run this script.
  echo ""
  echo "	"Install Failed 
  exit 1
fi
###
usage()
{
cat << EOF
	
	Usage:	`basename $0` [--tool_dir <tool directory>]

EOF
}
echo ""
# Default values
prefix="/usr/eye_opening"
twodirpwd=`echo $PWD | cut -d"/" -f1-3`

while [ "$1" ]; do
	case "$1" in
		-t |--tool_dir)
		    shift
		    prefix=$1
		;;
                -h|--help|*)
                    usage
                    exit 1 
                ;;
	esac
   shift
done

if [ -e $prefix ] ; then
	 echo -n "Remove currently installed components (rm -rf $prefix) (y/n) [n] ? "
	 read force 
	 if [ "$force" != "y" ] && [ "$force" != "yes" ] && [ "$force" != "Y" ] && [ "$force" != "YES" ] ; then
		exit 1
	 else
	 # Clean old distribution
		if [ "$prefix" == "$twodirpwd" ] ; then
			echo "Can't remove current dir while in it "
			echo "please un-pack in another directory"
			echo "******* Install failed ************"
			echo ""
			exit 1
		fi
	 	echo "Removing $prefix"
		rm -rf $prefix
	 fi
fi	
echo "`basename $0` will put tool in $prefix directory"
echo "FYI : You can change it using pref option. See -h for usage explanation"
echo ""
/bin/mkdir -p $prefix
/bin/cp BUILD_ID $prefix
/bin/cp uninstall.sh $prefix 
/bin/cp -rf tools/ $prefix/tools
/bin/cp -rf bin/ $prefix/bin
echo ""
echo " Install Finished "
echo ""

exit 0

