#include <cm_test.h>

char ** cm_event_table;
char ** conn_state_str;
cmtest_context_t cm_test_ctx;


//CONNECTION_INFO_t * conn_arr;

atomic_t clnt_refcnt;

extern QUEUE_t q;

int srv_conn_cnt;



int callcbk_is_err(tTS_IB_U_QP_HANDLE   consumer_qp,
                   tTS_IB_CM_COMM_ID    comm_id,
                   tTS_IB_CM_EVENT      event,
                   void                *params,
                   void                *arg)
{
    debug("Error in test flow");

    return 0;
}

/***************
*  Test type 1 *
***************/

/* Test flow: connect, accept, confirm, active disconnect, idle */

int test_1_clnt_conn_code(tTS_IB_U_QP_HANDLE consumer_qp, tTS_IB_CM_COMM_ID comm_id, 
                          tTS_IB_CM_EVENT event, void *params, void  *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on conn 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    //printf("Got callbck, conn_p is %p\n", arg);
    
    if ((event == TS_IB_CM_REP_RECEIVED) && (conn_p->stage == CONN_STAGE_CLNT_CREATION))
    {
        int ret = tsIbUCmConfirm(comm_id, NULL, 0);

        if(ret)
            debug("Confirm return non zero value on sucess");

        conn_p->stage = CONN_STAGE_CLNT_CONFIRM;

        debug("Confirmed");

    }
    else if ((event == TS_IB_CM_ESTABLISHED)&&(conn_p->stage == CONN_STAGE_CLNT_CONFIRM))
    {
        conn_p->stage = CONN_STAGE_CLNT_ESTB;
        debug("Established -  Going to disconnect");

        tsIbUCmDisconnect(comm_id);

    }
    else if ((event == TS_IB_CM_DISCONNECTED)&&(conn_p->stage == CONN_STAGE_CLNT_ESTB))
    {
        conn_p->stage = CONN_STAGE_CLNT_DISCONN;
    }
    else if ((event == TS_IB_CM_IDLE)&&(conn_p->stage == CONN_STAGE_CLNT_DISCONN))
    {
        conn_p->stage = CONN_STAGE_CLNT_IDLE;

        atomic_dec(&clnt_refcnt);

        debug("Idle ");
    }
    else if ((event == TS_IB_CM_IDLE) && (conn_p->stage == CONN_STAGE_CLNT_CREATION))
    {
        atomic_dec(&clnt_refcnt);
    }
    else
    {
        err_exit("Not expected situation => ERROR");
    }

    return 0;
}


int test_1_srv_conn_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                         tTS_IB_CM_COMM_ID    comm_id,
                         tTS_IB_CM_EVENT      event,
                         void                *params,
                         void                *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on comm_id 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    if ((event == TS_IB_CM_ESTABLISHED) && (conn_p->stage == CONN_STAGE_SERV_ACCEPT))
    {
        conn_p->stage = CONN_STAGE_SERV_ESTB;
        debug("Establish");

    }
    else if ((event == TS_IB_CM_DISCONNECTED)&&(conn_p->stage == CONN_STAGE_SERV_ESTB))
    {
        conn_p->stage = CONN_STAGE_SERV_DISCONN;
        debug("Disconnecitng");

    }
    else if ((event == TS_IB_CM_IDLE)&&
                                ((conn_p->stage == CONN_STAGE_SERV_DISCONN) ||
                                 (conn_p->stage == CONN_STAGE_SERV_ESTB)    ||
                                 (conn_p->stage == CONN_STAGE_SERV_ACCEPT)))
    {
        conn_p->stage = CONN_STAGE_SERV_IDLE;

        debug("Idle -> freeing conn_p");

        reset_qp_state(conn_p->qp_hndl_p);

        enQ_qp(&q,conn_p->qp_hndl_p);

        free(conn_p);

        srv_conn_cnt--;

    }
    else
    {
        if (event == TS_IB_CM_IDLE)
        {
            reset_qp_state(conn_p->qp_hndl_p);

            debug("Reseting qp state");

            enQ_qp(&q,conn_p->qp_hndl_p);

            free(conn_p);

            srv_conn_cnt--;
        }

        debug("Not expected situation => ERROR");
    }

    return 0;
}




void test_1_listen_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                        tTS_IB_CM_COMM_ID    comm_id,
                        tTS_IB_CM_EVENT      event,
                        void                *params,
                        void                *arg)
{
    int ret;
    QP_HANDLE_t * qp_hndl_p;

    LISTEN_INFO_t       *listen_p = arg;

    CONNECTION_INFO_t * conn_p;

    switch (event)
    {
    case TS_IB_CM_REQ_RECEIVED:

        debug("RCV: TS_IB_CM_REQ_RECEIVED");

        conn_p = malloc(sizeof(CONNECTION_INFO_t));

        if (!conn_p)
            exit(-1);


        if (deQ_qp(&q, &qp_hndl_p))
            exit(-1);

        conn_p->qp_hndl_p   = qp_hndl_p;

        conn_p->test_type   = TEST_TYPE_1;

        conn_p->sid         = listen_p->sid;

        conn_p->stage       = CONN_STAGE_SERV_ACCEPT;

        conn_p->cid         = comm_id;

        ret = tsIbUCmAccept(comm_id, 
                            cm_test_ctx.v_hca, 
                            qp_hndl_p->qp, 
                            qp_hndl_p->qpn, 
                            test_1_srv_conn_code, 
                            conn_p, 
                            NULL, 
                            0);
        if (ret)
        {
            debug("BUG: Accept return value is %d", ret);

            reset_qp_state(conn_p->qp_hndl_p);

            enQ_qp(&q,qp_hndl_p);

            free(conn_p);
        }
        else
        {
            srv_conn_cnt++;
        }


        break;

    default:

        debug("RCV: Unkown");
        break;

    }
}




/***************
*  Test type 2 *
***************/

/* Test flow: connect, reject, idle */

void test_2_listen_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                        tTS_IB_CM_COMM_ID    comm_id,
                        tTS_IB_CM_EVENT      event,
                        void                *params,
                        void                *arg)
{
    int ret;

    //LISTEN_INFO_t       *listen_p = arg;

    switch (event)
    {
    case TS_IB_CM_REQ_RECEIVED:

        debug("RCV: TS_IB_CM_REQ_RECEIVED");

        ret = tsIbUCmReject(comm_id,NULL,0);

        break;

    default:

        debug("RCV: Unkown");
        break;

    }
}


int test_2_clnt_conn_code(tTS_IB_U_QP_HANDLE consumer_qp, tTS_IB_CM_COMM_ID comm_id, 
                          tTS_IB_CM_EVENT event, void *params, void  *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on conn 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    //printf("Got callbck, conn_p is %p\n", arg);
    if ((event == TS_IB_CM_IDLE))
    {
        conn_p->stage = CONN_STAGE_CLNT_IDLE;

        atomic_dec(&clnt_refcnt);

        debug("Idle ");
    }
    else
    {
        if (event != TS_IB_CM_DISCONNECTED)
        {
            err_exit("Not expected situation => ERROR");
        }
    }

    return 0;
}





/***************
*  Test type 3 *
***************/

/* Test flow: connect, err qp accept, idle */

int test_3_clnt_conn_code(tTS_IB_U_QP_HANDLE consumer_qp, tTS_IB_CM_COMM_ID comm_id, 
                          tTS_IB_CM_EVENT event, void *params, void  *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on conn 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    //printf("Got callbck, conn_p is %p\n", arg);
    if ((event == TS_IB_CM_IDLE))
    {
        conn_p->stage = CONN_STAGE_CLNT_IDLE;

        atomic_dec(&clnt_refcnt);

        debug("Idle ");
    }
    else
    {
        err_exit("Not expected situation => ERROR");
    }

    return 0;
}


void test_3_listen_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                        tTS_IB_CM_COMM_ID    comm_id,
                        tTS_IB_CM_EVENT      event,
                        void                *params,
                        void                *arg)
{
    int ret;

    switch (event)
    {
    case TS_IB_CM_REQ_RECEIVED:

        debug("RCV: TS_IB_CM_REQ_RECEIVED");

        QP_HANDLE_t * qp_hndl_p;


        if (deQ_qp(&q, &qp_hndl_p))
            exit(-1);

        qp_state_to_err(qp_hndl_p);

        ret = tsIbUCmAccept(comm_id, 
                            cm_test_ctx.v_hca, 
                            qp_hndl_p->qp, 
                            qp_hndl_p->qpn, 
                            callcbk_is_err, 
                            0, 
                            NULL, 
                            0);
        if (!ret)
        {
            debug("An error in test flow");
        }

        reset_qp_state(qp_hndl_p);

        enQ_qp(&q,qp_hndl_p);

        break;

    default:

        debug("Not expected situation => ERROR");

        exit(-1);

        break;

    }
}




/***************
*  Test type 4 *
***************/

/* Test flow: connect, accept, err qp confirm */

int test_4_clnt_conn_code(tTS_IB_U_QP_HANDLE consumer_qp, tTS_IB_CM_COMM_ID comm_id, 
                          tTS_IB_CM_EVENT event, void *params, void  *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;
    int ret;

    debug("Event %s received on conn 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    //printf("Got callbck, conn_p is %p\n", arg);

    if ((event == TS_IB_CM_REP_RECEIVED) && (conn_p->stage == CONN_STAGE_CLNT_CREATION))
    {
        qp_state_to_err(conn_p->qp_hndl_p);

        ret = tsIbUCmConfirm(comm_id, NULL, 0);

        if (!ret)
        {
            debug("Error in test flow");

            exit(-1);
        }

        debug("Confirm - bad machine");

        conn_p->stage = CONN_STAGE_CLNT_CONFIRM_FAIL;

        atomic_dec(&clnt_refcnt);

    }
    else if ((event == TS_IB_CM_IDLE) && (conn_p->stage == CONN_STAGE_CLNT_CREATION))
    {
        atomic_dec(&clnt_refcnt);
    }
    else
    {
        err_exit("Not expected situation => ERROR");
    }

    return 0;
}


int test_4_srv_conn_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                         tTS_IB_CM_COMM_ID    comm_id,
                         tTS_IB_CM_EVENT      event,
                         void                *params,
                         void                *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on comm_id 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);



    if ((event == TS_IB_CM_IDLE) && (conn_p->stage == CONN_STAGE_SERV_ACCEPT))
    {
        reset_qp_state(conn_p->qp_hndl_p);

        enQ_qp(&q,conn_p->qp_hndl_p);

        free(conn_p);

        srv_conn_cnt--;
    }
    else
    {
        if (event == TS_IB_CM_IDLE)
        {
            reset_qp_state(conn_p->qp_hndl_p);

            debug("Reseting qp state");

            enQ_qp(&q,conn_p->qp_hndl_p);

            free(conn_p);

            srv_conn_cnt--;
        }

        debug("Not expected situation => ERROR");
    }

    return 0;
}




void test_4_listen_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                        tTS_IB_CM_COMM_ID    comm_id,
                        tTS_IB_CM_EVENT      event,
                        void                *params,
                        void                *arg)
{
    int ret;
    QP_HANDLE_t * qp_hndl_p;

    LISTEN_INFO_t       *listen_p = arg;

    CONNECTION_INFO_t * conn_p;

    switch (event)
    {
    case TS_IB_CM_REQ_RECEIVED:

        debug("RCV: TS_IB_CM_REQ_RECEIVED");

        conn_p = malloc(sizeof(CONNECTION_INFO_t));

        if (!conn_p)
            exit(-1);


        if (deQ_qp(&q, &qp_hndl_p))
            exit(-1);

        conn_p->qp_hndl_p   = qp_hndl_p;

        conn_p->test_type   = TEST_TYPE_4;

        conn_p->sid         = listen_p->sid;

        conn_p->stage       = CONN_STAGE_SERV_ACCEPT;

        conn_p->cid         = comm_id;

        ret = tsIbUCmAccept(comm_id, 
                            cm_test_ctx.v_hca, 
                            qp_hndl_p->qp, 
                            qp_hndl_p->qpn, 
                            test_4_srv_conn_code, 
                            conn_p, 
                            NULL, 
                            0);
        if (ret)
        {
            debug("BUG: Accept return value is %d", ret);

            reset_qp_state(conn_p->qp_hndl_p);

            enQ_qp(&q,qp_hndl_p);

            free(conn_p);
        }
        else
        {
            srv_conn_cnt++;
        }


        break;

    default:

        debug("RCV: Unkown");
        break;

    }
}


/***************
*  Test type 5 *
***************/

/* Test flow: connect, accept - drop-consumer, confirm  */

int test_5_clnt_conn_code(tTS_IB_U_QP_HANDLE consumer_qp, tTS_IB_CM_COMM_ID comm_id, 
                          tTS_IB_CM_EVENT event, void *params, void  *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;
    int ret;

    debug("Event %s received on conn 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    //printf("Got callbck, conn_p is %p\n", arg);

    if ((event == TS_IB_CM_REP_RECEIVED) && (conn_p->stage == CONN_STAGE_CLNT_CREATION))
    {
        ret = tsIbUCmConfirm(comm_id, NULL, 0);

        if (ret)
        {                                                   
            debug("Confirm failed ret %d", ret);

            conn_p->stage = CONN_STAGE_CLNT_CONFIRM_FAIL;

            if (ret == -22)
            {
                atomic_dec(&clnt_refcnt);
            }
        }
        

    }
    else
    {
        if (event == TS_IB_CM_IDLE)
        {
            atomic_dec(&clnt_refcnt);
        }         
    }

    return 0;
}


int test_5_srv_conn_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                         tTS_IB_CM_COMM_ID    comm_id,
                         tTS_IB_CM_EVENT      event,
                         void                *params,
                         void                *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on comm_id 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);



    if ((event == TS_IB_CM_IDLE) && (conn_p->stage == CONN_STAGE_SERV_ACCEPT))
    {
        reset_qp_state(conn_p->qp_hndl_p);

        enQ_qp(&q,conn_p->qp_hndl_p);

        free(conn_p);

        srv_conn_cnt--;
    }
    else
    {
        if (event == TS_IB_CM_IDLE)
        {
            reset_qp_state(conn_p->qp_hndl_p);

            debug("Reseting qp state");

            enQ_qp(&q,conn_p->qp_hndl_p);

            free(conn_p);

            srv_conn_cnt--;
        }

        debug("Not expected situation => ERROR");
    }

    return 0;
}




void test_5_listen_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                        tTS_IB_CM_COMM_ID    comm_id,
                        tTS_IB_CM_EVENT      event,
                        void                *params,
                        void                *arg)
{
    int ret;
    QP_HANDLE_t * qp_hndl_p;

    LISTEN_INFO_t       *listen_p = arg;

    CONNECTION_INFO_t * conn_p;

    //int i;

    switch (event)
    {
    case TS_IB_CM_REQ_RECEIVED:

        debug("RCV: TS_IB_CM_REQ_RECEIVED");

        conn_p = malloc(sizeof(CONNECTION_INFO_t));

        if (!conn_p)
            exit(-1);


        if (deQ_qp(&q, &qp_hndl_p))
            exit(-1);

        conn_p->qp_hndl_p   = qp_hndl_p;

        conn_p->test_type   = TEST_TYPE_5;

        conn_p->sid         = listen_p->sid;

        conn_p->stage       = CONN_STAGE_SERV_ACCEPT;

        conn_p->cid         = comm_id;

        ret = tsIbUCmAccept(comm_id, 
                            cm_test_ctx.v_hca, 
                            qp_hndl_p->qp, 
                            qp_hndl_p->qpn, 
                            test_5_srv_conn_code, 
                            conn_p, 
                            NULL, 
                            0);

        if (mlx_rand(1,0))
            usleep(mlx_rand(10,1));

        if (!tsIbUCmDropConsumer(comm_id)){

            debug("DropConsumer succeeded");

            reset_qp_state(conn_p->qp_hndl_p);
            
            enQ_qp(&q,qp_hndl_p);
            
            free(conn_p);
        }

        break;

    default:

        debug("RCV: Unkown");
        break;

    }
}




/***************
*  Test type 6 *
***************/

/* Test flow: connect, accept, confirm - drop-consumer, (passive establish) drop-consumer */

int test_6_clnt_conn_code(tTS_IB_U_QP_HANDLE consumer_qp, tTS_IB_CM_COMM_ID comm_id, 
                          tTS_IB_CM_EVENT event, void *params, void  *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on conn 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    if ((event == TS_IB_CM_REP_RECEIVED) && (conn_p->stage == CONN_STAGE_CLNT_CREATION))
    {
        tsIbUCmConfirm(comm_id, NULL, 0);

        conn_p->stage = CONN_STAGE_CLNT_CONFIRM;

    }
    else if ((event == TS_IB_CM_ESTABLISHED)&&(conn_p->stage == CONN_STAGE_CLNT_CONFIRM))
    {
        if (mlx_rand(1,0))
            usleep(mlx_rand(35,15));

        if (!tsIbUCmDropConsumer(comm_id)){

            atomic_dec(&clnt_refcnt);

            debug("DropConsumer succeeded");
        }
        else
        {
            atomic_dec(&clnt_refcnt);
            debug("DropConsumer failed");
        }
    }
    else if ((event == TS_IB_CM_IDLE))
    {
        debug("Error - Got IDLE after drop");
        //err_exit("Not expected situation => ERROR");
    }
    

    return 0;
}


int test_6_srv_conn_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                         tTS_IB_CM_COMM_ID    comm_id,
                         tTS_IB_CM_EVENT      event,
                         void                *params,
                         void                *arg)
{
    CONNECTION_INFO_t   *conn_p = arg;

    debug("Event %s received on comm_id 0x%x, conn_state %s", 
          cm_event_table[event],
          conn_p->cid, conn_state_str[conn_p->stage]);

    if ((event == TS_IB_CM_ESTABLISHED) && (conn_p->stage == CONN_STAGE_SERV_ACCEPT))
    {
        if (!tsIbUCmDropConsumer(comm_id)){

            debug("DropConsumer succeeded");

            reset_qp_state(conn_p->qp_hndl_p);
            
            enQ_qp(&q,conn_p->qp_hndl_p);
            
            free(conn_p);

            srv_conn_cnt--;
        }

        conn_p->stage = CONN_STAGE_SERV_ESTB_DROP;

    }
    else if ((event == TS_IB_CM_DISCONNECTED)&&(conn_p->stage == CONN_STAGE_SERV_ESTB_DROP))
    {
        debug("Got Disconnecitng");

    }
    else if ((event == TS_IB_CM_IDLE)&&
             ((conn_p->stage == CONN_STAGE_SERV_ESTB_DROP) || (conn_p->stage == CONN_STAGE_SERV_ACCEPT)))
    {
        debug("Got idle");
    }
    else
    {
        debug("Not expected situation => ERROR");
    }

    return 0;
}




void test_6_listen_code(tTS_IB_U_QP_HANDLE   consumer_qp,
                        tTS_IB_CM_COMM_ID    comm_id,
                        tTS_IB_CM_EVENT      event,
                        void                *params,
                        void                *arg)
{
    int ret;
    QP_HANDLE_t * qp_hndl_p;

    LISTEN_INFO_t       *listen_p = arg;

    CONNECTION_INFO_t * conn_p;

    switch (event)
    {
    case TS_IB_CM_REQ_RECEIVED:

        debug("RCV: TS_IB_CM_REQ_RECEIVED");

        conn_p = malloc(sizeof(CONNECTION_INFO_t));

        if (!conn_p)
            exit(-1);


        if (deQ_qp(&q, &qp_hndl_p))
            exit(-1);

        conn_p->qp_hndl_p   = qp_hndl_p;

        conn_p->test_type   = TEST_TYPE_1;

        conn_p->sid         = listen_p->sid;

        conn_p->stage       = CONN_STAGE_SERV_ACCEPT;

        conn_p->cid         = comm_id;

        ret = tsIbUCmAccept(comm_id, 
                            cm_test_ctx.v_hca, 
                            qp_hndl_p->qp, 
                            qp_hndl_p->qpn, 
                            test_6_srv_conn_code, 
                            conn_p, 
                            NULL, 
                            0);
        if (ret)
        {
            debug("BUG: Accept return value is %d", ret);

            reset_qp_state(conn_p->qp_hndl_p);

            enQ_qp(&q,qp_hndl_p);

            free(conn_p);
        }
        else
        {
            srv_conn_cnt++;
        }


        break;

    default:

        debug("RCV: Unkown");
        break;

    }
}

