#include <cm_test.h>



///////////////////////////////////////////////////
// EXTERN VARIABLES DECLERATIONS
///////////////////////////////////////////////////

extern LISTEN_INFO_t     * listen_array;

extern int listen_inx;

extern VAPI_hca_hndl_t hca;

extern char * hca_name;

extern VAPI_hca_port_t hca_port;

extern IB_gid_t gid;

extern VAPI_pd_hndl_t        pd;


static char * CM_EVENT_NAME_STR[] = {
    [TS_IB_CM_REQ_RECEIVED]              =    "TS_IB_CM_REQ_RECEIVED"   ,
    [TS_IB_CM_REP_RECEIVED]              =    "TS_IB_CM_REP_RECEIVED"   ,
    [TS_IB_CM_LAP_RECEIVED]              =    "TS_IB_CM_LAP_RECEIVED"   ,
    [TS_IB_CM_APR_RECEIVED]              =    "TS_IB_CM_APR_RECEIVED"   ,
    [TS_IB_CM_ESTABLISHED ]              =    "TS_IB_CM_ESTABLISHED "   ,
    [TS_IB_CM_DISCONNECTED]              =    "TS_IB_CM_DISCONNECTED"   ,
    [TS_IB_CM_IDLE        ]              =    "TS_IB_CM_IDLE        "   
    
}; 

char ** cm_event_table = CM_EVENT_NAME_STR;


static char * CONN_STATE_NAME_STR[] = {
    [CONN_STAGE_SERV_ACCEPT       ]         =    "CONN_STAGE_SERV_ACCEPT       "   ,
    [CONN_STAGE_SERV_ESTB         ]         =    "CONN_STAGE_SERV_ESTB         "   ,
    [CONN_STAGE_SERV_ESTB_DROP    ]         =    "CONN_STAGE_SERV_ESTB_DROP    "   ,
    [CONN_STAGE_SERV_DISCONN      ]         =    "CONN_STAGE_SERV_DISCONN      "   ,
    [CONN_STAGE_SERV_IDLE         ]         =    "CONN_STAGE_SERV_IDLE         "   ,
    [CONN_STAGE_CLNT_CREATION     ]         =    "CONN_STAGE_CLNT_CREATION     "   , 
    [CONN_STAGE_CLNT_CONFIRM      ]         =    "CONN_STAGE_CLNT_CONFIRM      "   , 
    [CONN_STAGE_CLNT_CONFIRM_FAIL ]         =    "CONN_STAGE_CLNT_CONFIRM_FAIL "   , 
    [CONN_STAGE_CLNT_CONFIRM_DROP ]         =    "CONN_STAGE_CLNT_CONFIRM_DROP "   ,
    [CONN_STAGE_CLNT_ESTB         ]         =    "CONN_STAGE_CLNT_ESTB         "   ,
    [CONN_STAGE_CLNT_DISCONN      ]         =    "CONN_STAGE_CLNT_DISCONN      "   , 
    [CONN_STAHE_CLNT_REJ          ]         =    "CONN_STAHE_CLNT_REJ          "   , 
    [CONN_STAGE_CLNT_IDLE         ]         =    "CONN_STAGE_CLNT_IDLE         "
};


char ** conn_state_str = CONN_STATE_NAME_STR;

///////////////////////////////////////////////////
// FUNCTION DEFINITION
///////////////////////////////////////////////////

void init_qp_queue(QUEUE_t * q, unsigned int size)
{
    q->size = size;

    q->inx = 0;

    q->p_arr = malloc( sizeof(QP_HANDLE_t *) * size);
}


int enQ_qp(QUEUE_t * q, QP_HANDLE_t * elem_p) 
{
    if (q->inx < (q->size)) 
    {
        q->p_arr[q->inx] = elem_p;

        //qp_q_buff[qp_q_inx].handle_p = handle_p;

        q->inx++;

        return 0;
    } 
    else
    {
        error("QP queue full can't enqueue bug in test");

        return -1;
    }
}

int deQ_qp(QUEUE_t * q, QP_HANDLE_t ** elem_p_p)
{
    if (q->inx > 0)
    {
        q->inx--;

        *elem_p_p = q->p_arr[q->inx];

        return 0;
    }
    else
    {
        error("QP queue empty can't dequeue queue empty");

        return -1;

    }
}


unsigned int mlx_rand(unsigned int x, unsigned int y)
{
    unsigned int diff, bottom;

    if (x == y)
        return y;
    else if ( x > y)
    {
        bottom = y;

        diff = x - y;
    }
    else
    {
        bottom = x;

        diff = y - x + 1;
    }

    //return (bottom + (int) (diff*rand()/(RAND_MAX+1.0)));
    return (bottom + (int) rand()%diff);

}


#define MAX_GID_TBL 0x20

int get_port_gid(VAPI_hca_hndl_t hca_hndl, IB_port_t port, IB_gid_t * gid)
{
  VAPI_ret_t rc;
  u_int16_t tbl_sz;
  IB_gid_t gid_tbl[MAX_GID_TBL] = { {0} };
  

  rc = VAPI_query_hca_gid_tbl(hca_hndl, port, MAX_GID_TBL, &tbl_sz, gid_tbl);
  if ( rc != VAPI_OK )
      return(-1);

  memcpy(gid, gid_tbl[0], sizeof(IB_gid_t));


  return(0);

}

void init_hca() 
{   
    if (EVAPI_get_hca_hndl(hca_name, &hca))
        err_exit("Couldn't get hca handle");

    if (get_port_gid(hca, HCA_PORT, &gid))
        err_exit("Couldn't get GID");

    if (VAPI_query_hca_port_prop(hca, HCA_PORT, &hca_port))
        err_exit("Couldn't get hca port properties");
}

void init_pd(void)
{
    if(VAPI_alloc_pd(hca, &pd))
        err_exit("Couldn't get pd");
}


#define QP_CQ_SIZE  0x20
int ib_qp_alloc_init(VAPI_hca_hndl_t hca, IB_port_t port, QP_HANDLE_t * handle_p)
{
    //VAPI_ret_t            ib_status;
    VAPI_qp_init_attr_t   qp_init_attr;
    VAPI_qp_prop_t        qp_prop;
    
    VAPI_qp_attr_t        qp_attr = { 0 };
    VAPI_qp_attr_mask_t   qp_attr_mask = 0;
    VAPI_qp_cap_t         qp_cap;

    VAPI_qp_hndl_t        qp = 0;
    VAPI_cq_hndl_t        cq_recv = 0;
    VAPI_cq_hndl_t        cq_send = 0;

    int cq_sz;

    if(VAPI_create_cq(hca, QP_CQ_SIZE, &cq_recv, &cq_sz))
        goto qp_alloc_out;

    if(VAPI_create_cq(hca, QP_CQ_SIZE, &cq_send, &cq_sz))
        goto qp_alloc_out; 

    qp_init_attr.cap.max_inline_data_sq    = 0;
    qp_init_attr.cap.max_oust_wr_sq        = 0x10;
    qp_init_attr.cap.max_oust_wr_rq        = 0x10;
    qp_init_attr.cap.max_sg_size_sq        = 0x10;
    qp_init_attr.cap.max_sg_size_rq        = 0x10;
    qp_init_attr.pd_hndl                   = pd;
    qp_init_attr.rdd_hndl                  = 0;
    qp_init_attr.rq_cq_hndl                = cq_recv;
    qp_init_attr.rq_sig_type               = VAPI_SIGNAL_ALL_WR;
    qp_init_attr.sq_cq_hndl                = cq_send;
    qp_init_attr.sq_sig_type               = VAPI_SIGNAL_REQ_WR;
    qp_init_attr.ts_type                   = VAPI_TS_RC;

    if(VAPI_create_qp(hca, &qp_init_attr, &qp, &qp_prop))
        goto qp_alloc_out;

    qp_attr.qp_state = VAPI_INIT;  
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_QP_STATE);

    qp_attr.remote_atomic_flags = VAPI_EN_REM_WRITE |  VAPI_EN_REM_READ;
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_REMOTE_ATOMIC_FLAGS);

    qp_attr.pkey_ix = 0;
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_PKEY_IX);

    qp_attr.port = port;

    
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_PORT);

    if(VAPI_modify_qp(hca, qp, &qp_attr, &qp_attr_mask, &qp_cap))
        return(-1);

    handle_p->qp = qp;

    handle_p->qpn = qp_prop.qp_num;

    handle_p->rcq = cq_recv;

    handle_p->scq = cq_send;

    return 0;


qp_alloc_out:
    if(qp)
        VAPI_destroy_qp(hca, qp);

    if(cq_recv)
        VAPI_destroy_cq(hca, cq_recv);

    if(cq_send)
        VAPI_destroy_cq(hca, cq_send);

    return(-1);
}


int qp_state_to_err(QP_HANDLE_t * handle_p)
{
    VAPI_qp_cap_t        qp_cap;
    VAPI_qp_attr_t       qp_attr = { 0 };      
    VAPI_qp_attr_mask_t  qp_attr_mask = 0; 
    
    qp_attr.qp_state = VAPI_ERR; 
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_QP_STATE);

    if(VAPI_modify_qp(hca, handle_p->qp, &qp_attr, &qp_attr_mask, &qp_cap)){

        debug("couldn't change qp state to error");

        exit(-1);
    }

    return 0;
}


int reset_qp_state(QP_HANDLE_t * handle_p)
{
    VAPI_qp_cap_t        qp_cap;
    VAPI_qp_attr_t       qp_attr = { 0 };      
    VAPI_qp_attr_mask_t  qp_attr_mask = 0; 
    VAPI_qp_init_attr_t  qp_init_attr; 
    VAPI_ret_t ret;

    qp_attr.qp_state = VAPI_RESET; 
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_QP_STATE);

    if(VAPI_modify_qp(hca, handle_p->qp, &qp_attr, &qp_attr_mask, &qp_cap))
        exit(-1);

    VAPI_query_qp(hca, handle_p->qp, &qp_attr,
                   &qp_attr_mask, &qp_init_attr);

    qp_attr_mask = 0;  

    qp_attr.qp_state = VAPI_INIT;
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_QP_STATE);

    qp_attr.remote_atomic_flags = VAPI_EN_REM_WRITE |  VAPI_EN_REM_READ;
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_REMOTE_ATOMIC_FLAGS);

    qp_attr.pkey_ix = 0;
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_PKEY_IX);

    qp_attr.port = HCA_PORT;
    
    QP_ATTR_MASK_SET (qp_attr_mask, QP_ATTR_PORT);

    ret = VAPI_modify_qp(hca, handle_p->qp, &qp_attr, &qp_attr_mask, &qp_cap);

    if(ret) {

        printf("ret = %d\n", ret);

        exit(-1);
    }
}


void ib_qp_dealloc(VAPI_hca_hndl_t hca,QP_HANDLE_t * handle_p)
{
    if(handle_p->qp)
        VAPI_destroy_qp(hca, handle_p->qp);

    if(handle_p->rcq)
        VAPI_destroy_cq(hca, handle_p->rcq);

    if(handle_p->scq)
        VAPI_destroy_cq(hca, handle_p->scq);
}


void qp_cleanup(QUEUE_t * q)
{
    QP_HANDLE_t * hndl_p;

    if (q == NULL)
        err_exit("Bad arg");

    while (!deQ_qp(q, &hndl_p)) 
    { 
        ib_qp_dealloc(hca, hndl_p);
    }

}


int init_qp_pool(QUEUE_t * q, QP_HANDLE_t *qp_hndl_arr) 
{
    int i;

    for (i = 0; i < q->size ; i++)
    {
        if (ib_qp_alloc_init(hca, HCA_PORT, &qp_hndl_arr[i]))
        {
            err_exit("Couldn't allocate all QPs, cleaning up");

            goto cleanup;
        }

        enQ_qp(q, &qp_hndl_arr[i]);
    }

    return 0;

        cleanup:

    qp_cleanup(q);
    
    return -1;

}



