#include <cm_test.h>

cmtest_context_t cm_test_ctx = { 0 };

QP_HANDLE_t         qp_hndl_arr[NUM_QP];   //Holds the data

QUEUE_t q;

LISTEN_INFO_t     * listen_array;

int listen_inx = 0;

VAPI_hca_hndl_t hca;

char * hca_name;

VAPI_hca_port_t hca_port;

IB_gid_t gid;

VAPI_pd_hndl_t        pd = 0;

int srv_conn_cnt;

extern char ** cm_event_table;

extern char ** conn_state_str;

TEST_FLOW_t test_table[] = TEST_TABLE;

int listen_callback(tTS_IB_U_QP_HANDLE   consumer_qp,
                     tTS_IB_CM_COMM_ID    comm_id,
                     tTS_IB_CM_EVENT      event,
                     void                *params,
                     void                *arg)
{
    int ret = 0;
    LISTEN_INFO_t * listen_p = arg;

    struct ib_u_cm_req_received_param * req_param = params;

    TEST_PRIV_DATA_t *priv_data = req_param->remote_private_data;

    TEST_TYPE_enum test_type = priv_data->test_type;

    tTS_IB_U_CM_COMPLETION_FUNC callbck_func = test_table[test_type].serv_func;

    debug("event %s received, cid 0x%x", cm_event_table[event], comm_id);


    callbck_func(consumer_qp, comm_id,
                 event, params, listen_p);

    // switch (test_type)
    // {
    // case TEST_TYPE_1:   
    // 
    //     test_1_listen_code
    //     break;
    // 
    // default:
    // 
    //     err_exit("Test not implemented yet");
    // }

    return ret;
}



int open_listens(TEST_OPT_t test_opt) 
{   
    int i, sid,status;

    for (sid = test_opt.start_sid ; sid  <= test_opt.end_sid ; sid++)
    {
        i = listen_inx;

        listen_array[i].sid = sid;

        status = tsIbUCmListen(listen_array[i].sid, 
                               TS_IB_CM_SERVICE_EXACT_MASK, 
                               listen_callback,
                               &listen_array[i], 
                               &listen_array[i].srv);
        if (status)
        {
            goto err_exit;
        }

        listen_inx++;
    }


    return 0;

    err_exit:
        
    while (listen_inx > 0 )
    {
        listen_inx --;

        tsIbUCmListenStop(listen_array[listen_inx].srv);
    }

    return status;
}



inline void usage(const char *prog_name)
{
	printf("Usage: %s [-h <hca name>] -s <start Service ID>  [-e <end Service ID>] \n", prog_name);
}

int get_test_opt(int argc, char *argv[], TEST_OPT_t * test_opt)
{
	int c, num_listen;

    char *start_sid_string = NULL;
	char *end_sid_string = NULL;
    char *tmp;

    hca_name = HCA_NAME;
    
	while ( (c= getopt(argc, argv, "h:s:e:")) != -1) {
		switch (c) {
        case 'h':
            hca_name = optarg;
            break;
		case 's': 
			start_sid_string = optarg;
			break;
		case 'e':
			end_sid_string = optarg;
			break;
        case ':': /* missing param. */
		case '?': /* Unknown option */
		default:
			usage(argv[0]);
            return -1;
		}
	}

    if(start_sid_string)
    {
        test_opt->start_sid = strtoll(start_sid_string, &tmp, 0);

        //if (tmp) goto err_exit;
    }
    else
        goto err_exit;


    if(end_sid_string)
    {
        test_opt->end_sid = strtoll(end_sid_string, &tmp, 0);

        //if (*tmp != '\o')  goto err_exit;
    }
    else
    {
        test_opt->end_sid = test_opt->start_sid;    
    }

    if (test_opt->start_sid > test_opt->end_sid)
    {
        goto err_exit;
    }

    num_listen = test_opt->end_sid - test_opt->start_sid +1;

    listen_array = malloc(sizeof(LISTEN_INFO_t) * num_listen);
    
    return 0;


    err_exit:

    usage(argv[0]);

    return -1;

}



int main(int argc, char *argv[])
{
	TEST_OPT_t test_opt;

    srv_conn_cnt = 0;
    
    if (get_test_opt(argc, argv, &test_opt) != 0)  exit(-1);

    init_hca();

    init_pd();

    init_qp_queue(&q, NUM_QP);

    if (init_qp_pool(&q, qp_hndl_arr))
    {
        VAPI_dealloc_pd(hca, pd);

        exit(-1);
    }

    if (open_listens(test_opt))
    {
        error("Couldn't open listen, cleaning up");

        qp_cleanup(&q);

        VAPI_dealloc_pd(hca, pd);

        exit(-1);
    }

    
    
     // for (int sid = test_opt.start_sid ; sid  <= test_opt.end_sid ; sid++)
     // {
     //     if (deQ_qp(&qp_hndl_p))
     //     exit(-1);
     // 
     //     if (ib_connect(hca, gid, hca_port.lid, 
     //                    qp_hndl_p->qp, 
     //                    qp_hndl_p->qpn   , 
     //                    sid))
     //         exit(-1);
     // }

    while (1)
    {
        sleep(10000000);
    }
    

    
    return 0;

}
