/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 *
 * HEADER: dat_init.h
 *
 * PURPOSE: DAT registry global data
 *
 * $Id: dat_init.h,v 1.14 2005/02/11 20:17:02 jlentini Exp $
 **********************************************************************/

#ifndef _DAT_INIT_H_
#define _DAT_INIT_H_

#include "dat_osd.h"

/*********************************************************************
 *                                                                   *
 * Enumerations                                                      *
 *                                                                   *
 *********************************************************************/

typedef enum
{
    DAT_MODULE_STATE_UNINITIALIZED,
    DAT_MODULE_STATE_INITIALIZING,
    DAT_MODULE_STATE_INITIALIZED,
    DAT_MODULE_STATE_DEINITIALIZING,
    DAT_MODULE_STATE_DEINITIALIZED
} DAT_MODULE_STATE;

/*********************************************************************
 *                                                                   *
 * Function Prototypes                                               *
 *                                                                   *
 *********************************************************************/

DAT_MODULE_STATE
dat_module_get_state ( void ) ;

void
dat_init ( void ) __attribute__ ((constructor));

void
dat_fini ( void ) __attribute__ ((destructor));

extern DAT_RETURN 
dats_handle_vector_init ( void );

extern void 
dats_handle_vector_free(void);

extern unsigned long
dats_set_ia_handle (
	IN  DAT_IA_HANDLE		ia_handle);

extern DAT_RETURN 
dats_get_ia_handle(
	IN	unsigned long		handle,
	OUT	DAT_IA_HANDLE		*ia_handle_p);

extern DAT_BOOLEAN
dats_is_ia_handle (
	IN  DAT_HANDLE          	dat_handle);

extern DAT_RETURN 
dats_free_ia_handle(
	IN	unsigned long		handle);

#endif
