/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dapl_cno_util.h
 *
 * PURPOSE: Utility defs & routines for the cno data structure
 *
 * $Id: dapl_cno_util.h,v 1.2 2004/08/02 15:14:26 rabin Exp $
 *
 **********************************************************************/

#ifndef _DAPL_CNO_UTIL_H_
#define _DAPL_CNO_UTIL_H_

#include "dapl.h"

#if defined(__KDAPL__)
DAPL_CNO *
dapl_cno_alloc (
    IN DAPL_IA				*ia_ptr,
    IN const DAT_UPCALL_OBJECT		*upcall) ;
#else
DAPL_CNO *
dapl_cno_alloc (
    IN DAPL_IA				*ia_ptr,
    IN DAT_OS_WAIT_PROXY_AGENT		wait_agent) ;
#endif	/* defined(__KDAPL__) */

void
dapl_cno_dealloc (
    IN DAPL_CNO *cno_ptr) ;

void
dapl_cno_trigger(
    IN DAPL_CNO		*cno_ptr,
    IN DAPL_EVD		*evd_ptr);

#endif
