/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dapl_cookie.h
 *
 * PURPOSE: Utility defs & routines for the cookie data structure
 *
 * $Id: dapl_cookie.h,v 1.2 2004/08/02 15:14:26 rabin Exp $
 *
 **********************************************************************/

#ifndef _DAPL_COOKIE_H
#define _DAPL_COOKIE_H_

#include "dapl.h"

extern DAT_RETURN 
dapls_cb_create (
    DAPL_COOKIE_BUFFER		*buffer,
    DAPL_EP			*ep,
    DAT_COUNT			size );

extern void 
dapls_cb_free (
    DAPL_COOKIE_BUFFER		*buffer );

extern DAT_RETURN
dapls_rmr_cookie_alloc (
    IN  DAPL_COOKIE_BUFFER	*buffer,
    IN 	DAPL_RMR		*rmr,
    IN 	DAT_RMR_COOKIE          user_cookie,
    OUT DAPL_COOKIE 		**cookie_ptr );

extern DAT_RETURN
dapls_dto_cookie_alloc (
    IN  DAPL_COOKIE_BUFFER	*buffer,
    IN  DAPL_DTO_TYPE		type,
    IN 	DAT_DTO_COOKIE	   	user_cookie,
    OUT DAPL_COOKIE 		**cookie_ptr );

extern void
dapls_cookie_dealloc (
    IN  DAPL_COOKIE_BUFFER	*buffer,
    IN 	DAPL_COOKIE		*cookie );

#endif /* _DAPL_COOKIE_H_ */
