/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dapl_name_service.h
 *
 * PURPOSE: Utility defs & routines supporting name services
 *
 * $Id: dapl_name_service.h,v 1.3 2004/08/02 15:14:27 rabin Exp $
 *
 **********************************************************************/

#include "dapl.h"

/*
 * Prototypes for name service routines
 */

DAT_RETURN dapls_ns_init (void);

#ifdef IBHOSTS_NAMING
DAT_RETURN dapls_ns_lookup_address (
	IN  DAPL_IA		*ia_ptr,
	IN  DAT_IA_ADDRESS_PTR	remote_ia_address,
	OUT ib_gid_t		*gid);
#else

/* routine is a no op if not using local name services */
#define dapls_ns_lookup_address(ia,ria,gid) DAT_SUCCESS

#endif
