/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dapl_ring_buffer_util.h
 *
 * PURPOSE: Utility defs & routines for the ring buffer data structure
 *
 * $Id: dapl_ring_buffer_util.h,v 1.2 2004/08/02 15:14:27 rabin Exp $
 *
 **********************************************************************/

#ifndef _DAPL_RING_BUFFER_H_
#define _DAPL_RING_BUFFER_H_

#include "dapl.h"

/*
 * Prototypes
 */
DAT_RETURN dapls_rbuf_alloc (
        DAPL_RING_BUFFER		*rbuf,
	DAT_COUNT			 size );

DAT_RETURN dapls_rbuf_realloc (
        DAPL_RING_BUFFER		*rbuf,
	DAT_COUNT			 size );

void dapls_rbuf_destroy (
	DAPL_RING_BUFFER		*rbuf);

DAT_RETURN dapls_rbuf_add (
	DAPL_RING_BUFFER		*rbuf,
	void				*entry);

void * dapls_rbuf_remove (
	DAPL_RING_BUFFER		*rbuf);

DAT_COUNT dapls_rbuf_count (
	DAPL_RING_BUFFER		*rbuf );

//DAT_BOOLEAN dapls_rbuf_contains (
//	IN  DAPL_RING_BUFFER		*rbuf,
//	IN  void			*entry);

DAT_BOOLEAN
dapls_rbuf_contains (
	IN  DAPL_RING_BUFFER	*rbuf,
	IN  void		*entry,
    IN  void		*old_entry);


/*
 * Simple functions
 */
#define dapls_rbuf_empty(rbuf)	(rbuf->head == rbuf->tail)


#endif /* _DAPL_RING_BUFFER_H_ */
