/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dapl_srq_util.h
 *
 * PURPOSE: Utility defs & routines for the SRQ data structure
 *
 * $Id: dapl_srq_util.h,v 1.1 2004/10/12 17:41:00 sjs2 Exp $
 *
 **********************************************************************/

#ifndef _DAPL_SRQ_UTIL_H_
#define _DAPL_SRQ_UTIL_H_

#include "dapl.h"

/* function prototypes */

extern DAPL_SRQ * 
dapl_srq_alloc (
    IN DAPL_IA			*ia,
    IN const DAT_SRQ_ATTR	*srq_attr );

extern void 
dapl_srq_dealloc (
    IN DAPL_SRQ			*srq_ptr );

#endif /*  _DAPL_SRQ_UTIL_H_ */
