/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dapl_dummy_dto.h
 *
 * PURPOSE: 
 *	This files is useful for porting and understanding the provider
 *	interface. DAPL is designed to accomodate multiple transport
 *	providers and currently supports InfiniBand, Myrinet, iWarp,
 *	MPI, and others.
 *
 *	This file contains the post operations required to support
 *	DAPL. Typically, data must be copied from generic DAPL
 *	structures to transport specific scatter/gather lists, and the
 *	transport library invoked to ring the DTO doorbell (or otherwise
 *	initiate the I/O).
 *
 * $Id: dapl_dummy_dto.h,v 1.1 2004/08/03 06:01:01 rabin Exp $
 *
 **********************************************************************/
#ifndef _DAPL_DUMMY_DTO_H
#define _DAPL_DUMMY_DTO_H

#include "dapl_dummy_util.h"


STATIC _INLINE_ DAT_RETURN 
dapls_ib_post_recv (
	IN  DAPL_EP		   	*ep_ptr,
	IN  DAPL_COOKIE			*cookie,
	IN  DAT_COUNT	   		num_segments,
	IN  DAT_LMR_TRIPLET	   	*local_iov)
{
	return DAT_SUCCESS;
}

STATIC _INLINE_ DAT_RETURN 
dapls_ib_post_send (
	IN  DAPL_EP		   	*ep_ptr,
	IN  int				op_type,
	IN  DAPL_COOKIE			*cookie,
	IN  DAT_COUNT	   		num_segments,
	IN  DAT_LMR_TRIPLET	   	*local_iov,
	IN  const DAT_RMR_TRIPLET	*remote_iov,
	IN  DAT_COMPLETION_FLAGS	completion_flags)
{
	return DAT_SUCCESS;
}

#define DAPL_GET_CQE_WRID(cqe_p)	0
#define DAPL_GET_CQE_OPTYPE(cqe_p)	0
#define DAPL_GET_CQE_BYTESNUM(cqe_p)	0
#define DAPL_GET_CQE_STATUS(cqe_p)	0


#endif /* _DAPL_DUMMY_DTO_H */
