/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * MODULE: dapl_dummy_util.c
 *
 * PURPOSE: 
 *	This files is useful for porting and understanding the provider
 *	interface. DAPL is designed to accomodate multiple transport
 *	providers and currently supports InfiniBand, Myrinet, iWarp,
 *	MPI, and others.
 *
 *	This file contains a trivial implementation of the provider API,
 *	defined in common/dapl_adapter.h. Each of these functions must
 *	be implemented for a specific transport to complete a port.
 *
 * $Id: dapl_dummy_util.c,v 1.1 2004/08/03 06:01:01 rabin Exp $
 *
 **********************************************************************/

#include "dapl.h"
#include "dapl_adapter_util.h"
#include "dapl_evd_util.h"
#include "dapl_cr_util.h"
#include "dapl_lmr_util.h"
#include "dapl_rmr_util.h"
#include "dapl_cookie.h"
#include "dapl_vendor.h"


int dapls_ib_init (void)
{
	return 0;
}

int dapls_ib_release (void)
{
    return 0;
}


DAT_RETURN dapls_ib_enum_hcas (
	OUT  DAPL_HCA_NAME		**hca_names,
	OUT  DAT_COUNT			*total_hca_count,
	IN   const char                 *vendor )
{
	return DAT_SUCCESS;
}

DAT_RETURN dapls_ib_open_hca (
	IN   char   	               *name,
	IN   DAPL_HCA		       *hca_ptr)
{
	return DAT_SUCCESS;
}

DAT_RETURN dapls_ib_close_hca (
	IN   DAPL_HCA		       *hca_ptr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_qp_alloc (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EP			*ep_ptr,
	IN  DAPL_EP			*ep_ctx_ptr )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_qp_free (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EP			*ep_ptr )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_qp_modify (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EP			*ep_ptr,
	IN  DAT_EP_ATTR			*ep_attr )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_connect (
	IN  DAT_EP_HANDLE		ep_handle,
	IN  DAT_IA_ADDRESS_PTR		remote_ia_address,
	IN  DAT_CONN_QUAL		remote_conn_qual,
	IN	DAT_COUNT		prd_size,
	IN	DAPL_PRIVATE		*prd_ptr )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_disconnect (
	IN	DAPL_EP			*ep_ptr,
	IN	DAT_CLOSE_FLAGS		close_flags )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_setup_conn_listener (
	IN  DAPL_IA			*ia_ptr,
	IN  DAT_UINT64			ServiceID,
	IN  DAPL_SP			*sp_ptr )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_remove_conn_listener (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_SP			*sp_ptr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_accept_connection (
	IN  DAT_CR_HANDLE		cr_handle,
	IN  DAT_EP_HANDLE		ep_handle,
	IN  DAT_COUNT			private_data_size,
	IN  const DAT_PVOID		private_data )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_reject_connection (
	IN  ib_cm_handle_t		cm_handle,
	IN  int				reject_reason )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_setup_async_callback (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_ASYNC_HANDLER_TYPE	handler_type,
	IN  unsigned int *		callback_handle,
	IN  ib_async_handler_t		callback,
	IN  void			*context )
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_cq_alloc (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EVD			*evd_ptr,
	IN  DAT_COUNT			*cqlen)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_cq_free (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EVD			*evd_ptr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_set_cq_notify (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EVD			*evd_ptr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_cq_resize (
	IN  DAPL_IA			*ia_ptr,
	IN  DAPL_EVD			*evd_ptr,
	IN  DAT_COUNT			*cqlen)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_pd_alloc (
	IN  DAPL_IA 			*ia_ptr,
	IN  DAPL_PZ 			*pz)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_pd_free (
	IN  DAPL_PZ	 		*pz)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_mr_register (
	IN  DAPL_IA 			*ia_ptr,
        IN  DAPL_LMR			*lmr,
	IN  DAT_PVOID			virt_addr,
	IN  DAT_VLEN			length,
	IN  DAT_MEM_PRIV_FLAGS		privileges)
{
	return DAT_SUCCESS;
}


#if defined(__KDAPL__)
DAT_RETURN dapls_ib_mr_register_physical (
	IN  DAPL_IA	 		*ia_ptr,
	IN  DAPL_LMR			*lmr,
	IN  DAT_VADDR  			phys_addr,
	IN  DAT_VLEN	   		length,
	IN  DAT_MEM_PRIV_FLAGS		privileges)
{
	return DAT_SUCCESS;
}

#endif /* __KDAPL__ */

DAT_RETURN dapls_ib_mr_deregister (
	IN  DAPL_LMR			*lmr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_mr_register_shared (
	IN  DAPL_IA 			*ia_ptr,
        IN  DAPL_LMR			*lmr,
	IN  DAT_MEM_PRIV_FLAGS		privileges)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_mw_alloc (
	IN  DAPL_RMR 			*rmr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_mw_free (
     IN  DAPL_RMR			*rmr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_mw_bind (
	IN  DAPL_RMR			*rmr,
	IN  DAPL_LMR			*lmr,
	IN  DAPL_EP			*ep,
	IN  DAPL_COOKIE			*cookie,
	IN  DAT_VADDR			virtual_address,
	IN  DAT_VLEN			length,
	IN  DAT_MEM_PRIV_FLAGS		mem_priv,
	IN  ib_bool_t			is_signaled)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_mw_unbind (
	IN  DAPL_RMR			*rmr,
	IN  DAPL_EP			*ep,
	IN  DAPL_COOKIE			*cookie,
	IN  ib_bool_t			is_signaled)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_query_hca (
	IN  DAPL_HCA			*hca_ptr,
	OUT DAT_IA_ATTR	   		*ia_attr,
	OUT DAT_EP_ATTR			*ep_attr,
	OUT DAT_SOCK_ADDR6		*ip_addr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_completion_poll (
	IN  DAPL_HCA			*hca_ptr,
	IN  ib_cq_handle_t		cq_handle,
	IN  ib_work_completion_t	*cqe_ptr)
{
	return DAT_SUCCESS;
}


DAT_RETURN dapls_ib_completion_notify (
	IN  ib_hca_handle_t		hca_handle,
	IN  ib_cq_handle_t		cq_handle,
	IN  ib_notification_type_t	type)
{
	return DAT_SUCCESS;
}


DAT_DTO_COMPLETION_STATUS dapls_ib_get_dto_status(
	IN ib_work_completion_t		*cqe_ptr)
{
	return DAT_DTO_SUCCESS;
}


void dapls_ib_reinit_ep (
	IN  DAPL_EP			*ep_ptr)
{
	return;
}


void dapls_ib_disconnect_clean (
	IN  DAPL_EP			*ep_ptr,
	IN  DAT_BOOLEAN			passive,
	IN  const ib_cm_events_t	ib_cm_event )
{
	return;
}


DAT_RETURN dapls_ib_get_async_event (
	IN  ib_error_record_t		*cause_ptr,
	OUT DAT_EVENT_NUMBER		*async_event)
{
	return DAT_SUCCESS;
}


DAT_EVENT_NUMBER dapls_ib_get_dat_event (
	IN    const ib_cm_events_t	ib_cm_event,
	IN    DAT_BOOLEAN		active)
{
	return DAT_DTO_COMPLETION_EVENT;
}


ib_cm_events_t dapls_ib_get_cm_event (
	IN    DAT_EVENT_NUMBER		dat_event_num)
{
	return DAT_DTO_COMPLETION_EVENT;
}


DAT_RETURN dapls_ib_cm_remote_addr (
	IN      DAT_HANDLE		dat_handle,
	OUT	DAT_SOCK_ADDR6		*remote_ia_address )
{
	return DAT_SUCCESS;
}


int dapls_ib_private_data_size (
	IN      DAPL_PRIVATE		*prd_ptr,
	IN	DAPL_PDATA_OP		conn_op)
{
	return 0;
}
