/*************************************************************************
*   Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.  *
*   Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

*************************************************************************/

#ifndef _IB_CM_VAPI_H_
#define _IB_CM_VAPI_H_

//#include "dapl_openib.h"
#include "ts_ib_useraccess_cm.h"	/* ioctl API to kernel */


int ib_cm_vapi_disconnect(tTS_IB_CM_COMM_ID comm_id );

int ib_cm_vapi_confirm(tTS_IB_CM_COMM_ID comm_id,
                       void             *rtu_private_data,
                       int               rtu_private_data_len);


int ib_cm_vapi_kill(tTS_IB_CM_COMM_ID comm_id);

int ib_cm_vapi_establish(tTS_IB_CM_COMM_ID comm_id,
                         int               immediate); 

int ib_cm_vapi_listen_stop(tTS_IB_LISTEN_HANDLE listen_handle);

    
int ib_cm_vapi_listen(tTS_IB_SERVICE_ID           service_id,
                      tTS_IB_SERVICE_ID           service_mask,
                      tTS_IB_U_CM_COMPLETION_FUNC         function,
                      void                       *arg,
                      tTS_IB_LISTEN_HANDLE       *listen_handle);



int  ib_cm_vapi_connect (VAPI_hca_hndl_t                hca_handle,
                         void                           *pd,
                         tTS_IB_U_QP_HANDLE             vqp_handle,
                         __u32                          qpn,
                         struct ib_cm_active_param  *param,
                         struct ib_path_record      *primary_path,
                         struct ib_path_record      *alternate_path,
                         tTS_IB_SERVICE_ID           service_id,
                         int                         peer_to_peer,
                         tTS_IB_U_CM_COMPLETION_FUNC         function,
                         void                       *arg,
                         tTS_IB_CM_COMM_ID          *comm_id);


int ib_cm_vapi_reject(tTS_IB_CM_COMM_ID comm_id,
                      void             *rej_private_data,
                      int               rej_private_data_len);

int ib_cm_vapi_accept(VAPI_hca_hndl_t                hca_handle,
                      void                           *pd,
                      tTS_IB_U_QP_HANDLE             vqp_handle,
                      __u32                          qpn,
                      tTS_IB_U_CM_COMPLETION_FUNC            function,
                      void                          *comp_arg,
                      tTS_IB_CM_COMM_ID              comm_id,
                      struct ib_cm_passive_param    *param);

tTS_IB_SERVICE_ID ib_cm_vapi_service_assign(void);

 
#endif /* _IB_CM_VAPI_H_  */



