/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.
 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

#ifndef __DAPL_FFT_CMD_H__
#define __DAPL_FFT_CMD_H__

#include "dapl_proto.h"

#define MAXCASES	100

typedef enum
{
    NONE,
    HWCONN,
    CQMGT,
    ENDPOINT,
    PTAGMGT,
    MEMMGT,
    CONNMGT,
    CONNMGT_CLIENT,
    DATAXFER,
    DATAXFER_CLIENT,
    QUERYINFO,
    NS,
    ERRHAND,
    UNSUPP,
    STRESS,
    STRESS_CLIENT,
} FFT_Type_e;


typedef struct
{
    FFT_Type_e		fft_type;
    char 		device_name[256];	//-D
    char		server_name[256];
    bool		cases_flag[MAXCASES];
    int 		size;
    int 		num_iter;	//-i
    int 		num_threads;	//-t
    int 		num_vis;	//-v
    DAT_QOS		ReliabilityLevel;	//-R
    DAT_MEM_TYPE    DT_mem_type; /* -M */ 
} FFT_Cmd_t;

/*
   typedef struct
   {
   Mdep_LockType       Thread_counter_lock;
   int                 Thread_counter;

   Mdep_LockType       Thread_success_lock;
   int                 Thread_success_counter;
   } Stress_glob_t;

   typedef struct
   {
   Stress_glob_t  	*glob;
   Thread              *thread_ptr;
   FFT_Cmd_t           *cmd;
   int                 flag;
   unsigned int        discriminator;
   bool                is_server;
   } Stress_arg_t;


   typedef struct
   {
   VIP_VI_HANDLE	vi_handle;
   Bpool		*bp;
   VIP_DESCRIPTOR	*recv_desc;
   } Stress_vi_context_t;
 */

//#pragma pack (2)
//typedef struct
//{
//    char        server_name[256];   /* -s */
//    char        device_name[256];   /* -D */
//    DAT_UINT32  debug;              /* -d */
//    DAT_QOS     ReliabilityLevel;   /* -R */
//} Quit_Cmd_t;
//#pragma pack ()


#endif
