/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.
 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

#ifndef __DAPL_TRANSACTION_STATS_H__
#define __DAPL_TRANSACTION_STATS_H__

#include "dapl_proto.h"

#define whole(num)       ((unsigned int)(num))
#define hundredths(num)  ((unsigned int)(((num) - (unsigned int)(num)) * 100))

typedef struct
{
    DT_Mdep_LockType	lock;
    unsigned int	wait_count;
    unsigned int	num_ops;
    unsigned int	time_ms;
    unsigned int	bytes_send;
    unsigned int	bytes_recv;
    unsigned int	bytes_rdma_read;
    unsigned int	bytes_rdma_write;
} Transaction_Stats_t;

typedef struct
{
    unsigned int	wait_count;
    unsigned int	num_ops;
    unsigned int	time_ms;
    unsigned int	bytes_send;
    unsigned int	bytes_recv;
    unsigned int	bytes_rdma_read;
    unsigned int	bytes_rdma_write;
} Transaction_Stats2_t;

#endif
