#!/bin/bash
#
# Sample regression client invocation
#
# replace # with the real number in the next lines
#            NO DEAFAULTS VALUES
# usag : ./Daplregress user #.#.#.# ib# netapp   // for netapp user regression
# usag : ./Daplregress user #.#.#.# ib# mlx      // for mlx user regression
# usag : ./Daplregress kernel #.#.#.# ib# netapp // for netapp kernel regression
# usag : ./Daplregress kernel #.#.#.# ib# netapp // for mlx kernel regression


me=`basename $0`
      
exe=$1
host=$2
device=$3 
testKind=$4

if [ $exe == "user" ]
then 
    exe_prog="dapltest"
else 
    exe_prog="kdapltest"
fi

if [ $testKind == "netapp" ]
then
#====================================================================
#client1
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 1 -w 1 \
	client SR 256 					   \
	server SR 256

#====================================================================
#client2
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 1 -w 1 \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256

#====================================================================
#client3
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 1 -w 1 \
	client SR 256 					   \
	server RR 4096 					   \
	server SR 256

#====================================================================
#client4
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 1 -w 1 \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256 					   \
	client SR 256 					   \
	server RR 4096 					   \
	server SR 256 					   \
	client SR 4096 					   \
	server SR 256
 
#====================================================================
#client5
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 1 -w 8 \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256 					   \
	client SR 256 					   \
	server RR 4096 					   \
	server SR 256 					   \
	client SR 4096 					   \
	server SR 256
 
#====================================================================
#client6
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 4 -w 8 \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256 					   \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256 					   \
	client SR 4096 					   \
	server SR 256


#====================================================================
# Quit the server
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T Q -s ${host} -D ${device} 

else
#====================================================================
#client1
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 1 -w 1 \
	client SR 256 -f					   \
	server SR 256 -f

#====================================================================
#client2
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 4 -w 8 \
        -V -P                                              \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256 					   \
	client SR 256 					   \
	server RR 4096 					   \
	server SR 256 					   \
	client SR 4096 					   \
	server SR 256

#====================================================================
#client3
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 4 -w 8 \
        -V                                                 \
	client SR 256 					   \
	server RW 4096 					   \
	server SR 256 					   \
	client SR 256 					   \
	server RR 4096 					   \
	server SR 256 					   \
	client SR 4096 					   \
	server SR 256

#====================================================================
#client4
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 4 -w 8 \
	client SR 256 2					   \
	server RW 4096 2				   \
	server SR 256 2					   \
	client SR 256 2					   \
	server RR 4096 2				   \
	server SR 256 2					   \
	client SR 4096 2				   \
	server SR 256 2
#====================================================================
#client5
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T T -s ${host} -D ${device} -i 10000 -t 4 -w 8 \
	client SR 256 4					   \
	server RW 4096 4				   \
	server SR 256 4					   \
	client SR 256 4					   \
	server RR 4096 4				   \
	server SR 256 4					   \
	client SR 4096 4				   \
	server SR 256 4
#====================================================================
#client6
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T P -s ${host} -D ${device} -i 1000 \
        -m p				           \
	RR 4096 4				   
#====================================================================
#client7
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T P -s ${host} -D ${device} -i 1000 \
        -m b				           \
	RR 4096 4
#====================================================================
#client8
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T P -s ${host} -D ${device} -i 1000 \
        -m p				           \
	RW 4096 4				   
#====================================================================
#client9
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T P -s ${host} -D ${device} -i 1000 \
        -m b				           \
	RW 4096 4
	
#====================================================================
# Quit the server
#====================================================================
/usr/local/ibgd/bin/${exe_prog} -T Q -s ${host} -D ${device} 

fi
