/*
 * Copyright (c) 2002-2003, Network Appliance, Inc. All rights reserved.
 * Copyright (c) 2005 Mellanox Technologies.   All rights reserved.

 *
 * This Software is licensed under both of the following two licenses:
 *
 * 1) under the terms of the "Common Public License 1.0" a copy of which is
 *    in the file LICENSE.txt in the root directory. The license is also
 *    available from the Open Source Initiative, see
 *    http://www.opensource.org/licenses/cpl.php.
 * OR
 *
 * 2) under the terms of the "The BSD License" a copy of which is in the file
 *    LICENSE2.txt in the root directory. The license is also available from
 *    the Open Source Initiative, see
 *    http://www.opensource.org/licenses/bsd-license.php.
 *
 * Licensee has the right to choose either one of the above two licenses.
 *
 * Redistributions of source code must retain both the above copyright
 * notice and either one of the license notices.
 *
 * Redistributions in binary form must reproduce both the above copyright
 * notice, either one of the license notices in the documentation
 * and/or other materials provided with the distribution.
 */

/**********************************************************************
 * 
 * HEADER: dat_sr_parser.h
 *
 * PURPOSE: static registry (SR) parser inteface declarations
 *
 * $Id: udat_sr_parser.h,v 1.2 2004/07/14 14:06:56 sjs2 Exp $
 **********************************************************************/

#ifndef _DAT_SR_PARSER_H_
#define _DAT_SR_PARSER_H_


#include "dat_osd.h"


/*********************************************************************
 *                                                                   *
 * Function Declarations                                             *
 *                                                                   *
 *********************************************************************/

/*
 * The static registry exports the same interface regardless of 
 * platform. The particular implementation of dat_sr_load() is 
 * found with other platform dependent sources.
 */

extern DAT_RETURN 
dat_sr_load (void);


#endif /* _DAT_SR_PARSER_H_ */
