/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Topspin Communications.  All rights reserved.

  $Id: ipoib_proto.h 428 2004-07-12 04:54:43Z roland $
*/

#ifndef _IPOIB_PROTO_H
#define _IPOIB_PROTO_H

#include <linux/netdevice.h>
#include <ib_legacy_types.h>
#include <ts_ib_core_types.h>

/* ------------------------------------------------------------------------- */
/* Public constants                                                          */
/* ------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------- */
/* Public functions                                                          */
/* ------------------------------------------------------------------------- */
int ipoib_get_gid(struct net_device *dev, uint8_t *hash, tTS_IB_GID gid);

int ipoib_device_handle(struct net_device *dev, struct ib_device **ca,
			tTS_IB_PORT *port, tTS_IB_GID gid, u16 *pkey);

#endif /* _IPOIB_PROTO_H */
