/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Topspin Communications.  All rights reserved.

  $Id: sdp_types.h 218 2004-06-02 22:02:33Z libor $
*/

#ifndef _TS_SDP_TYPES_H
#define _TS_SDP_TYPES_H
/*
 * defines
 */
#if 0
#define TS_EXPECT(mod, expr)                                      \
{                                                                 \
  if (!(expr)) {                                                  \
    TS_TRACE(mod, T_TERSE, TRACE_FLOW_WARN,                       \
             "EXCEPT: Internal error check <%s> failed.", #expr); \
  }                                                               \
} /* TS_EXPECT */

#define TS_CHECK_NULL(value, result) \
        if (NULL == (value)) return (result);
#define TS_CHECK_LT(value, bound, result) \
        if ((bound) > (value)) return(result);
#define TS_CHECK_GT(value, bound, result) \
        if ((bound) < (value)) return(result);
#define TS_CHECK_EQ(value, test, result) \
        if ((test) == (value)) return(result);
#define TS_CHECK_EXPR(expr, result) \
        if (!(expr)) return(result);
#else
#define TS_EXPECT(mod, expr)
#define TS_CHECK_NULL(value, result)
#define TS_CHECK_LT(value, bound, result)
#define TS_CHECK_GT(value, bound, result)
#define TS_CHECK_EQ(value, test, result)
#define TS_CHECK_EXPR(expr, result)
#endif

#endif /* _TS_SDP_TYPES_H */
