/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Topspin Communications.  All rights reserved.

  $Id: dm_client.h 479 2004-07-16 18:01:50Z roland $
*/

#ifndef _DM_CLIENT_H
#define _DM_CLIENT_H

#include "ts_ib_dm_client.h"
#include "ts_ib_mad_types.h"

enum {
	TS_IB_DM_CLASS_VERSION = 1
};

extern int use_port_info_tbl;

void ib_dm_client_mad_init(struct ib_mad *packet, struct ib_device *device,
			   tTS_IB_PORT port, u16 dst_lid, u32 dst_qpn,
			   u32 r_method, u16 attribute_id,
			   u32 attribute_modifier);

int ib_dm_client_query_init(void);

void ib_dm_client_query_cleanup(void);

void ib_dm_async_notify_handler(struct ib_mad *packet, void *arg);

#endif				/* _DM_CLIENT_H */
