/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_DM_CLIENT_PRIV_H
#define H_DM_CLIENT_PRIV_H

extern struct list_head  dm_outs_query_q;
extern spinlock_t        dm_outs_query_lock;     

struct ib_dm_query_hdr {
	tTS_IB_CLIENT_QUERY_TID transaction_id;
	struct list_head outs_query;
};

static inline void ib_dm_outs_query_remove(struct list_head *entry)
{
	unsigned long flags;

	spin_lock_irqsave(&dm_outs_query_lock,flags);
	list_del(entry);
	spin_unlock_irqrestore(&dm_outs_query_lock,flags);
}

static inline void ib_dm_outs_query_add(struct list_head *entry)
{
 	unsigned long flags;

	spin_lock_irqsave(&dm_outs_query_lock,flags);
	list_add(entry, &dm_outs_query_q);
	spin_unlock_irqrestore(&dm_outs_query_lock,flags);
}

#endif
