/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Topspin Communications.  All rights reserved.

  $Id: sa_client.h 477 2004-07-16 16:40:34Z roland $
*/

#ifndef _SA_CLIENT_H
#define _SA_CLIENT_H

#include "ts_ib_sa_client.h"
#include "ts_ib_mad_types.h"
#include "ts_ib_client_query.h"

enum {
	TS_IB_SA_CLASS_VERSION = 2
};

int tsIbSaNoticeHandlerRegister(s16 trap_num,
				struct ib_device *device,
				tTS_IB_PORT port,
				tTS_IB_SA_NOTICE_HANDLER_FUNC handler,
				void *arg);

tTS_IB_SA_NOTICE_HANDLER_FUNC tsIbSaNoticeHandlerGet(s16 trap_num,
						     struct ib_device *device,
						     tTS_IB_PORT port);

void *tsIbNoticeHandlerArgGet(s16 trap_num,
			      struct ib_device *device, tTS_IB_PORT port);

void tsIbSaNoticeHandler(struct ib_mad *mad, void *arg);

int tsIbSaNoticeInit(void
    );

void tsIbSaClientMadInit(struct ib_mad *packet,
			 struct ib_device *device, tTS_IB_PORT port);

int tsIbSaClientQueryInit(void
    );

void tsIbSaClientQueryCleanup(void
    );

#endif				/* _SA_CLIENT_H */
