#!/bin/bash
# Link Makefile.24|26 to Makefile 

if [ $# -lt 1 ]; then
  echo "Usage: $0 <kernel type:[24|26]>|clean"
  exit 1
fi

if [ $1 == clean ]; then
  echo Cleaning Makefile links:
  find . -name Makefile -type l -print -exec rm \{\} \;
  exit 0
fi

echo Linking Makefile.$1 to Makefile:
MKFILES=`find . -follow -name Makefile.$1 -print`
rootdir=`pwd`
for mkf in $MKFILES; do 
  echo $mkf
  cd `dirname $mkf` 
  ln -s Makefile.$1 Makefile
  cd $rootdir
done

