/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#include <hh.h>


/* pci driver private data */
struct hca_driver_data_st {
  char    dev_desc[MAX_HCA_DEVDESC_SIZE];     /* Device description (name, etc.) */
  struct msix_entry *vect_arr; /* pointer to allocated vector array */
  int num_irqs; /* total number of allocated vectors */
  int resource_requested[3];  /* which resources were requested */
  struct pci_dev *dev;
  int found_index;
#if LINUX_KERNEL_2_6
  struct class_device  class_dev;
#endif  
};


#define MT_PCI_DEV_FMT  "%d:%d.%d"
#define MT_PCI_DEV_ARGS(dev) (dev)->bus->number, ((dev)->devfn>>8)&0xf, (dev)->devfn&0xf


int vapi_device_register_sysfs(struct hca_driver_data_st *driver_data);
void vapi_device_unregister_sysfs(struct hca_driver_data_st *driver_data);
int vapi_sysfs_setup(void);
void vapi_sysfs_cleanup(void);


unsigned long XHH_show_hotplug_support(void);
void XHH_set_hotplug_support(unsigned long hotp);

