/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_ARBEL_IF_DEFS_H
#define H_ARBEL_IF_DEFS_H

/* TK: FW cannot guarantee commands completion timeout due to starvation with door-bells
   So we put the 1 minute hoping that the DBs will stop and the
   command will have time to complete */
#define ARBEL_IF_CMD_ETIME_CLASS_A				60000000 
#define ARBEL_IF_CMD_ETIME_CLASS_B				60000000 
#define ARBEL_IF_CMD_ETIME_CLASS_C				60000000 

/* macros to define the estimated time in microseconds to execute a command */
#define ARBEL_IF_CMD_ETIME_MAP_FA             ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_UNMAP_FA           ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_MAP_ICM_AUX        ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_UNMAP_ICM_AUX      ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_MAP_ICM            ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_UNMAP_ICM          ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_SET_ICM_SIZE       ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_QUERY_DEV_LIM      ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_QUERY_FW           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_RUN_FW             ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_ACCESS_LAM         ARBEL_IF_CMD_ETIME_UNKNOWN_LAT
#define ARBEL_IF_CMD_ETIME_ENABLE_LAM         ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_DISABLE_LAM        ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_QUERY_ADAPTER      ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_INIT_HCA           ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_CLOSE_HCA          ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_INIT_IB            ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_CLOSE_IB           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_QUERY_HCA          ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_SET_IB             ARBEL_IF_CMD_ETIME_CLASS_B
#define ARBEL_IF_CMD_ETIME_NOP                ARBEL_IF_CMD_ETIME_CLASS_B

#define ARBEL_IF_CMD_ETIME_SW2HW_MPT          ARBEL_IF_CMD_ETIME_CLASS_B
#define ARBEL_IF_CMD_ETIME_QUERY_MPT          ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_HW2SW_MPT          ARBEL_IF_CMD_ETIME_CLASS_B
#define ARBEL_IF_CMD_ETIME_READ_MTT           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_WRITE_MTT          ARBEL_IF_CMD_ETIME_CLASS_B
#define ARBEL_IF_CMD_ETIME_SYNC_TPT           ARBEL_IF_CMD_ETIME_CLASS_B

#define ARBEL_IF_CMD_ETIME_MAP_EQ             ARBEL_IF_CMD_ETIME_CLASS_B
#define ARBEL_IF_CMD_ETIME_SW2HW_EQ           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_HW2SW_EQ           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_QUERY_EQ           ARBEL_IF_CMD_ETIME_CLASS_A

#define ARBEL_IF_CMD_ETIME_SW2HW_CQ           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_HW2SW_CQ           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_QUERY_CQ           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_RESIZE_CQ          ARBEL_IF_CMD_ETIME_CLASS_A

#define ARBEL_IF_CMD_ETIME_RST2INIT_QPEE      ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_INIT2INIT_QPEE     ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_INIT2RTR_QPEE      ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_RTR2RTS_QPEE       ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_RTS2RTS_QPEE       ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_SQERR2RTS_QPEE     ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_2ERR_QPEE          ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_RTS2SQD            ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_SQD2RTS_QPEE       ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_ERR2RST_QPEE       ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_QUERY_QPEE         ARBEL_IF_CMD_ETIME_CLASS_C

#define ARBEL_IF_CMD_ETIME_CONF_SPECIAL_QP    ARBEL_IF_CMD_ETIME_CLASS_B
#define ARBEL_IF_CMD_ETIME_MAD_IFC            ARBEL_IF_CMD_ETIME_CLASS_C

#define ARBEL_IF_CMD_ETIME_READ_MGM           ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_WRITE_MGM          ARBEL_IF_CMD_ETIME_CLASS_A
#define ARBEL_IF_CMD_ETIME_MGID_HASH          ARBEL_IF_CMD_ETIME_CLASS_A

#define ARBEL_IF_CMD_ETIME_CONF_PM            ARBEL_IF_CMD_ETIME_CLASS_C

#define ARBEL_IF_CMD_ETIME_CONF_NTU           ARBEL_IF_CMD_ETIME_CLASS_C
#define ARBEL_IF_CMD_ETIME_QUERY_NTU          ARBEL_IF_CMD_ETIME_CLASS_C

#define ARBEL_IF_CMD_ETIME_DIAG_RPRT          ARBEL_IF_CMD_ETIME_UNKNOWN_LAT
#define ARBEL_IF_CMD_ETIME_QUERY_DEBUG_MSG    ARBEL_IF_CMD_ETIME_UNKNOWN_LAT
#define ARBEL_IF_CMD_ETIME_SET_DEBUG_MSG      ARBEL_IF_CMD_ETIME_UNKNOWN_LAT


//////////////////////// ADDED BY FW TEAM /////////////////////////
#define	ARBEL_IF_STRIDE_QPC_BIT 	8
#define	ARBEL_IF_STRIDE_EEC_BIT 	8
#define	ARBEL_IF_STRIDE_SRQC_BIT 	5
#define	ARBEL_IF_STRIDE_CQC_BIT	  6
#define	ARBEL_IF_STRIDE_EQC_BIT	  6
#define	ARBEL_IF_STRIDE_MPT_BIT   6
#define	ARBEL_IF_STRIDE_MTT_BIT		3
#define	ARBEL_IF_STRIDE_EQPC_BIT	5
#define	ARBEL_IF_STRIDE_EEEC_BIT	5
#define	ARBEL_IF_STRIDE_APM_BIT		5
#define	ARBEL_IF_STRIDE_MCST_BIT	5
#define	ARBEL_IF_STRIDE_UARSCR_BIT 5

#define ARBEL_IF_STRIDE_QPC (1<<ARBEL_IF_STRIDE_QPC_BIT)
#define ARBEL_IF_STRIDE_EEC (1<<ARBEL_IF_STRIDE_EEC_BIT)
#define ARBEL_IF_STRIDE_SRQC (1<<ARBEL_IF_STRIDE_SRQC_BIT)
#define ARBEL_IF_STRIDE_CQC (1<<ARBEL_IF_STRIDE_CQC_BIT)
#define ARBEL_IF_STRIDE_EQC (1<<ARBEL_IF_STRIDE_EQC_BIT)
#define ARBEL_IF_STRIDE_MPT (1<<ARBEL_IF_STRIDE_MPT_BIT)
#define ARBEL_IF_STRIDE_MTT (1<<ARBEL_IF_STRIDE_MTT_BIT)
#define ARBEL_IF_STRIDE_EQPC (1<<ARBEL_IF_STRIDE_EQPC_BIT)
#define ARBEL_IF_STRIDE_EEEC (1<<ARBEL_IF_STRIDE_EEEC_BIT)
#define ARBEL_IF_STRIDE_APM (1<<ARBEL_IF_STRIDE_APM_BIT)
#define ARBEL_IF_STRIDE_MCST (1<<ARBEL_IF_STRIDE_MCST_BIT)
#define ARBEL_IF_STRIDE_UARSCR (1<<ARBEL_IF_STRIDE_UARSCR_BIT)

#define ARBEL_IF_MPT_HW_STATUS_OFFSET        0
#define ARBEL_IF_MPT_HW_START_ADDR_OFFSET   16
#define ARBEL_IF_MPT_HW_LEN_OFFSET          24
#define ARBEL_IF_MPT_HW_MEMKEY_OFFSET        8
#define ARBEL_IF_MPT_HW_LKEY_OFFSET         32

/* this constant is the flag masked on to the opcode modifier in ARBEL_IF_CMD_RTS2SQD_QPEE
   in order to request SQD notification  */
#define ARBEL_IF_SQD_EVENT_FLAG		    0x80000000

////////////////////////     FW TEAM      /////////////////////////

typedef enum arbel_if_cmd {
  /* initialization and general commands */
  ARBEL_IF_CMD_MAP_FA = 0xFFF,
  ARBEL_IF_CMD_UNMAP_FA = 0xFFE,
  ARBEL_IF_CMD_RUN_FW = 0xFF6,
  ARBEL_IF_CMD_MOD_STAT_CFG = 0x34,
  ARBEL_IF_CMD_QUERY_DEV_LIM = 0x3,
  ARBEL_IF_CMD_QUERY_FW = 0x4,
  ARBEL_IF_CMD_ENABLE_LAM = 0xFF8,
  ARBEL_IF_CMD_DISABLE_LAM = 0xFF7,
  ARBEL_IF_CMD_ACCESS_LAM = 0x2E,
  ARBEL_IF_CMD_QUERY_ADAPTER = 0x6,
  ARBEL_IF_CMD_INIT_HCA = 0x7,
  ARBEL_IF_CMD_CLOSE_HCA = 0x8,
  ARBEL_IF_CMD_INIT_IB = 0x9,
  ARBEL_IF_CMD_CLOSE_IB = 0xa,
  ARBEL_IF_CMD_QUERY_HCA = 0xb,
  ARBEL_IF_CMD_SET_IB = 0xc,
  ARBEL_IF_CMD_MAP_ICM = 0xFFA,
  ARBEL_IF_CMD_UNMAP_ICM = 0xFF9,
  ARBEL_IF_CMD_MAP_ICM_AUX = 0xFFC,
  ARBEL_IF_CMD_UNMAP_ICM_AUX = 0xFFB,
  ARBEL_IF_CMD_SET_ICM_SIZE = 0xFFD,

  /* TPT commands */
  ARBEL_IF_CMD_SW2HW_MPT = 0xd,
  ARBEL_IF_CMD_QUERY_MPT = 0xe,
  ARBEL_IF_CMD_HW2SW_MPT = 0xf,
  ARBEL_IF_CMD_MODIFY_MPT = 0x39,
  ARBEL_IF_CMD_READ_MTT = 0x10,
  ARBEL_IF_CMD_WRITE_MTT = 0x11,
  ARBEL_IF_CMD_SYNC_TPT = 0x2f,

  /* EQ commands */
  ARBEL_IF_CMD_MAP_EQ = 0x12,
  ARBEL_IF_CMD_SW2HW_EQ = 0x13,
  ARBEL_IF_CMD_HW2SW_EQ = 0x14,
  ARBEL_IF_CMD_QUERY_EQ = 0x15,

  /* CQ commands */
  ARBEL_IF_CMD_SW2HW_CQ = 0x16,
  ARBEL_IF_CMD_HW2SW_CQ = 0x17,
  ARBEL_IF_CMD_QUERY_CQ = 0x18,
  ARBEL_IF_CMD_RESIZE_CQ= 0x2c,

  /* SRQ commands */
  ARBEL_IF_CMD_SW2HW_SRQ = 0x35,
  ARBEL_IF_CMD_HW2SW_SRQ = 0x36,
  ARBEL_IF_CMD_QUERY_SRQ = 0x37,
  ARBEL_IF_CMD_ARM_SRQ = 0x40,

  /* QP/EE commands */
  ARBEL_IF_CMD_RST2INIT_QPEE = 0x19,
  ARBEL_IF_CMD_INIT2RTR_QPEE = 0x1a,
  ARBEL_IF_CMD_RTR2RTS_QPEE = 0x1b,
  ARBEL_IF_CMD_RTS2RTS_QPEE = 0x1c,
  ARBEL_IF_CMD_SQERR2RTS_QPEE = 0x1d,
  ARBEL_IF_CMD_2ERR_QPEE = 0x1e,
  ARBEL_IF_CMD_RTS2SQD_QPEE = 0x1f,
  ARBEL_IF_CMD_SQD2SQD_QPEE = 0x38,
  ARBEL_IF_CMD_SQD2RTS_QPEE = 0x20,
  ARBEL_IF_CMD_ERR2RST_QPEE = 0x21,
  ARBEL_IF_CMD_QUERY_QPEE = 0x22,
  ARBEL_IF_CMD_INIT2INIT_QPEE = 0x2d,
  ARBEL_IF_CMD_SUSPEND_QPEE = 0x32,
  ARBEL_IF_CMD_UNSUSPEND_QPEE = 0x33,
  /* special QPs and management commands */
  ARBEL_IF_CMD_CONF_SPECIAL_QP = 0x23,
  ARBEL_IF_CMD_MAD_IFC = 0x24,

  /* multicast commands */
  ARBEL_IF_CMD_READ_MGM = 0x25,
  ARBEL_IF_CMD_WRITE_MGM = 0x26,
  ARBEL_IF_CMD_MGID_HASH = 0x27,

  /* miscellaneous commands */
  //  ARBEL_IF_CMD_CONF_PM = 0,
  ARBEL_IF_CMD_DIAG_RPRT = 0x30,
  ARBEL_IF_CMD_NOP       = 0x31,
  ARBEL_IF_CMD_POST_DOORBELL = 0x41,

  /* debug commands */
  ARBEL_IF_CMD_QUERY_DEBUG_MSG = 0x2a,
  ARBEL_IF_CMD_SET_DEBUG_MSG = 0x2b,
  /* NTU commands */
  ARBEL_IF_CMD_CONF_NTU = 0x28,
  ARBEL_IF_CMD_QUERY_NTU = 0x29

}
arbel_if_cmd_t;


typedef enum arbel_if_cmd_status {
  ARBEL_IF_CMD_STAT_OK = 0x00,             /* command completed successfully */
  ARBEL_IF_CMD_STAT_INTERNAL_ERR = 0x01,   /* Internal error (such as a bus error) occurred while processing command */
  ARBEL_IF_CMD_STAT_BAD_OP = 0x02,         /* Operation/command not supported or opcode modifier not supported */
  ARBEL_IF_CMD_STAT_BAD_PARAM = 0x03,      /* Parameter not supported or parameter out of range */
  ARBEL_IF_CMD_STAT_BAD_SYS_STATE = 0x04,  /* System not enabled or bad system state */
  ARBEL_IF_CMD_STAT_BAD_RESOURCE = 0x05,   /* Attempt to access reserved or unallocaterd resource */
  ARBEL_IF_CMD_STAT_RESOURCE_BUSY = 0x06,  /* Requested resource is currently executing a command, or is otherwise busy */
  ARBEL_IF_CMD_STAT_DDR_MEM_ERR = 0x07,    /* memory error */
  ARBEL_IF_CMD_STAT_EXCEED_LIM = 0x08,     /* Required capability exceeds device limits */
  ARBEL_IF_CMD_STAT_BAD_RES_STATE = 0x09,  /* Resource is not in the appropriate state or ownership */
  ARBEL_IF_CMD_STAT_BAD_INDEX = 0x0a,      /* Index out of range */
  ARBEL_IF_CMD_STAT_BAD_NVMEM = 0x0b,      /* FW image corrupted */
  ARBEL_IF_CMD_STAT_BAD_QPEE_STATE = 0x10, /* Attempt to modify a QP/EE which is not in the presumed state */
  ARBEL_IF_CMD_STAT_BAD_SEG_PARAM = 0x20,  /* Bad segment parameters (Address/Size) */
  ARBEL_IF_CMD_STAT_REG_BOUND = 0x21,      /* Memory Region has Memory Windows bound to */
  ARBEL_IF_CMD_STAT_LAM_NOT_PRE = 0x22,      /* Memory Region has Memory Windows bound to */
  ARBEL_IF_CMD_STAT_BAD_PKT = 0x30,        /* Bad management packet (silently discarded) */
  ARBEL_IF_CMD_STAT_BAD_SIZE = 0x40        /* More outstanding CQEs in CQ than new CQ size */
}
arbel_if_cmd_status_t;

/* special QP types */
typedef enum arbel_if_spqp {
  ARBEL_IF_SPQP_SMI = 0,
  ARBEL_IF_SPQP_GSI = 1,
  ARBEL_IF_SPQP_RAW_IPV6 = 2,
  ARBEL_IF_SPQP_RAW_ETHERTYPE = 3
}
arbel_if_spqp_t;

/* optparammask of QP/EE transition commands. (Tavor-PRM 13.6.x) */
enum arbel_if_qpee_optpar {
  ARBEL_IF_QPEE_OPTPAR_ALT_ADDR_PATH     = 1 << 0,
  ARBEL_IF_QPEE_OPTPAR_RRE               = 1 << 1,
  ARBEL_IF_QPEE_OPTPAR_RAE               = 1 << 2,
  ARBEL_IF_QPEE_OPTPAR_REW               = 1 << 3,
  ARBEL_IF_QPEE_OPTPAR_PKEY_INDEX        = 1 << 4,
  ARBEL_IF_QPEE_OPTPAR_Q_KEY             = 1 << 5,
  ARBEL_IF_QPEE_OPTPAR_RNR_TIMEOUT       = 1 << 6,
  ARBEL_IF_QPEE_OPTPAR_PRIMARY_ADDR_PATH = 1 << 7,
  ARBEL_IF_QPEE_OPTPAR_SRA_MAX           = 1 << 8,
  ARBEL_IF_QPEE_OPTPAR_RRA_MAX           = 1 << 9,
  ARBEL_IF_QPEE_OPTPAR_PM_STATE          = 1 << 10,
  ARBEL_IF_QPEE_OPTPAR_PORT_NUM          = 1 << 11,
  ARBEL_IF_QPEE_OPTPAR_RETRY_COUNT       = 1 << 12,
  ARBEL_IF_QPEE_OPTPAR_ALT_RNR_RETRY     = 1 << 13,
  ARBEL_IF_QPEE_OPTPAR_ACK_TIMEOUT       = 1 << 14,
  ARBEL_IF_QPEE_OPTPAR_RNR_RETRY         = 1 << 15,
  ARBEL_IF_QPEE_OPTPAR_SCHED_QUEUE       = 1 << 16,
  ARBEL_IF_QPEE_OPTPAR_ALL               = (1 << 17) -1
};

/* NOPCODE field enumeration for doorbells and send-WQEs */
typedef enum arbel_if_nopcode {
  ARBEL_IF_NOPCODE_NOP          = 0,  /* NOP */
  ARBEL_IF_NOPCODE_RDMAW        = 8,  /* RDMA-write */
  ARBEL_IF_NOPCODE_RDMAW_IMM    = 9,  /* RDMA-write w/immediate */
  ARBEL_IF_NOPCODE_SEND         = 10, /* Send */
  ARBEL_IF_NOPCODE_SEND_IMM     = 11, /* Send w/immediate */
  ARBEL_IF_NOPCODE_RDMAR        = 16, /* RDMA-read */
  ARBEL_IF_NOPCODE_ATOM_CMPSWP  = 17, /* Atomic Compare & Swap */
  ARBEL_IF_NOPCODE_ATOM_FTCHADD = 18, /* Atomic Fetch & Add */
  ARBEL_IF_NOPCODE_BIND_MEMWIN  = 24  /* Bind memory window */
}
arbel_if_nopcode_t;

/* OPCODE field enumeration for CQEs with completion error */
typedef enum arbel_if_cqe_err_opcode {
  ARBEL_IF_CQE_ERR_OPCODE_RQ          = 0xFE,  /* completion with error on Receive Queues */
  ARBEL_IF_CQE_ERR_OPCODE_SQ          = 0xFF   /* completion with error on Send Queues */
}
arbel_if_cqe_err_opcode_t;

/* event types */
/*=============*/
typedef enum arbel_if_eventt_num {
/* Completion Events */
  ARBEL_IF_EV_TYPE_CQ_COMP  =                  0,
/* IB - affiliated events */
  ARBEL_IF_EV_TYPE_PATH_MIG                 = 0x01,
  ARBEL_IF_EV_TYPE_COMM_EST                 = 0x02,
  ARBEL_IF_EV_TYPE_SEND_Q_DRAINED           = 0x03,
  /* IB - affiliated errors CQ  */
  ARBEL_IF_EV_TYPE_CQ_ERR                   = 0x04,
  ARBEL_IF_EV_TYPE_LOCAL_WQ_CATAS_ERR       = 0x05,
  ARBEL_IF_EV_TYPE_LOCAL_EE_CATAS_ERR       = 0x06,
  ARBEL_IF_EV_TYPE_PATH_MIG_FAIL            = 0x07,
  ARBEL_IF_EV_TYPE_PATH_MIG_ARMED           = 0x17,
  ARBEL_IF_EV_TYPE_LOCAL_SRQ_CATAS_ERR      = 0x12,
  ARBEL_IF_EV_TYPE_SRQ_QP_LAST_WQE_REACHED  = 0x13,
  ARBEL_IF_EV_TYPE_SRQ_LIMIT_REACHED        = 0x14,
  /* Unaffiliated errors */
  ARBEL_IF_EV_TYPE_LOCAL_CATAS_ERR          = 0x08,
  ARBEL_IF_EV_TYPE_PORT_ERR                 = 0x09,
  ARBEL_IF_EV_TYPE_LOCAL_WQ_INVALID_REQ_ERR = 0x10,
  ARBEL_IF_EV_TYPE_LOCAL_WQ_ACCESS_VIOL_ERR = 0x11,
  ARBEL_IF_EV_TYPE_GPIO                     = 0x15,
  ARBEL_IF_EV_TYPE_CLIENT_REREGISTER        = 0x16,
  /* Command Interface */
  ARBEL_IF_EV_TYPE_CMD_IF_COMP              = 0x0A,
  /* Address translation */
  ARBEL_IF_EV_TYPE_WQE_DATA_BUFF_PAGE_FAULT = 0x0B,
  ARBEL_IF_EV_TYPE_UNSUPP_PAGE_FAULT        = 0x0C,
  /* Performance Tuning Events  */
  ARBEL_IF_EV_TYPE_PERF_MONITOR_EVENTS      = 0x0D,
  /*Debug Events */
  ARBEL_IF_EV_TYPE_ECC_DETECT               = 0x0E,
  ARBEL_IF_EV_TYPE_OVERRUN                  = 0x0F
} arbel_if_eventt_num_t;

/* events sub-types */
typedef enum arbel_if_debug_eventt_subtype {
    ARBEL_IF_RAW_DBG_INFO1 = 0xF0,
    ARBEL_IF_RAW_DBG_INFO2 = 0xF1,
    ARBEL_IF_RAW_DBG_INFO3 = 0xF2,
    ARBEL_IF_RAW_DBG_ERROR1 = 0xF4,
    ARBEL_IF_RAW_DBG_ERROR2 = 0xF5,
    ARBEL_IF_RAW_DBG_ERROR3 = 0xF6
}arbel_if_debug_eventt_subtype_t;


typedef enum arbel_if_port_event_subtype {
    ARBEL_IF_SUB_EV_PORT_DOWN = 0x1,
    ARBEL_IF_SUB_EV_PORT_UP = 0x4
}arbel_if_port_event_subtype_t;

/* event type mask */
typedef enum arbel_if_eventt_mask_enum {
  ARBEL_IF_EV_MASK_CQ_COMP                     = 1<<ARBEL_IF_EV_TYPE_CQ_COMP,
  ARBEL_IF_EV_MASK_PATH_MIG   		           = 1<<ARBEL_IF_EV_TYPE_PATH_MIG,
  ARBEL_IF_EV_MASK_COMM_EST 		           = 1<<ARBEL_IF_EV_TYPE_COMM_EST,
  ARBEL_IF_EV_MASK_SEND_Q_DRAINED		       = 1<<ARBEL_IF_EV_TYPE_SEND_Q_DRAINED,
  ARBEL_IF_EV_MASK_CQ_ERR				       = 1<<ARBEL_IF_EV_TYPE_CQ_ERR,
  ARBEL_IF_EV_MASK_LOCAL_WQ_CATAS_ERR          = 1<<ARBEL_IF_EV_TYPE_LOCAL_WQ_CATAS_ERR,
  ARBEL_IF_EV_MASK_LOCAL_EE_CATAS_ERR          = 1<<ARBEL_IF_EV_TYPE_LOCAL_EE_CATAS_ERR,
  ARBEL_IF_EV_MASK_PATH_MIG_FAIL               = 1<<ARBEL_IF_EV_TYPE_PATH_MIG_FAIL,
  ARBEL_IF_EV_MASK_PATH_MIG_ARMED              = 1<<ARBEL_IF_EV_TYPE_PATH_MIG_ARMED,
  ARBEL_IF_EV_MASK_LOCAL_CATAS_ERR             = 1<<ARBEL_IF_EV_TYPE_LOCAL_CATAS_ERR,
  ARBEL_IF_EV_MASK_PORT_ERR                    = 1<<ARBEL_IF_EV_TYPE_PORT_ERR,
  ARBEL_IF_EV_MASK_CMD_IF_COMP                 = 1<<ARBEL_IF_EV_TYPE_CMD_IF_COMP,
  ARBEL_IF_EV_MASK_WQE_DATA_BUFF_PAGE_FAULT    = 1<<ARBEL_IF_EV_TYPE_WQE_DATA_BUFF_PAGE_FAULT,
  ARBEL_IF_EV_MASK_UNSUPP_PAGE_FAULT           = 1<<ARBEL_IF_EV_TYPE_UNSUPP_PAGE_FAULT,
  ARBEL_IF_EV_MASK_PERF_MONITOR_EVENTS         = 1<<ARBEL_IF_EV_TYPE_PERF_MONITOR_EVENTS,
  ARBEL_IF_EV_MASK_ECC_DETECT                  = 1<<ARBEL_IF_EV_TYPE_ECC_DETECT,
  ARBEL_IF_EV_MASK_LOCAL_WQ_INVALID_REQ_ERR    = 1<<ARBEL_IF_EV_TYPE_LOCAL_WQ_INVALID_REQ_ERR,
  ARBEL_IF_EV_MASK_LOCAL_WQ_ACCESS_VIOL_ERR    = 1<<ARBEL_IF_EV_TYPE_LOCAL_WQ_ACCESS_VIOL_ERR,
  ARBEL_IF_EV_MASK_LOCAL_SRQ_CATAS_ERR         = 1<<ARBEL_IF_EV_TYPE_LOCAL_SRQ_CATAS_ERR,
  ARBEL_IF_EV_MASK_SRQ_QP_LAST_WQE_REACHED     = 1<<ARBEL_IF_EV_TYPE_SRQ_QP_LAST_WQE_REACHED,
  ARBEL_IF_EV_MASK_SRQ_LIMIT_REACHED           = 1<<ARBEL_IF_EV_TYPE_SRQ_LIMIT_REACHED,
  ARBEL_IF_EV_MASK_GPIO                        = 1<<ARBEL_IF_EV_TYPE_GPIO,
  ARBEL_IF_EV_MASK_CLIENT_REREGISTER           = 1<<ARBEL_IF_EV_TYPE_CLIENT_REREGISTER
} arbel_if_eventt_mask_enum_t;

typedef u_int64_t arbel_if_eventt_mask_t; /* To be used with arbel_if_eventt_mask_enum_t */


typedef enum arbel_if_ev_catas_error_type {
  ARBEL_IF_EV_CATAS_ERR_FW_INTERNAL_ERR = 0x00,
  ARBEL_IF_EV_CATAS_ERR_MISBEHAVED_UAR_PAGE = 0x02,
  ARBEL_IF_EV_CATAS_ERR_UPLINK_BUS_ERR = 0x03,
  ARBEL_IF_EV_CATAS_ERR_HCA_DDR_DATA_ERR = 0x04,
  ARBEL_IF_EV_CATAS_ERR_INTERNAL_PARITY_ERR = 0x05,
  ARBEL_IF_EV_CATAS_ERR_EQ_ERR = 0x06
}arbel_if_ev_catas_error_type_t;

#define ARBEL_IF_UNMAP_QP_BIT  0x80000000

/* Completion status encoding (as given in CQE.immediate[31:24]) */
typedef enum arbel_if_comp_status {
  ARBEL_IF_COMP_STATUS_SUCCESS              = 0x0,
  ARBEL_IF_COMP_STATUS_ERR_LCL_LEN          = 0x1,
  ARBEL_IF_COMP_STATUS_ERR_LCL_QP_OP        = 0x2,
  ARBEL_IF_COMP_STATUS_ERR_LCL_EE_OP        = 0x3,
  ARBEL_IF_COMP_STATUS_ERR_LCL_PROT         = 0x4,
  ARBEL_IF_COMP_STATUS_ERR_FLUSH            = 0x5,
  ARBEL_IF_COMP_STATUS_ERR_MWIN_BIND        = 0x6,
  ARBEL_IF_COMP_STATUS_ERR_BAD_RESP         = 0x10,
  ARBEL_IF_COMP_STATUS_ERR_LCL_ACCS         = 0x11,
  ARBEL_IF_COMP_STATUS_ERR_RMT_INVAL_REQ    = 0x12,
  ARBEL_IF_COMP_STATUS_ERR_RMT_ACCSS        = 0x13,
  ARBEL_IF_COMP_STATUS_ERR_RMT_OP           = 0x14,
  ARBEL_IF_COMP_STATUS_ERR_TRANS_RETRY_EX   = 0x15,
  ARBEL_IF_COMP_STATUS_ERR_RNR_RETRY_EX     = 0x16,
  ARBEL_IF_COMP_STATUS_ERR_LCL_RDD_VIOL     = 0x20,
  ARBEL_IF_COMP_STATUS_ERR_RMT_INVAL_REQ_RD = 0x21,
  ARBEL_IF_COMP_STATUS_ERR_RMT_ABORT        = 0x22,
  ARBEL_IF_COMP_STATUS_ERR_INVAL_EEC_NUM    = 0x23,
  ARBEL_IF_COMP_STATUS_ERR_INVAL_EEC_STT    = 0x24
} arbel_if_comp_status_t;


/* different enums for error events */
typedef enum arbel_if_cq_err_synd {
  ARBEL_IF_CQ_OVERRUN = 1,
  ARBEL_IF_CQ_ACCSS_VIOL_ERR = 2
}arbel_if_cq_err_synd_t;


typedef enum arbel_if_port_change_synd {
  ARBEL_IF_PORT_LOG_DN_PHY_DN = 0,
  ARBEL_IF_PORT_LOG_DN_PHY_UP = 1,
  ARBEL_IF_PORT_LOG_UP_PHY_UP = 2
}arbel_if_port_change_synd_t;

typedef enum arbel_if_addr_trans_fault_type{
  ARBEL_IF_FALT_REGION_INVALID              =0,
  ARBEL_IF_FALT_REGION_PD_MIS               =1,
  ARBEL_IF_FALT_REGION_WRT_ACC_VIOL         =2,
  ARBEL_IF_FALT_REGION_ATOMIC_ACC_VIOL      =3,
  /*4-7 - reserved */
  ARBEL_IF_FALT_PAGE_NOT_PRESENT            =8,
  /* RESERVED 9 */
  ARBEL_IF_FALT_PAGE_WRT_ACC_VIOL           =10,
  /* RESERVED 11-13 */
  ARBEL_IF_FALT_UNSUPP_NON_PRESENT_PAGE_FLT =14,
  ARBEL_IF_FALT_UNSUPP_WRT_ACC_VIOL         =15
}arbel_if_addr_trans_fault_type_t;

typedef enum arbel_if_perf_mntr_num {
  ARBEL_IF_MNTR_NUM_SQPC = 1,
  ARBEL_IF_MNTR_NUM_RQPC = 2,
  ARBEL_IF_MNTR_NUM_CQC  = 3,
  ARBEL_IF_MNTR_NUM_RKEY = 4,
  ARBEL_IF_MNTR_NUM_TLB  = 5,
  ARBEL_IF_MNTR_NUM_PORT_0 = 6,
  ARBEL_IF_MNTR_NUM_PORT_1 = 7
} arbel_if_perf_mntr_num_t;

/* CQ doorbell command encoding */
typedef enum arbel_if_cq_db_cmd {
  ARBEL_IF_UAR_CQ_NOTIF_SOLIC_COMP=1,/* Req. notif. for next solicited comp.(param=consumer counter)*/
  ARBEL_IF_UAR_CQ_NOTIF_NEXT_COMP =2,/* Request notif. for next comp. event (param=consumer counter)*/
  ARBEL_IF_UAR_CQ_NOTIF_NCOMP=3 /* Request notif. when N CQEs are outstanding (cq_param=consumer counter to trigger event)*/
} arbel_if_uar_cq_db_cmd_t;


/* QP-state encoding */
typedef enum arbel_if_qp_state {
  ARBEL_IF_QP_STATE_RESET     = 0,
  ARBEL_IF_QP_STATE_INIT      = 1,
  ARBEL_IF_QP_STATE_RTR       = 2,
  ARBEL_IF_QP_STATE_RTS       = 3,
  ARBEL_IF_QP_STATE_SQER      = 4,
  ARBEL_IF_QP_STATE_SQD       = 5,
  ARBEL_IF_QP_STATE_ERR       = 6,
  ARBEL_IF_QP_STATE_DRAINING  = 7,
  ARBEL_IF_QP_STATE_BUSY      = 8,
  ARBEL_IF_QP_STATE_SUSPENDED = 9
} arbel_if_qp_state_t;

/* Old CQ state encoding (for STS,STC).
 * Kept here for informational purposes.
 *
  ARBEL_IF_CQ_STATE_DISARMED = 0,
  ARBEL_IF_CQ_STATE_ARMED = 1,
  ARBEL_IF_CQ_STATE_FIRED = 2
 *
 */

/* CQ state encoding */
typedef enum arbel_if_cq_state {
  ARBEL_IF_CQ_STATE_ARMED = 0x9,
  ARBEL_IF_CQ_STATE_ARMED_SOL = 0x6,
  ARBEL_IF_CQ_STATE_FIRED = 0xA
} arbel_if_cq_state_t;

/* EQ state encoding */
typedef enum arbel_if_eq_state {
  ARBEL_IF_EQ_STATE_ARMED = 0x9,
  ARBEL_IF_EQ_STATE_FIRED = 0xA,
  ARBEL_IF_EQ_STATE_ALWAYS_ARMED = 0xB
} arbel_if_eq_state_t;

/* SRQ state encoding */
typedef enum arbel_if_srq_state {
  ARBEL_IF_SRQ_STATE_HW = 0x0,
  ARBEL_IF_SRQ_STATE_ERROR = 0x1,
  ARBEL_IF_SRQ_STATE_SW = 0xF
} arbel_if_srq_state_t;

/* Miscellaneous Values: limits, tunable paramaters, etc. */
enum
{
  ARBEL_IF_HOST_BIGENDIAN = 1,   /* host is big endian*/
  ARBEL_NUM_RESERVED_PDS  = 0,   /* Obselete: will be moved to internal FW define once QUERY_DEV_LIM is implemented in full in driver */
  ARBEL_NUM_RESERVED_EQS  = 0,   /* Obselete: will be moved to internal FW define once QUERY_DEV_LIM is implemented in full in driver */
  ARBEL_NUM_RESERVED_RDDS = 0,   /* Obselete: will be moved to internal FW define once QUERY_DEV_LIM is implemented in full in driver */
  ARBEL_IF_HOST_LTLENDIAN = 0,   /* host is little endian*/

  /* Limits on QP in UD mode: max message and MTU */
  ARBEL_LOG2_MAX_MTU      = 11,

  ARBEL_IF_MAX_MPT_PAGE_SIZE = 31  /* (log2) Maximum page size for an MPT */
                                   /*sharon: 23.3.2003: changed from 32 at the req of tziporet */
};

typedef enum arbel_sys_en_syn
{
  ARBEL_SYS_EN_SYN_OK   = 0x0, /* No syndrome: When command succeeds */
  ARBEL_SYS_EN_SYN_SPD  = 0x1, /* SPD error (e. g. checksum error,
                                 no response, error while reading) */
  ARBEL_SYS_EN_SYN_DIMM = 0x2, /* DIMM out of bounds (e. g. DIMM rows
                                  number is not between 7 and 14,
                                  DIMM type is not 2) */
  ARBEL_SYS_EN_SYN_CONF = 0x3, /* DIMM conflict (e.g. mix of registered and
                                  unbuffered DIMMs, CAS latency conflict) */
  ARBEL_SYS_EN_SYN_CALB = 0x4, /* Calibration error */
  ARBEL_SYS_EN_SYN_TSIZ  = 0x5,  /* Total size out of bounds:
                                  E.g. total memory size exceeds the
                                  maximum supported value.  */
  ARBEL_SYS_EN_SYN_DCHK  = 0x6,   /*dimm check error occured*/
  ARBEL_SYS_EN_SYN_NOT_PRE  = 0xf   /*dimm not present*/
} arbel_sys_en_syn_t;

typedef enum arbel_diag_rprt
{
  ARBEL_DIAG_RPRT_QUERY_ERR = 0x2, /* Query transport and CI error counters */
  ARBEL_DIAG_RPRT_RESET_ERR = 0x3, /* Query and reset error counters */
  ARBEL_DIAG_RPRT_QUERY_PERF = 0x4, /* Query performance counters */
  ARBEL_DIAG_RPRT_RESET_PERF = 0x5, /* Query and reset performance counters */
  ARBEL_DIAG_RPRT_QUERY_MISC = 0x6, /* Query MISC counters */
  ARBEL_DIAG_RPRT_RESET_MISC = 0x7, /* Query and reset MISC counters */
} arbel_diag_rprt_t;

typedef enum arbel_if_db_record {
  ARBEL_IF_DB_RECORD_INV = 0x0,
  ARBEL_IF_DB_RECORD_CI = 0x1,
  ARBEL_IF_DB_RECORD_ARM = 0x2,
  ARBEL_IF_DB_RECORD_SQ = 0x3,
  ARBEL_IF_DB_RECORD_RQ = 0x4,
  ARBEL_IF_DB_RECORD_SRQ = 0x5,
  ARBEL_IF_DB_RECORD_INV_LAST = 0x7,
} arbel_if_db_record;

#define CMDIF_OUTPRM_ALIGN 16 /* alignment requirement for out params */

#endif /* H_ARBEL_IF_DEFS_H */

