/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#include <cmdif_priv.h>
#include <cmdif.h>
#include <mosal.h>
#include <cmdif_priv_defs.h>

const char *str_XHH_cmd(arbel_if_cmd_t opcode)
{
  switch ( opcode ) {
    case ARBEL_IF_CMD_MAP_FA:
      return "ARBEL_IF_CMD_MAP_FA";
    case ARBEL_IF_CMD_UNMAP_FA:
      return "ARBEL_IF_CMD_UNMAP_FA";
    case ARBEL_IF_CMD_SET_ICM_SIZE:
      return "ARBEL_IF_CMD_SET_ICM_SIZE";
    case ARBEL_IF_CMD_MAP_ICM:
      return "ARBEL_IF_CMD_MAP_ICM";
    case ARBEL_IF_CMD_UNMAP_ICM:
      return "ARBEL_IF_CMD_UNMAP_ICM";
    case ARBEL_IF_CMD_MAP_ICM_AUX:
      return "ARBEL_IF_CMD_MAP_ICM_AUX";
    case ARBEL_IF_CMD_UNMAP_ICM_AUX:
      return "ARBEL_IF_CMD_UNMAP_ICM_AUX";
    case ARBEL_IF_CMD_ENABLE_LAM:
      return "ARBEL_IF_CMD_ENABLE_LAM";
    case ARBEL_IF_CMD_DISABLE_LAM:
      return "ARBEL_IF_CMD_DISABLE_LAM";
    case ARBEL_IF_CMD_MOD_STAT_CFG:
      return "ARBEL_IF_CMD_MOD_STAT_CFG";
    case ARBEL_IF_CMD_QUERY_DEV_LIM:
      return "ARBEL_IF_CMD_QUERY_DEV_LIM";
    case ARBEL_IF_CMD_QUERY_FW:
      return "ARBEL_IF_CMD_QUERY_FW";
    case ARBEL_IF_CMD_QUERY_ADAPTER:
      return "ARBEL_IF_CMD_QUERY_ADAPTER";
    case ARBEL_IF_CMD_INIT_HCA:
      return "ARBEL_IF_CMD_INIT_HCA";
    case ARBEL_IF_CMD_CLOSE_HCA:
      return "ARBEL_IF_CMD_CLOSE_HCA";
    case ARBEL_IF_CMD_INIT_IB:
      return "ARBEL_IF_CMD_INIT_IB";
    case ARBEL_IF_CMD_CLOSE_IB:
      return "ARBEL_IF_CMD_CLOSE_IB";
    case ARBEL_IF_CMD_QUERY_HCA:
      return "ARBEL_IF_CMD_QUERY_HCA";
    case ARBEL_IF_CMD_SET_IB:
      return "ARBEL_IF_CMD_SET_IB";
    case ARBEL_IF_CMD_SW2HW_MPT:
      return "ARBEL_IF_CMD_SW2HW_MPT";
    case ARBEL_IF_CMD_QUERY_MPT:
      return "ARBEL_IF_CMD_QUERY_MPT";
    case ARBEL_IF_CMD_HW2SW_MPT:
      return "ARBEL_IF_CMD_HW2SW_MPT";
    case ARBEL_IF_CMD_READ_MTT:
      return "ARBEL_IF_CMD_READ_MTT";
    case ARBEL_IF_CMD_WRITE_MTT:
      return "ARBEL_IF_CMD_WRITE_MTT";
    case ARBEL_IF_CMD_MAP_EQ:
      return "ARBEL_IF_CMD_MAP_EQ";
    case ARBEL_IF_CMD_SW2HW_EQ:
      return "ARBEL_IF_CMD_SW2HW_EQ";
    case ARBEL_IF_CMD_HW2SW_EQ:
      return "ARBEL_IF_CMD_HW2SW_EQ";
    case ARBEL_IF_CMD_QUERY_EQ:
      return "ARBEL_IF_CMD_QUERY_EQ";
    case ARBEL_IF_CMD_SW2HW_CQ:
      return "ARBEL_IF_CMD_SW2HW_CQ";
    case ARBEL_IF_CMD_HW2SW_CQ:
      return "ARBEL_IF_CMD_HW2SW_CQ";
    case ARBEL_IF_CMD_QUERY_CQ:
      return "ARBEL_IF_CMD_QUERY_CQ";
    case ARBEL_IF_CMD_RST2INIT_QPEE:
      return "ARBEL_IF_CMD_RST2INIT_QPEE";
    case ARBEL_IF_CMD_INIT2RTR_QPEE:
      return "ARBEL_IF_CMD_INIT2RTR_QPEE";
    case ARBEL_IF_CMD_RTR2RTS_QPEE:
      return "ARBEL_IF_CMD_RTR2RTS_QPEE";
    case ARBEL_IF_CMD_RTS2RTS_QPEE:
      return "ARBEL_IF_CMD_RTS2RTS_QPEE";
    case ARBEL_IF_CMD_SQERR2RTS_QPEE:
      return "ARBEL_IF_CMD_SQERR2RTS_QPEE";
    case ARBEL_IF_CMD_2ERR_QPEE:
      return "ARBEL_IF_CMD_2ERR_QPEE";
    case ARBEL_IF_CMD_RTS2SQD_QPEE:
      return "ARBEL_IF_CMD_RTS2SQD_QPEE";
    case ARBEL_IF_CMD_SQD2RTS_QPEE:
      return "ARBEL_IF_CMD_SQD2RTS_QPEE";
    case ARBEL_IF_CMD_ERR2RST_QPEE:
      return "ARBEL_IF_CMD_ERR2RST_QPEE";
    case ARBEL_IF_CMD_QUERY_QPEE:
      return "ARBEL_IF_CMD_QUERY_QPEE";
    case ARBEL_IF_CMD_CONF_SPECIAL_QP:
      return "ARBEL_IF_CMD_CONF_SPECIAL_QP";
    case ARBEL_IF_CMD_MAD_IFC:
      return "ARBEL_IF_CMD_MAD_IFC";
    case ARBEL_IF_CMD_READ_MGM:
      return "ARBEL_IF_CMD_READ_MGM";
    case ARBEL_IF_CMD_WRITE_MGM:
      return "ARBEL_IF_CMD_WRITE_MGM";
    case ARBEL_IF_CMD_MGID_HASH:
      return "ARBEL_IF_CMD_MGID_HASH";
    case ARBEL_IF_CMD_CONF_NTU:
      return "ARBEL_IF_CMD_CONF_NTU";
    case ARBEL_IF_CMD_QUERY_NTU:
      return "ARBEL_IF_CMD_QUERY_NTU";
    case ARBEL_IF_CMD_RESIZE_CQ:
      return "ARBEL_IF_CMD_RESIZE_CQ";
    case ARBEL_IF_CMD_SUSPEND_QPEE:
      return "ARBEL_IF_CMD_SUSPEND_QPEE";
    case ARBEL_IF_CMD_UNSUSPEND_QPEE:
      return "ARBEL_IF_CMD_UNSUSPEND_QPEE";
    case ARBEL_IF_CMD_SW2HW_SRQ:
      return "ARBEL_IF_CMD_SW2HW_SRQ";
    case ARBEL_IF_CMD_HW2SW_SRQ:
      return "ARBEL_IF_CMD_HW2SW_SRQ";
    case ARBEL_IF_CMD_QUERY_SRQ:
      return "ARBEL_IF_CMD_QUERY_SRQ";
    case ARBEL_IF_CMD_NOP:
      return "ARBEL_IF_CMD_NOP";
	case ARBEL_IF_CMD_RUN_FW:
	  return "ARBEL_IF_CMD_RUN_FW";
	case ARBEL_IF_CMD_ACCESS_LAM:
	  return "ARBEL_IF_CMD_ACCESS_LAM";
	case ARBEL_IF_CMD_ARM_SRQ:
	  return "ARBEL_IF_CMD_ARM_SRQ";
	case ARBEL_IF_CMD_DIAG_RPRT:
	  return "ARBEL_IF_CMD_DIAG_RPRT";
	case ARBEL_IF_CMD_INIT2INIT_QPEE:
	  return "ARBEL_IF_CMD_INIT2INIT_QPEE";
	case ARBEL_IF_CMD_SQD2SQD_QPEE:
	  return "ARBEL_IF_CMD_SQD2SQD_QPEE";
	case ARBEL_IF_CMD_SET_DEBUG_MSG:
	  return "ARBEL_IF_CMD_SET_DEBUG_MSG";
	case ARBEL_IF_CMD_QUERY_DEBUG_MSG:
	  return "ARBEL_IF_CMD_QUERY_DEBUG_MSG";
	case ARBEL_IF_CMD_MODIFY_MPT:
	  return "ARBEL_IF_CMD_MODIFY_MPT";
	case ARBEL_IF_CMD_SYNC_TPT:
	  return "ARBEL_IF_CMD_SYNC_TPT";
    default:
      return "[UNKNOWN_COMMAND]";
  }
}
/*
 *  cmd_invoke
 */
XHH_cmd_status_t cmd_invoke(XHH_cmd_t cmd_if, command_fields_t *cmd_prms)
{
  struct cmd_if_context_st *entry = (struct cmd_if_context_st *)cmd_if;
  XHH_cmd_status_t rc;

  FUNC_IN;

  if ( entry->have_fatal && ((cmd_prms->input_modifier==0) || (cmd_prms->opcode!=ARBEL_IF_CMD_CLOSE_HCA)) ) {
    MT_RETURN(XHH_CMD_STAT_EFATAL);
  }

  /* system enabled */
  rc = XHH_cmd_main_flow(entry, cmd_prms);
  if ( rc != XHH_CMD_STAT_OK ) {
	  if (rc == XHH_CMD_STAT_LAM_NOT_PRE) {
		  MTL_DEBUG1(MT_FLFMT("command 0x%X (%s) returned status=0x%X (%s)"), 
					 cmd_prms->opcode, str_XHH_cmd(cmd_prms->opcode),rc,str_XHH_cmd_status_t(rc));
	  } else {
		  MTL_ERROR1(MT_FLFMT("Failed command 0x%X (%s): status=0x%X (%s)"), 
					 cmd_prms->opcode, str_XHH_cmd(cmd_prms->opcode),rc,str_XHH_cmd_status_t(rc));
	  }
  }
  MT_RETURN(rc);
}


/*
 *  alloc_prm_ctx
 */
HH_ret_t alloc_prm_ctx(struct cmd_if_context_st *entry,
                              prms_buf_t *prm_p,
                              MT_size_t buf_sz
                              )
{
	unsigned long addr;

	addr = __get_free_page(GFP_KERNEL);
	if ( !addr ) {
		return HH_EAGAIN;
	}


	prm_p->prm_alloc_va = (MT_virt_addr_t)addr;
	prm_p->prm_base_va = (MT_virt_addr_t)addr;
	prm_p->prm_base_pa = virt_to_phys((void *)addr);
	prm_p->prm_buf_sz = PAGE_SIZE;
	prm_p->allocated = 1;
	return HH_OK;
}


/*
 *  de_alloc_prm_ctx
 */
HH_ret_t de_alloc_prm_ctx(struct cmd_if_context_st *entry,
                                 prms_buf_t *prms_p)
{
	free_page((unsigned long)(prms_p->prm_alloc_va));
	return HH_OK;
}
