/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef __dev_cmdif_h
#define __dev_cmdif_h

/* for map_fw, map_icm_aux, and map_icm */
typedef struct pa_vec_st {
    MT_phys_addr_t phys_addr;
    u_int8_t       log2size;
} XHH_cmd_pa_vec_t ;

/* Initialization commands */
XHH_cmd_status_t XHH_cmd_MAP_FA(/*IN*/ XHH_cmd_t cmd_if, /*IN*/ u_int32_t num_pa_vec_entries,
                                /*IN*/ XHH_cmd_pa_vec_t * pa_vec_p);
XHH_cmd_status_t XHH_cmd_UNMAP_FA(/*IN*/ XHH_cmd_t cmd_if);
XHH_cmd_status_t XHH_cmd_SET_ICM_SIZE(/*IN*/  XHH_cmd_t cmd_if, /*IN*/ u_int64_t icm_size,
                                      /*OUT*/ u_int64_t * icm_aux_size);
XHH_cmd_status_t XHH_cmd_MAP_ICM_AUX(/*IN*/ XHH_cmd_t cmd_if, /*IN*/ u_int32_t num_pa_vec_entries,
                                     /*IN*/ XHH_cmd_pa_vec_t * pa_vec_p);
XHH_cmd_status_t XHH_cmd_UNMAP_ICM_AUX(/*IN*/ XHH_cmd_t cmd_if);
XHH_cmd_status_t XHH_cmd_ENABLE_LAM(/*IN*/ XHH_cmd_t cmd_if, /*OUT*/ XHH_lam_props_t *lam_props);
XHH_cmd_status_t XHH_cmd_DISABLE_LAM(/*IN*/ XHH_cmd_t cmd_if);
XHH_cmd_status_t XHH_cmd_ACCESS_LAM(/*IN*/ XHH_cmd_t cmd_if, MT_bool read_flag, u_int32_t num_bytes,
                                    /*INOUT*/ u_int8_t *iobuf_p);

/* General commands */
XHH_cmd_status_t XHH_cmd_MAP_ICM(/*IN*/ XHH_cmd_t cmd_if, /*IN*/ XHH_icm_va_t  icm_start_addr,
                                 /*IN*/ u_int32_t num_pa_vec_entries,/*IN*/ XHH_cmd_pa_vec_t * pa_vec_p);
XHH_cmd_status_t XHH_cmd_UNMAP_ICM(/*IN*/ XHH_cmd_t cmd_if, /*IN*/ XHH_icm_va_t  icm_start_addr,
                                   /*IN*/ u_int32_t page_count);
XHH_cmd_status_t XHH_cmd_NOP(/*IN*/ XHH_cmd_t cmd_if, /*IN*/ u_int8_t interval);
XHH_cmd_status_t XHH_cmd_RUN_FW(/*IN*/ XHH_cmd_t cmd_if);

#endif
