/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_DEV_CMDS_WRAP_H
#define H_DEV_CMDS_WRAP_H

#define QP_INS_FLD_SH(src, a, st, fld) MT_INSERT_ARRAY32(a, (u_int32_t)((src->fld) >> (MT_BIT_OFFSET(st, qpc_eec_data.fld) & MASK32(5))),MT_BIT_OFFSET(st, qpc_eec_data.fld), MT_BIT_SIZE(st, qpc_eec_data.fld))
#define QP_EX_FLD_SH(dst, a, st, fld) dst->fld = (MT_EXTRACT_ARRAY32(a, MT_BIT_OFFSET(st, qpc_eec_data.fld), MT_BIT_SIZE(st, qpc_eec_data.fld))) << (MT_BIT_OFFSET(st, qpc_eec_data.fld)& MASK32(5))

#define  XHH_DEV_SPECIFIC_PRINT_HCA_PROPS \
  CMDS_DBG( "time_stamp_granularity = %d\n", hca_props->time_stamp_granularity); \
  CMDS_DBG( "responder_exu = %d\n", hca_props->responder_exu);  \
  CMDS_DBG( "ce (Checksum Enabled) = %s\n", hca_props->ce ? "TRUE" :  "FALSE"); \
  CMDS_DBG( "sph (HW calculates TCP/UDP Pseudo-Header csum for send) = %s\n", hca_props->sph ? "TRUE" :  "FALSE"); \
  CMDS_DBG( "rph (HW calculates TCP/UDP Pseudo-Header csum for recv) = %s\n", hca_props->rph ? "TRUE" :  "FALSE"); \
  CMDS_DBG( "wqe_quota_en (wqe_quota field Enabled) = %s\n", hca_props->wqe_quota_en ? "TRUE" :  "FALSE");   \
  CMDS_DBG( "wqe_quota = %d\n", hca_props->wqe_quota);

#define  XHH_DEV_SPECIFIC_QUERY_DEV_LIM(dev_lim, outprm, prm_struct)  \
    EX_BOOL_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), win_type);  \
    EX_BOOL_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), mps);       \
    EX_BOOL_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), bl);        \
    EX_BOOL_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), zb);        \
    EX_BOOL_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), lif);       \
    EX_BOOL_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), lamr);      \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), log_max_mtts);   \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), log_pbl_sz);     \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), resd_lkey);      \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), log2_rsvd_rdbs); \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), mpt_entry_sz);   \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), mtt_entry_sz);   \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), max_desc_sz_sq);      \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), max_desc_sz_rq); \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), max_sg_sq);   \
    EX_FLD(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), max_sg_rq);   \
    /*EX_FLD64(dev_lim, outprm, ADD_DEV_PRM_PREFIX(prm_struct), max_icm_size);*/
    
    
#define  XHH_DEV_SPECIFIC_PRINT_CQ_CONTEXT  \
    CMDS_DBG( "cqc->consumer_indx = 0x%X\n",  cqc->consumer_counter);  \
    CMDS_DBG( "cqc->producer_indx = 0x%X\n",  cqc->producer_counter);


#define  XHH_DEV_SPECIFIC_QUERY_FW(fw_props,outprm, prm_struct) \
    EX_BOOL_FLD(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), dt);  \
    EX_FLD(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), fw_pages);\
    EX_FLD64(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), clr_int_base_addr);\
    EX_FLD64(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), eq_arm_base_addr);\
    EX_FLD64(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), eq_set_ci_base_addr); \
    EX_BOOL_FLD(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), wqe_h_mode);  \
	EX_BOOL_FLD(fw_props, outprm, ADD_DEV_PRM_PREFIX(prm_struct), zb_wq_cq);

#define  XHH_DEV_SPECIFIC_PRINT_DEV_LIM  \
    CMDS_DBG( "dev_lim->log_max_mtts = %d\n",dev_lim->log_max_mtts);               \
    CMDS_DBG( "dev_lim->log_pbl_sz = %d\n",dev_lim->log_pbl_sz);                   \
    CMDS_DBG( "dev_lim->resd_lkey = %d\n",dev_lim->resd_lkey);                     \
    /*CMDS_DBG( "dev_lim->max_icm_size = "U64_FMT"\n", dev_lim->max_icm_size); */       \
    CMDS_DBG( "dev_lim->win_type = %s\n", dev_lim->win_type ? "TRUE" :  "FALSE");  \
    CMDS_DBG( "dev_lim->mps = %s\n", dev_lim->mps ? "TRUE" :  "FALSE");            \
    CMDS_DBG( "dev_lim->bl = %s\n", dev_lim->bl ? "TRUE" :  "FALSE");              \
    CMDS_DBG( "dev_lim->zb = %s\n", dev_lim->zb ? "TRUE" :  "FALSE");              \
    CMDS_DBG( "dev_lim->lif = %s\n", dev_lim->lif ? "TRUE" :  "FALSE");            \
    CMDS_DBG( "dev_lim->lamr = %s\n", dev_lim->lamr ? "TRUE" :  "FALSE");\
    CMDS_DBG( "dev_lim->log2_rsvd_rdbs = %d\n",dev_lim->log2_rsvd_rdbs);             \
    CMDS_DBG( "dev_lim->mpt_entry_sz = %d\n",dev_lim->mpt_entry_sz);                   \
    CMDS_DBG( "dev_lim->mtt_entry_sz = %d\n",dev_lim->mtt_entry_sz);      \
    CMDS_DBG( "dev_lim->max_desc_sz_sq = %d\n",dev_lim->max_desc_sz_sq);            \
    CMDS_DBG( "dev_lim->max_desc_sz_rq = %d\n",dev_lim->max_desc_sz_rq);           \
    CMDS_DBG( "dev_lim->max_sg_sq = %d\n",dev_lim->max_sg_sq);                     \
    CMDS_DBG( "dev_lim->max_sg_rq = %d\n",dev_lim->max_sg_rq);                     

#define XHH_DEV_SPECIFIC_PRINT_MPT_ENTRY \
    CMDS_DBG( "MPT MTT addr = "U64_FMT"\n", mpt->mtt_adr);

    
#define  XHH_DEV_SPECIFIC_PRINT_QUERY_FW   \
    CMDS_DBG( "fw_props->dt = %s\n", fw_props->dt ? "TRUE" :  "FALSE");            \
    CMDS_DBG( "fw_props->fw_pages = %d\n", fw_props->fw_pages);\
    CMDS_DBG( "fw_props->clr_int_base_addr = "PHYS_ADDR_FMT"\n", fw_props->clr_int_base_addr);\
    CMDS_DBG( "fw_props->eq_arm_base_addr = "PHYS_ADDR_FMT"\n", fw_props->eq_arm_base_addr); \
    CMDS_DBG( "fw_props->eq_set_ci_base_addr ="PHYS_ADDR_FMT"\n", fw_props->eq_set_ci_base_addr); 
	     

#define  XHH_CMD_DEV_SPECIFIC_INIT_HCA   \
    INS_BOOL_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), ce);  \
    INS_BOOL_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), sph);  \
    INS_BOOL_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), rph);  \
    INS_BOOL_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), wqe_quota_en);  \
    INS_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), time_stamp_granularity);  \
    INS_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), responder_exu);  \
    INS_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), wqe_quota);      \
    INS_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), uar_parameters.log_uar_entry_sz);	  \
    INS_FLD(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), uar_parameters.log_max_uars);	  \
    INS_FLD64(hca_props, inprm, ADD_DEV_PRM_PREFIX(init_hca_st), uar_parameters.uar_context_base_addr);
    
#define  XHH_CMD_DEV_SPECIFIC_QUERY_HCA   \
    EX_BOOL_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), ce);  \
    EX_BOOL_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), sph);  \
    EX_BOOL_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), rph);  \
    EX_BOOL_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), wqe_quota_en);  \
    EX_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), time_stamp_granularity);  \
    EX_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), responder_exu);  \
    EX_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), wqe_quota);  	\
    EX_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), uar_parameters.log_uar_entry_sz);	  \
    EX_FLD(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), uar_parameters.log_max_uars);	  \
    EX_FLD64(hca_props, outprm, ADD_DEV_PRM_PREFIX(init_hca_st), uar_parameters.uar_context_base_addr);

#define  XHH_CMD_DEV_SPECIFIC_SW2HW_MPT  \
    mpt_entry->mem_key= (mpt_entry->mem_key << 24) | (mpt_entry->mem_key >> 8); /* Shuffle */		\
    INS_FLD(mpt_entry, inprm, ADD_DEV_PRM_PREFIX(mpt_st), mem_key);					\
    mpt_entry->mem_key= (mpt_entry->mem_key >> 24) | (mpt_entry->mem_key << 8); /* Shuffle back */	\
    INS_FLD64_SH(mpt_entry, inprm, ADD_DEV_PRM_PREFIX(mpt_st), mtt_adr);
 
#define  XHH_CMD_DEV_SPECIFIC_MODIFY_MPT \
    mpt_entry->mem_key= (mpt_entry->mem_key << 24) | (mpt_entry->mem_key >> 8); /* Shuffle */		\
    INS_FLD(mpt_entry, inprm, ADD_DEV_PRM_PREFIX(mpt_st), mem_key);					\
    mpt_entry->mem_key= (mpt_entry->mem_key >> 24) | (mpt_entry->mem_key << 8); /* Shuffle back */	\
    INS_FLD64_SH(mpt_entry, inprm, ADD_DEV_PRM_PREFIX(mpt_st), mtt_adr);

#define  XHH_CMD_DEV_SPECIFIC_QUERY_MPT  \
    EX_FLD(mpt_entry, outprm, ADD_DEV_PRM_PREFIX(mpt_st), mem_key);	\
    mpt_entry->mem_key= (mpt_entry->mem_key >> 24) | (mpt_entry->mem_key << 8); /* Shuffle back */	\
    EX_FLD64_SH(mpt_entry, outprm, ADD_DEV_PRM_PREFIX(mpt_st), mtt_adr);    

#define  XHH_CMD_DEV_SPECIFIC_HW2SW_MPT  \
    EX_FLD(mpt_entry, outprm, ADD_DEV_PRM_PREFIX(mpt_st), mem_key);					\
    mpt_entry->mem_key= (mpt_entry->mem_key >> 24) | (mpt_entry->mem_key << 8); /* Shuffle back */	\
    EX_FLD64_SH(mpt_entry, outprm, ADD_DEV_PRM_PREFIX(mpt_st), mtt_adr);    

#define  XHH_CMD_DEV_SPECIFIC_SW2HW_EQ
#define  XHH_CMD_DEV_SPECIFIC_HW2SW_EQ
#define  XHH_CMD_DEV_SPECIFIC_QUERY_EQ

#define  XHH_CMD_DEV_SPECIFIC_SW2HW_CQ \
    INS_FLD(cq_context, inprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), consumer_counter); \
    INS_FLD(cq_context, inprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), producer_counter); \
    INS_FLD(cq_context, inprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), cq_ci_db_record);  \
    INS_FLD(cq_context, inprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), cq_state_db_record);


#define  XHH_CMD_DEV_SPECIFIC_HW2SW_CQ \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), consumer_counter); \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), producer_counter); \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), cq_ci_db_record);  \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), cq_state_db_record);

#define  XHH_CMD_DEV_SPECIFIC_QUERY_CQ \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), consumer_counter); \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), producer_counter); \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), cq_ci_db_record);  \
    EX_FLD(cq_context, outprm, ADD_DEV_PRM_PREFIX(completion_queue_context_st), cq_state_db_record);

#define  XHH_CMD_DEV_SPECIFIC_MODIFY_QPEE   \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), wqe_base_adr_h);        \
	QP_INS_FLD_SH(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), snd_wqe_base_adr_l); \
	QP_INS_FLD_SH(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rcv_wqe_base_adr_l); \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_sq_stride);         \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_sq_size);           \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_rq_stride);         \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_rq_size);           \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), snd_db_record_index);   \
	QP_INS_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rcv_db_record_index);   \
	QP_INS_BOOL_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rlky);             \
	QP_INS_BOOL_FLD(qp_context, inprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), fre); 
        
#define  XHH_CMD_DEV_SPECIFIC_QUERY_QPEE \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), wqe_base_adr_h);        \
	QP_EX_FLD_SH(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), snd_wqe_base_adr_l); \
	QP_EX_FLD_SH(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rcv_wqe_base_adr_l); \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_sq_stride);         \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_sq_size);           \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_rq_stride);         \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), log_rq_size);           \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), snd_db_record_index);   \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rcv_db_record_index);   \
	QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), sq_wqe_counter);        \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rq_wqe_counter);        \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rmsn);                  \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), ssn);                   \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), last_acked_psn);        \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), cur_rnr_retry);         \
    QP_EX_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), cur_retry_cnt);         \
    QP_EX_BOOL_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), rlky);             \
    QP_EX_BOOL_FLD(qp_context, outprm, ADD_DEV_PRM_PREFIX(qp_ee_state_transitions_st), fre); 

#define  XHH_CMD_DEV_SPECIFIC_SW2HW_SRQ \
    INS_FLD(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), log_srq_size);           \
    INS_FLD(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_db_record_index);    \
    INS_FLD(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), log_rq_stride);		\
    INS_FLD_SH(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_wqe_base_adr_l);  \
    INS_FLD(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), usr_page);               \
    INS_FLD(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), eq);                     \
    INS_FLD(srqc_p, inprm, ADD_DEV_PRM_PREFIX(srq_context_st), srqn);                   

#define  XHH_CMD_DEV_SPECIFIC_HW2SW_SRQ \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), log_srq_size); \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_db_record_index); \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), log_rq_stride);		\
    EX_FLD_SH(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_wqe_base_adr_l);  \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), usr_page);               \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), eq);                     \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srqn);                   
   
#define  XHH_CMD_DEV_SPECIFIC_QUERY_SRQ \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), log_srq_size); \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_db_record_index); \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), log_rq_stride);		\
    EX_FLD_SH(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_wqe_base_adr_l);  \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), usr_page);               \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), eq);                     \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srqn);                   \
    EX_FLD(srqc_p, outprm, ADD_DEV_PRM_PREFIX(srq_context_st), srq_wqe_counter);        \
    MTL_DEBUG1("quer_srq=0x%x,srqn=0x%x,lwm=%u,log_sz=%u,eq=%u,srq_counter=%u\n",  \
       srqn,srqc_p->srqn,srqc_p->lwm,srqc_p->log_srq_size,srqc_p->eq,srqc_p->srq_wqe_counter);
      
#endif

