/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHH_DEV_MCGM_H
#define H_XHH_DEV_MCGM_H

#include <mapm.h>

#define XHH_DEV_SPECIFIC_MCGM_INIT_PARAMS \
        XHH_icm_va_t mcg_tbl_base;    \
        u_int8_t   log2_mcg_entry_sz;
  
#define XHH_DEV_SPECIFIC_MCGM_DATA  \
 XHH_mapm_t             mapm;
 
#define XHH_DEV_SPECIFIC_MCGM_INIT  \
  hh_ret= XHH_mapm_alloc_all(p_init_params->mcg_tbl_base,       \
                             p_init_params->log2_total_entries, \
                             p_init_params->log2_mcg_entry_sz,  \
                             hob,                               \
                             &(new_mcgm_p->mapm));              \
  if (hh_ret != HH_OK) {                                        \
      MTL_ERROR4("%s: Cannot allocate multicast tables in icm. tbl_base="\
                U64_FMT", log2_tot_entries=%u, log2_entry_sz=%u\n",\
		 __func__,p_init_params->mcg_tbl_base,p_init_params->log2_total_entries,\
		 p_init_params->log2_mcg_entry_sz);\
      goto clean;                                               \
  }


#define XHH_DEV_SPECIFIC_MCGM_DONE \
        XHH_mapm_free_all(mcgm->mapm);
        
  

#endif
