/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHHUL_CQM_DEV_H
#define H_XHHUL_CQM_DEV_H

#include <cidb.h>


#define XHH_DEV_SPECIFIC_UL_CQ_T_FIELDS \
    XHH_cidb_t  cidb;                \
    void *      arm_db_record_p;     \
    void *      ci_db_record_p;      \
    u_int8_t*    next_cmd_sn_p;      \
	u_int8_t    last_sn;  /* seq num of last posted arm */  \
	u_int8_t    last_cmd; /* cmd of last posted arm */		\
	u_int32_t   last_counter; /*counter of last posted arm (for arm-n) */

#define XHH_DEV_SPECIFIC_CREATE_CQ_DONE \
    cq->ci_db_record_p = (void *)(((XHH_cq_ul_resources_t *) cq_ul_resources_p)->ci_db_record_p);   \
    cq->arm_db_record_p = (void *)(((XHH_cq_ul_resources_t *) cq_ul_resources_p)->arm_db_record_p); \
	cq->next_cmd_sn_p = (((XHH_cq_ul_resources_t *) cq_ul_resources_p)->next_cmd_sn_p);                                                                                 \
	cq->last_cmd = 0;                                                                               \
	cq->last_counter = 0;                                                                           \
	cq->last_sn = 0; /* initialize so that last_sn is not equal to cmd_sn */						\
    XHH_cidb_cq_init_cntr(cq->ci_db_record_p, hh_cq); \
    XHH_cidb_cq_init_arm(cq->arm_db_record_p, hh_cq);


#define XHH_DEV_RESIZE_COUNTER_INIT_VAL(val,mask) (val)

#define XHH_DEV_CHECK_CQE_STATE(cq_p, cur_cqe, cqe_num) \
     is_cqe_hw_own(cur_cqe) ? HH_CQ_EMPTY : HH_OK ;

#define  XHH_DEV_FREE_CQE   \
	  MTPERF_TIME_START(free_cqe);							  \
	  free_cqe(xhhul_cq_p,cur_cqe); /* Free original CQE and update consumer index */ \
	  MTPERF_TIME_END(free_cqe);
						      

#endif /* H_XHHUL_CQM_H */
