/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHHUL_SRQM_DEV_H
#define H_XHHUL_SRQM_DEV_H

#include <cidb.h>

#define WQE_SEGMENT_NEXT_ST             arbelprm_wqe_segment_next_st
#define WQE_SEGMENT_CTRL_SEND_ST        arbelprm_wqe_segment_ctrl_send_st
#define WQE_SEGMENT_DATA_PTR_ST         arbelprm_wqe_segment_data_ptr_st
#define WQE_SEGMENT_CTRL_RECV_ST        arbelprm_wqe_segment_ctrl_recv_st

#define XHH_DEV_SPECIFIC_WQE_BUILD_RECV  \
  cur_loc_p+= WQE_pack_recv_next((u_int32_t*)cur_loc_p, (u_int32_t)(MT_ulong_ptr_t)srq->free_wqes_list_top,    \
				 srq->max_sentries+1 /*nds in octo-words*/)

#define XHH_DEV_SPECIFIC_UL_SRQ_T_FIELDS \
    XHH_cidb_t  cidb;                    \
    u_int32_t	wqe_recv_counter;        \
    void *      recvq_db_record_p;   

/* subtract out invisible "spare" WQE which was allocated */				      
#define XHH_DEV_SPECIFIC_ADJUST_RET_MAX_OUTS(a) ((a)-1)
					
#define XHH_DEV_SPECIFIC_CREATE_SRQ_DONE \
    srq->recvq_db_record_p = (void *)(((XHH_srq_ul_resources_t *) srq_ul_resources_p)->recvq_db_record_p);   \
    srq->wqe_recv_counter= 0;		 \
    XHH_cidb_qp_init_uar_ctx_entry(srq->recvq_db_record_p, srq->srqn,  ARBEL_IF_DB_RECORD_SRQ)

#define XHHUL_DEV_SPECIFIC_ALLOC_SRQ_WQE_BUF_INIT \
 /* Require that number of WQEs be a power of 2 (because of log_rq_size, */          \
 /* log_rq_size in Arbel SRQ context. Added 1 to requested because need one spare */ \
 adjusted_req_max_outs = (1 << ceil_log2(req_max_outs+1))

/* fill the new wqe's buffer with "null" scatter/gather entries */
#define XHHUL_DEV_SPECIFIC_ALLOC_SRQ_WQE_BUF_INIT_DONE \
{                                                      \
    u_int32_t *cur_wqe_dw_p, *cur_wqe_dw_end_p;              \
    MT_virt_addr_t cur_wqe;      	               \
					               \
    for (cur_wqe = new_buf_p->wqe_buf; cur_wqe < new_buf_p->wqe_buf+(MT_virt_addr_t)buf_sz;     \
	  cur_wqe += ((MT_virt_addr_t)(1<<log2_max_wqe_sz))) {	                                \
	cur_wqe_dw_p = (u_int32_t *)(cur_wqe + (WQE_SEG_SZ_NEXT + WQE_SEG_SZ_CTRL));               \
	cur_wqe_dw_end_p = (u_int32_t *)(cur_wqe + ((MT_virt_addr_t)(1<<log2_max_wqe_sz)));        \
	for (;cur_wqe_dw_p < cur_wqe_dw_end_p; cur_wqe_dw_p += WQE_SEG_SZ_SG_ENTRY_DW) {			\
	    cur_wqe_dw_p[MT_BYTE_OFFSET(WQE_SEGMENT_DATA_PTR_ST,byte_count)>>2]= 0;                \
	    cur_wqe_dw_p[MT_BYTE_OFFSET(WQE_SEGMENT_DATA_PTR_ST,l_key)>>2]= SRQ_EMPTY_SENTRY_LKEY; \
	}                                                                                       \
    }                                                                                           \
}


#define SRQ_EMPTY_SENTRY_LKEY ((u_int32_t)0x00000100)

#endif /* H_XHHUL_SRQM_DEV_H */
