/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHHUL_SRQM_DEV_INLINE_H
#define H_XHHUL_SRQM_DEV_INLINE_H

inline static HH_ret_t init_uar_info(HHUL_hca_hndl_t hca, XHHUL_srq_t srq, XHH_srq_ul_resources_t *ul_res_p)
{
    HH_ret_t rc;

    rc= XHHUL_hob_get_cidb(hca,&(srq->cidb));
    if (rc != HH_OK) {
      MTL_ERROR1(MT_FLFMT("%s: Failed getting XHHUL_hob's cidb (err=%d)."),__func__,rc);
      return rc;
    }
    rc= XHH_cidb_get_uar_index(srq->cidb,&(ul_res_p->uar_index)); 
    if (rc != HH_OK) {
      MTL_ERROR1(MT_FLFMT("%s: Failed getting UAR index (err=%d)"), __func__, rc);
    }
    return rc;
}
inline static u_int32_t WQE_pack_recv_next(u_int32_t *segment_p,u_int32_t subseq_wqe_32lsb, u_int32_t stride)
{
  memset(segment_p,0,WQE_SEG_SZ_NEXT);  /* Clear all "RESERVED" */
  segment_p[MT_BYTE_OFFSET(WQE_SEGMENT_NEXT_ST,nda_31_6)>>2]= subseq_wqe_32lsb & (~MASK32(6)); 
  MT_INSERT_ARRAY32(segment_p,stride,
    MT_BIT_OFFSET(WQE_SEGMENT_NEXT_ST,nds),MT_BIT_SIZE(WQE_SEGMENT_NEXT_ST,nds));
  return WQE_SEG_SZ_NEXT;
}

#endif /* H_XHHUL_SRQM_DEV_INLINE_H */
