/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHH_HOB_H
#define H_XHH_HOB_H

#include <vapi.h>
#include <vip_delay_unlock.h>
#include <mosal.h>
#include <hh.h>
#include <xhh.h>
#include <hob_comm.h>

#define XHH_RESERVED_PD(hob)       ((HH_pd_hndl_t)(XHH_get_rsvd_pd_num(hob)))


/* Prototypes */


HH_ret_t XHH_hob_get_pdm ( /*IN*/ XHH_hob_t hob, 
                           /*OUT*/ XHH_pdm_t *pdm_p );
HH_ret_t XHH_hob_get_icmm ( /*IN*/ XHH_hob_t hob, 
                           /*OUT*/ XHH_icmm_t *icmm_p );
HH_ret_t XHH_hob_get_uarm ( /*IN*/ XHH_hob_t hob, 
                           /*OUT*/ XHH_uarm_t *uarm_p );

u_int32_t XHH_get_rsvd_pd_num(XHH_hob_t hob);

#endif  /* H_XHH_H */
