#ifndef _XHH_MAPM_H
#define _XHH_MAPM_H

#include <mosal.h>
#include <xhh.h>
#include <icmm.h>


HH_ret_t
XHH_mapm_create(XHH_icm_va_t tbl_base, 
            u_int8_t log2_tbl_sz, 
            u_int8_t log2_blk_sz, 
            u_int8_t log2_entry_sz, 
            XHH_hob_t hob,
            u_int32_t num_reserved_rsc,
            XHH_mapm_t* p_mapm
           );

HH_ret_t
XHH_mapm_destroy(XHH_mapm_t mapm);

HH_ret_t 
XHH_mapm_alloc_rsc( XHH_mapm_t mapm, 
                u_int32_t rsc_idx);

HH_ret_t 
XHH_mapm_alloc_rscs(XHH_mapm_t mapm,u_int32_t rsc_idx, u_int32_t num_of_rscs);

HH_ret_t 
XHH_mapm_free_rsc(XHH_mapm_t mapm, u_int32_t rsc_idx);

HH_ret_t 
XHH_mapm_free_rscs(XHH_mapm_t mapm, u_int32_t rsc_idx, u_int32_t num_of_rscs);

HH_ret_t
XHH_mapm_alloc_all(XHH_icm_va_t tbl_base,
                   u_int8_t log2_tbl_sz,
                   u_int8_t log2_entry_sz,
                   XHH_hob_t hob,
                   XHH_mapm_t* p_mapm);

HH_ret_t
XHH_mapm_free_all(XHH_mapm_t mapm);

HH_ret_t 
XHH_mapm_rscs_map(XHH_mapm_t mapm, u_int32_t rsc_start_idx, u_int32_t num_of_rscs,
		 XHH_icmm_kernel_map_t *kernel_map_p);

void 
XHH_mapm_rscs_unmap(XHH_mapm_t mapm, XHH_icmm_kernel_map_t kernel_map);

#endif

