/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHH_MEM_UTILS_H
#define H_XHH_MEM_UTILS_H

#include <cmdif.h>

typedef enum {
    XHH_MEM_ALLOC_FLAGS_NONE = 0,
    XHH_MEM_ALLOC_FLAGS_SINGLE_BLOCK = (1<<0)
} XHH_mem_alloc_flags_t;

HH_ret_t  XHH_phys_mem_alloc(/*IN*/   u_int64_t               size,
                             /*IN*/   MT_u_int_t              log2_align,
                             /*IN*/   MOSAL_mem_alloc_flags_t flags,
                             /*IN*/   XHH_mem_alloc_flags_t   xhh_flags, /*force single block */
                             /*OUT*/  MOSAL_phys_ctg_t        **mem_vec_pp,
                             /*OUT*/  u_int16_t               *mem_vec_size_p);

HH_ret_t  XHH_phys_mem_free (/*IN*/ MOSAL_phys_ctg_t       *mem_vec_p,
                             /*IN*/ u_int32_t              mem_vec_size);

HH_ret_t  XHH_build_pa_vec(/*IN*/  MOSAL_phys_ctg_t  *mem_vec_p,
                           /*IN*/  u_int32_t         pa_vec_size,
                           /*OUT*/ XHH_cmd_pa_vec_t  *pa_vec_p); 

HH_ret_t XHH_build_lamm_pa_vec(/*IN*/  MT_phys_addr_t lam_addr,
                               /*IN*/  u_int64_t size,
                               /*OUT*/ u_int32_t *pa_vec_size_p, 
                               /*OUT*/ XHH_cmd_pa_vec_t  **pa_vec_pp);

HH_ret_t  XHH_phys_mem_pattern_initialize (/*IN*/ MOSAL_phys_ctg_t    *mem_vec_p,
                             /*IN*/ u_int32_t           mem_vec_size);
#endif

