/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef CI_XHH_DEV_SRQM_CI
#define CI_XHH_DEV_SRQM_CI

inline static HH_ret_t dev_specific_srqm_create_srq(XHH_srqm_t  srqm, 
                                                  XHH_srq_ul_resources_t*  srq_ul_resources_p,
                                                  u_int32_t  srqn,
                                                  XHH_srq_t new_srq_p)
{
    HH_ret_t rc;
    u_int32_t rcv_db_record_index;
    void * recvq_db_record_va;
    
    FUNC_IN;
    rc= XHH_mapm_alloc_rsc(srqm->mapm,srqn);    
    if (rc != HH_OK) {  
	MT_RETURN(rc);
    }
    
    /* allocate doorbell records for receive doorbell */

    rc =  XHH_uarm_alloc_db_record( srqm->uarm, 
                                    srq_ul_resources_p->uar_index, 
                                    UARM_DBRECORD_RECEIVE,
                                    &rcv_db_record_index,
                                    &recvq_db_record_va);
    if (rc!= HH_OK) {
	XHH_mapm_free_rsc(srqm->mapm,srqn);
	MT_RETURN(rc);
    }

    new_srq_p->uar_index = srq_ul_resources_p->uar_index;
    new_srq_p->rcv_db_record_index = rcv_db_record_index;
    srq_ul_resources_p->recvq_db_record_p = (MT_virt_addr_t) recvq_db_record_va;

    MT_RETURN(HH_OK);
}

#endif
