/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHHUL_PDM_H
#define H_XHHUL_PDM_H

#include <mtl_common.h>
#include <hh.h>
#include <hhul.h>
#include <ul.h>

HH_ret_t XHHUL_pdm_create (
  /*IN*/ XHHUL_hob_t hob, 
  /*OUT*/ XHHUL_pdm_t *pdm_p
);

HH_ret_t XHHUL_pdm_destroy (/*IN*/ XHHUL_pdm_t pdm);

HH_ret_t XHHUL_pdm_alloc_pd_avs_prep (
   HHUL_hca_hndl_t hca, 
   u_int32_t max_num_avs,
   HH_pdm_pd_flags_t pd_flags,
   HHUL_pd_hndl_t *pd_p, 
   void *pd_ul_resources_p 
);

HH_ret_t XHHUL_pdm_alloc_pd_done (
  /*IN*/ HHUL_hca_hndl_t hca, 
  /*IN*/ HHUL_pd_hndl_t hhul_pd, 
  /*IN*/ HH_pd_hndl_t hh_pd, 
  /*IN*/ void/*XHH_pd_ul_resources_t*/ *pd_ul_resources_p 
);

HH_ret_t XHHUL_pdm_free_pd_prep (
  /*IN*/HHUL_hca_hndl_t hca, 
  /*IN*/HHUL_pd_hndl_t hhul_pd,
  /*IN*/MT_bool        undo_flag 
);

HH_ret_t XHHUL_pdm_free_pd_done (
  /*IN*/ HHUL_hca_hndl_t hca, 
  /*IN*/ HHUL_pd_hndl_t hhul_pd 
);


HH_ret_t XHHUL_pdm_get_hh_pd (
   XHHUL_pdm_t  pdm,
   HHUL_pd_hndl_t hhul_pd, 
   HH_pd_hndl_t *hh_pd);


HH_ret_t XHHUL_pdm_get_hh_pd_hold_ul_pd (
   XHHUL_pdm_t  pdm,
   HHUL_pd_hndl_t hhul_pd, 
   HH_pd_hndl_t *hh_pd);

HH_ret_t XHHUL_pdm_rel_ul_pd(
   XHHUL_pdm_t  pdm,
   HHUL_pd_hndl_t hhul_pd);

#endif /* H_XHHUL_PDM_H */

