/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHHUL_PDM_PRIV_H
#define H_XHHUL_PDM_PRIV_H

#include <mtl_common.h>
#include <cr_types.h>
#include <ul_pdm.h>
#include <xhh.h>
#include <ul_hob.h>
#include <vip_array.h>
#include <vip_hashp2p.h>
#include <mosal.h>

/* allocate initially space for 16 PDs for user-space processes, and 256 for kernel-space */
/* ----- OS-dependent implementation ----- */
#ifndef MT_KERNEL
#define XHHUL_PDM_INITIAL_NUM_PDS  16
#else
#define XHHUL_PDM_INITIAL_NUM_PDS  256
#endif

struct XHHUL_pdm_st {
    VIP_array_p_t   pd_array;
} ;

#endif /* H_XHHUL_PDM_H */

