/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#if !defined(H_SRQM_PRIV_H)
#define H_SRQM_PRIV_H

struct XHH_srqm_st {
  VIP_array_p_t srq_array;
  XHH_hob_t              hob;
  XHH_cmd_t              cmdif;
  XHH_mrwm_t             mrwm;
  u_int32_t              max_srq;  /* Excluding reserved */
  u_int32_t              rsvd_srq; /* Offset of first user SRQ from SRQC table base */

  XHH_DEV_SPECIFIC_SRQM_DATA
  
};

typedef struct XHH_srq_st {
  VAPI_lkey_t     lkey;
  XHH_DEV_SPECIFIC_SRQ_DATA
  /* No need for anything more for SRQ destruction. Still, VIP_array requires an "object" */
} *XHH_srq_t;


#endif
