/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#include <cmdif_priv.h>
#include <cmdif.h>
#include <mosal.h>
#include <cmdif_priv_defs.h>
#include <dev_cmds_wrap.h>

const char *str_XHH_cmd(tavor_if_cmd_t opcode)
{
  switch ( opcode ) {
    case TAVOR_IF_CMD_SYS_EN:
      return "TAVOR_IF_CMD_SYS_EN";
    case TAVOR_IF_CMD_SYS_DIS:
      return "TAVOR_IF_CMD_SYS_DIS";
    case TAVOR_IF_CMD_QUERY_DEV_LIM:
      return "TAVOR_IF_CMD_QUERY_DEV_LIM";
    case TAVOR_IF_CMD_QUERY_FW:
      return "TAVOR_IF_CMD_QUERY_FW";
    case TAVOR_IF_CMD_QUERY_DDR:
      return "TAVOR_IF_CMD_QUERY_DDR";
    case TAVOR_IF_CMD_QUERY_ADAPTER:
      return "TAVOR_IF_CMD_QUERY_ADAPTER";
    case TAVOR_IF_CMD_INIT_HCA:
      return "TAVOR_IF_CMD_INIT_HCA";
    case TAVOR_IF_CMD_CLOSE_HCA:
      return "TAVOR_IF_CMD_CLOSE_HCA";
    case TAVOR_IF_CMD_INIT_IB:
      return "TAVOR_IF_CMD_INIT_IB";
    case TAVOR_IF_CMD_CLOSE_IB:
      return "TAVOR_IF_CMD_CLOSE_IB";
    case TAVOR_IF_CMD_QUERY_HCA:
      return "TAVOR_IF_CMD_QUERY_HCA";
    case TAVOR_IF_CMD_SET_IB:
      return "TAVOR_IF_CMD_SET_IB";
    case TAVOR_IF_CMD_SW2HW_MPT:
      return "TAVOR_IF_CMD_SW2HW_MPT";
    case TAVOR_IF_CMD_QUERY_MPT:
      return "TAVOR_IF_CMD_QUERY_MPT";
    case TAVOR_IF_CMD_HW2SW_MPT:
      return "TAVOR_IF_CMD_HW2SW_MPT";
    case TAVOR_IF_CMD_READ_MTT:
      return "TAVOR_IF_CMD_READ_MTT";
    case TAVOR_IF_CMD_WRITE_MTT:
      return "TAVOR_IF_CMD_WRITE_MTT";
    case TAVOR_IF_CMD_MAP_EQ:
      return "TAVOR_IF_CMD_MAP_EQ";
    case TAVOR_IF_CMD_SW2HW_EQ:
      return "TAVOR_IF_CMD_SW2HW_EQ";
    case TAVOR_IF_CMD_HW2SW_EQ:
      return "TAVOR_IF_CMD_HW2SW_EQ";
    case TAVOR_IF_CMD_QUERY_EQ:
      return "TAVOR_IF_CMD_QUERY_EQ";
    case TAVOR_IF_CMD_SW2HW_CQ:
      return "TAVOR_IF_CMD_SW2HW_CQ";
    case TAVOR_IF_CMD_HW2SW_CQ:
      return "TAVOR_IF_CMD_HW2SW_CQ";
    case TAVOR_IF_CMD_QUERY_CQ:
      return "TAVOR_IF_CMD_QUERY_CQ";
    case TAVOR_IF_CMD_RST2INIT_QPEE:
      return "TAVOR_IF_CMD_RST2INIT_QPEE";
    case TAVOR_IF_CMD_INIT2RTR_QPEE:
      return "TAVOR_IF_CMD_INIT2RTR_QPEE";
    case TAVOR_IF_CMD_RTR2RTS_QPEE:
      return "TAVOR_IF_CMD_RTR2RTS_QPEE";
    case TAVOR_IF_CMD_RTS2RTS_QPEE:
      return "TAVOR_IF_CMD_RTS2RTS_QPEE";
    case TAVOR_IF_CMD_SQERR2RTS_QPEE:
      return "TAVOR_IF_CMD_SQERR2RTS_QPEE";
    case TAVOR_IF_CMD_2ERR_QPEE:
      return "TAVOR_IF_CMD_2ERR_QPEE";
    case TAVOR_IF_CMD_RTS2SQD_QPEE:
      return "TAVOR_IF_CMD_RTS2SQD_QPEE";
    case TAVOR_IF_CMD_SQD2RTS_QPEE:
      return "TAVOR_IF_CMD_SQD2RTS_QPEE";
    case TAVOR_IF_CMD_ERR2RST_QPEE:
      return "TAVOR_IF_CMD_ERR2RST_QPEE";
    case TAVOR_IF_CMD_QUERY_QPEE:
      return "TAVOR_IF_CMD_QUERY_QPEE";
    case TAVOR_IF_CMD_CONF_SPECIAL_QP:
      return "TAVOR_IF_CMD_CONF_SPECIAL_QP";
    case TAVOR_IF_CMD_MAD_IFC:
      return "TAVOR_IF_CMD_MAD_IFC";
    case TAVOR_IF_CMD_READ_MGM:
      return "TAVOR_IF_CMD_READ_MGM";
    case TAVOR_IF_CMD_WRITE_MGM:
      return "TAVOR_IF_CMD_WRITE_MGM";
    case TAVOR_IF_CMD_MGID_HASH:
      return "TAVOR_IF_CMD_MGID_HASH";
    case TAVOR_IF_CMD_CONF_NTU:
      return "TAVOR_IF_CMD_CONF_NTU";
    case TAVOR_IF_CMD_QUERY_NTU:
      return "TAVOR_IF_CMD_QUERY_NTU";
    case TAVOR_IF_CMD_RESIZE_CQ:
      return "TAVOR_IF_CMD_RESIZE_CQ";
    case TAVOR_IF_CMD_SUSPEND_QPEE:
      return "TAVOR_IF_CMD_SUSPEND_QPEE";
    case TAVOR_IF_CMD_UNSUSPEND_QPEE:
      return "TAVOR_IF_CMD_UNSUSPEND_QPEE";
    case TAVOR_IF_CMD_SW2HW_SRQ:
      return "TAVOR_IF_CMD_SW2HW_SRQ";
    case TAVOR_IF_CMD_HW2SW_SRQ:
      return "TAVOR_IF_CMD_HW2SW_SRQ";
    case TAVOR_IF_CMD_QUERY_SRQ:
      return "TAVOR_IF_CMD_QUERY_SRQ";
    default:
      return "[UNKNOWN_COMMAND]";
  }
}

/*
 *  sys_en_hca
 */
static XHH_cmd_status_t sys_en_hca(struct cmd_if_context_st *entry)
{
  u_int32_t token = 0, i, dw6;
  XHH_cmd_status_t rc;

  FUNC_IN;
  MOSAL_mutex_acq_ui(&entry->sys_en_mtx);
  if ( entry->sys_enabled ) {
    MOSAL_mutex_rel(&entry->sys_en_mtx);
    MT_RETURN(XHH_CMD_STAT_OK); /* already enabled */
  }
  if ( !XHH_cmd_cmdif_is_free(entry) ) {
    MOSAL_mutex_rel(&entry->sys_en_mtx);
    /* no need to call the hob at this early stage - just return XHH_CMD_STAT_EFATAL */
    MT_RETURN(XHH_CMD_STAT_EFATAL);
  }

  PREP_TOKEN_DW(token, DEFAULT_TOKEN);

  MOSAL_MMAP_IO_WRITE_DWORD((u_int8_t *)(entry->hcr_virt_base)+HCR_DW_BYTE_OFFSET(token), token);

  write_command_dw(&dw6, 1, 0, 0, TAVOR_IF_CMD_SYS_EN);
  MOSAL_MMAP_IO_WRITE_DWORD(((u_int32_t *)(entry->hcr_virt_base))+6, dw6);
  for ( i=0; i<(TAVOR_IF_CMD_ETIME_SYS_EN/10000); ++i ) {
    MOSAL_delay_execution(10000);
    if ( XHH_cmd_cmdif_is_free(entry) ) {
      MTL_TRACE1("command executed in %d mili seconds\n", i*10);
      break;
    }
  }
  if ( !XHH_cmd_cmdif_is_free(entry) ) {
    MOSAL_mutex_rel(&entry->sys_en_mtx);
    /* no need to call the hob at this early stage - just return XHH_CMD_STAT_EFATAL */
    MT_RETURN(XHH_CMD_STAT_ETIMEOUT);
  }
  rc = cmd_if_status(entry);
  if ( rc == XHH_CMD_STAT_OK ) {
    entry->sys_enabled = TRUE;
  }
  MOSAL_mutex_rel(&entry->sys_en_mtx);
  MT_RETURN(rc);
}


/*
 *  cmd_invoke
 */
XHH_cmd_status_t cmd_invoke(XHH_cmd_t cmd_if, command_fields_t *cmd_prms)
{
  struct cmd_if_context_st *entry = (struct cmd_if_context_st *)cmd_if;
  XHH_cmd_status_t rc;

  FUNC_IN;

  if ( entry->have_fatal && ((cmd_prms->input_modifier==0) || (cmd_prms->opcode!=ADD_DEV_PREFIX(IF_CMD_CLOSE_HCA))) ) {
    MT_RETURN(XHH_CMD_STAT_EFATAL);
  }

  if (entry->sys_enabled == FALSE ) {
    /* sys not enabled - we only allow sys enable cmd */
    if ( cmd_prms->opcode != TAVOR_IF_CMD_SYS_EN ) {
      MT_RETURN(XHH_CMD_STAT_EAGAIN);
    }
    else {
      rc = sys_en_hca(entry);
      MT_RETURN(rc);
    }
  }
  else {
    /* system enabled */
    if ( cmd_prms->opcode == TAVOR_IF_CMD_SYS_EN ) {
      /* we don't allow re-invoking sys enable */
      MT_RETURN(XHH_CMD_STAT_BAD_SYS_STATE);
    }
    else {
      rc = XHH_cmd_main_flow(entry, cmd_prms);
      if ( rc != XHH_CMD_STAT_OK ) {
        MTL_ERROR1(MT_FLFMT("Failed command 0x%X (%s): status=0x%X (%s)\n"), 
                   cmd_prms->opcode, str_XHH_cmd(cmd_prms->opcode),rc,str_XHH_cmd_status_t(rc));
      }
      MT_RETURN(rc);
    }
  }
}


/*
 *  XHH_cmd_SYS_EN
 */
XHH_cmd_status_t XHH_cmd_SYS_EN(IN XHH_cmd_t cmd_if)
{
  command_fields_t cmd_prms = {0};
  XHH_cmd_status_t rc;

  FUNC_IN;
  cmd_prms.opcode = TAVOR_IF_CMD_SYS_EN;
  cmd_prms.in_trans = TRANS_NA;
  cmd_prms.out_trans = TRANS_NA;
  rc = cmd_invoke(cmd_if, &cmd_prms);
  if ( rc != XHH_CMD_STAT_OK ) {
    MTL_ERROR1("%s\n", str_XHH_cmd_status_t(rc));
  }
  MT_RETURN(rc);
}


/*
 *  alloc_prm_ctx
 */
HH_ret_t alloc_prm_ctx(struct cmd_if_context_st *entry,
                              prms_buf_t *prm_p,
                              MT_size_t buf_sz
                              )
{
	MT_phys_addr_t pa;
	MT_size_t alloc_sz;
	MT_virt_addr_t alloc_va, va;
	call_result_t mrc;

	/* params put in main memory */
	alloc_sz = buf_sz + (1<<PRM_ALIGN_SHIFT) - 1;
	alloc_va = (MT_virt_addr_t)MOSAL_pci_phys_alloc_consistent(alloc_sz, PRM_ALIGN_SHIFT);
	if ( !alloc_va ) {
	  return HH_EAGAIN;
	}
	va = MT_UP_ALIGNX_VIRT(alloc_va, PRM_ALIGN_SHIFT);
	mrc = MOSAL_virt_to_phys(MOSAL_get_kernel_prot_ctx(), va, &pa);
	if ( mrc != MT_OK ) {
	  MOSAL_pci_phys_free_consistent((void *)(MT_ulong_ptr_t)alloc_va, alloc_sz);
	  return HH_ERR;
	}

	prm_p->prm_alloc_va = alloc_va;
	prm_p->prm_base_va = va;
	prm_p->prm_base_pa = pa;
	prm_p->prm_buf_sz = alloc_sz;
	prm_p->allocated = 1;

	return HH_OK;
}


/*
 *  de_alloc_prm_ctx
 */
HH_ret_t de_alloc_prm_ctx(struct cmd_if_context_st *entry,
                                 prms_buf_t *prms_p)
{
	MOSAL_pci_phys_free_consistent((void *)(MT_ulong_ptr_t)(prms_p->prm_alloc_va), prms_p->prm_buf_sz);
	return HH_OK;
}

