/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHH_DEV_SRQM_H
#define H_XHH_DEV_SRQM_H

#include <uldm.h>

#define XHH_DEV_SPECIFIC_SRQM_INIT_PARAMS

#define XHH_DEV_SPECIFIC_SRQM_DATA \
        XHH_uldm_t  prot_module;

#define XHH_DEV_SPECIFIC_SRQ_DATA

#define XHH_DEV_SPECIFIC_SRQM_INIT
#define XHH_DEV_SPECIFIC_SRQM_DONE

#define XHH_DEV_SPECIFIC_SRQM_CREATE_SRQ_FAIL_LABEL 

#define XHH_DEV_SPECIFIC_SRQM_CREATE_SRQ \
        xhh_srqc.uar= srq_ul_resources_p->uar_index;                                   \
        xhh_srqc.ds= (u_int32_t)(srq_ul_resources_p->wqe_sz >> 4); /* 16B chunks */    \
        if (xhh_srqc.ds > 0x3F)                                                        \
          xhh_srqc.ds=0x3F; /* Stride may be 1024, but max WQE size is 1008 (ds is 6bit) */

#define XHH_DEV_SPECIFIC_SRQM_DESTROY_SRQ

#define XHH_DEV_SPECIFIC_SRQM_GET_PROT_MODULE\
        XHH_hob_get_uldm(hob, &(*srqm_p)->prot_module);

#endif
