/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#if !defined(H_DEV_UDAV_H)
#define H_DEV_UDAV_H


/************************************************************************
 *  Function: XHH_udavm_create
 *  
 *  Arguments:
 *  version_p - Version information (see ...) 
 *  ud_av_table_memkey
 *  ud_av_table 
 *  ud_av_table ud_av_table_sz
 *  uadvm_p - Allocated object 
 *  
 *  Returns:
 *  HH_OK 
 *  HH_EINVAL -Invalid parameters (NULLs) 
 *  HH_EAGAIN -Not enough resources to allocate object 
 *
 *  Description: 
 *  Create the XHH_udavm_t class instance. 
 ************************************************************************/
 
extern HH_ret_t XHH_udavm_create( /*IN */ XHH_ver_info_t *version_p, 
                                  /*IN */ VAPI_lkey_t ud_av_table_memkey, 
                                  /*IN */ MT_virt_addr_t ud_av_table, 
                                  /*IN */ MT_size_t ud_av_table_sz,
                                  /*OUT*/ XHH_udavm_t *udavm_p);


#define UDAVM_HCA_HNDL XHH_udavm_t
#define UDAVM_PD_HNDL HH_pd_hndl_t
#define UDAVM_AV_HNDL HH_ud_av_hndl_t


#endif
