/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHHUL_CQM_DEV_H
#define H_XHHUL_CQM_DEV_H

#include <uar.h>

#define XHH_DEV_SPECIFIC_UL_CQ_T_FIELDS \
  XHH_uar_t uar;
  
#define XHH_DEV_SPECIFIC_CREATE_CQ_DONE
  
#define XHH_DEV_RESIZE_COUNTER_INIT_VAL(val,mask) \
        ((val) & (mask))

#define XHH_DEV_CHECK_CQE_STATE(cq_p, cur_cqe, cqe_num) \
	( (!is_cqe_hw_own(cur_cqe)) || (count_cqes(cq_p,cqe_num,NULL) >= cqe_num)) ? HH_OK : HH_CQ_EMPTY 
#endif /* H_XHHUL_CQM_H */

#define  XHH_DEV_FREE_CQE \
	{                                                                                                           \
	    u_int32_t dbd_cnt;											    \
	    dbd_cnt= MT_EXTRACT_ARRAY32(cqe_cpy,CQE_ERROR_DBDCNT_BIT_OFFSET, CQE_ERROR_DBDCNT_BIT_SIZE);	    \
	    if ((next_wqe_addr_32lsb == XHHUL_QPM_END_OF_WQE_CHAIN) ||    /* End of WQE chain */		    \
		    ((dbd_cnt + 1 - dbd_bit) == 0) )                       {  /* or dbd counter reached 0 */	    \
		  if ((next_wqe_addr_32lsb == XHHUL_QPM_END_OF_WQE_CHAIN) && (dbd_cnt > 0)) {			    \
		  MTL_ERROR1(MT_FLFMT("%s: CQ[0x%X]:CQE[0x%X]: Reached end of chain while dbd_cnt==%u"),	    \
		    __func__, xhhul_cq_p->cq_num, 								    \
		    (xhhul_cq_p->cur_buf.consumer_counter& MASK32(xhhul_cq_p->cur_buf.log2_num_o_cqes)), dbd_cnt);  \
		  }												    \
		  MTPERF_TIME_START(free_cqe);									    \
		  free_cqe(xhhul_cq_p,cur_cqe); /* Free original CQE and update consumer index */		    \
		  MTPERF_TIME_END(free_cqe);									    \
	    } else {												    \
		    recycle_cqe(cur_cqe, next_wqe_addr_32lsb, dbd_cnt - dbd_bit);				    \
	    } 													    \
	}

