/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/


#ifndef H_EVENTP_DEV_FUNCS_H
#define H_EVENTP_DEV_FUNCS_H

#include <eventp_priv.h>
#include <uar.h>
#include <cmd_types.h>


static inline HH_ret_t init_eventp_dev(XHH_eventp_t eventp,
				       XHH_eventp_res_t *event_res_p)
{
	eventp->kar = event_res_p->kar;
	return(XHH_uar_get_index(eventp->kar, &eventp->kar_index));
}

static inline HH_ret_t init_eq_dev(XHH_eventp_t eventp,
				   XHH_eqc_t    *eq_context,
				   EQP_eq_entry_t *new_eq)
{
	return(XHH_uar_get_index(eventp->kar, &eq_context->usr_page));
}                             

static inline HH_ret_t init_dev_regs(XHH_eventp_t eventp,
				     XHH_eventp_res_t *eventp_res)
{
	return HH_OK;
}


static inline void remove_dev_regs(XHH_eventp_t eventp)
{
	return;
}


#define DISARM_CQ(eventp, eq_num, cqnum)\
	XHH_uar_eq_cmd(eventp->kar, TAVOR_IF_UAR_EQ_DISARM_CQ, eq_num, cqnum)

/* these macros need to be different because of Arbel */
#define RE_ARM_EQ(eventp, eq_num, mask_val) \
	XHH_uar_eq_cmd(eventp->kar, TAVOR_IF_UAR_EQ_INT_ARM, eq_num, 0)
	
#define ARM_EQ_AT_END(eventp, eq_num)\
	XHH_uar_eq_cmd(eventp->kar, TAVOR_IF_UAR_EQ_INT_ARM, eq_num, 0)
	
#define EQ_UPDATE_CONS_CNTR(eventp, eqe_p) \
	XHH_uar_eq_cmd(eventp->kar, TAVOR_IF_UAR_EQ_INC_CI, eqe_p->eqn, 0)

#define ARM_EQS(eventp, mask_val) 

#define OVERRUN_CHECK(label) \
if (eqe.event_type == TAVOR_IF_EV_TYPE_OVERRUN) { 	            \
	MTL_ERROR1("%s: EQ OVERRUN eqn=%d\n", __func__, eqe_p->eqn);\
	/* need to notify the hob for the fatal error */	        \
	eqe_p->eventp_p->have_fatal = TRUE;			                \
	XHH_hob_fatal_error(eqe_p->eventp_p->hob, XHH_FATAL_EQ_OVF, \
			    VAPI_CATAS_ERR_EQ_OVERFLOW);	                \
	goto label;						        		        \
}

#define OVERRUN_CHECK_FAILURE(label)		label:    
#endif

