/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHH_DEV_QPM_H
#define H_XHH_DEV_QPM_H

#include <tavor_if_defs.h>
#include <uldm.h>

#define XHH_DEV_SPECIFIC_QPM_INIT_PARAMS

#define XHH_DEV_SPECIFIC_QPM_DATA \
        XHH_uldm_t       prot_module;
        
#define XHH_DEV_SPECIFIC_QPC_ENTRY_DATA
#define XHH_DEV_SPECIFIC_QPM_INIT
#define XHH_DEV_SPECIFIC_QPM_DONE

#define XHH_DEV_SPECIFIC_QPM_CREATE_QP_SRQ_CHECK \
      if ((init_attr_p->srq != HH_INVAL_SRQ_HNDL) && (init_attr_p->ts_type != VAPI_TS_RC)) { \
	/* SRQs are supported only for RC QPs in Tavor and Arbel*/                           \
	MTL_ERROR2(MT_FLFMT("%s: SRQ association with transport service type %s(%d)"         \
			    " - only RC QPs are allowed with SRQs."),                        \
		   __func__, VAPI_ts_type_sym(init_attr_p->ts_type), init_attr_p->ts_type);  \
	return HH_ENOSYS;								     \
      }

#define XHH_DEV_SPECIFIC_QPM_CREATE_QP(qpix,qp_p)
#define XHH_DEV_SPECIFIC_QPM_CREATE_SQP(qpix,qp_p)
#define XHH_DEV_SPECIFIC_CREATE_QP_UL_RES
#define XHH_DEV_SPECIFIC_QPM_DESTROY_QP

#define XHH_DEV_SPECIFIC_QPM_GET_PROT_MODULE\
        XHH_hob_get_uldm(hob, &qpm->prot_module)

#define XHH_DEV_SPECIFIC_QPM_INIT_WQE_BASE\
        qpc_p->wqe_base_adr = (sizeof(MT_virt_addr_t) <= 4 \
                         ? (u_int32_t)0\
                         : (u_int32_t)(((u_int64_t)qp_p->wqes_buf) >> 32));
  



#endif
