/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#ifndef H_XHH_PRIV_H
#define H_XHH_PRIV_H

#define XHH_VMALLOC_THRESHOLD (2*MOSAL_SYS_PAGE_SIZE)

#define XHH_SMART_MALLOC(size) ({                                          \
                                  void *p;                                 \
                                  if ( (size) > XHH_VMALLOC_THRESHOLD ) {  \
                                    p = VMALLOC(size);                  \
                                  }                                     \
                                  else {                                \
                                    p = MALLOC(size);                   \
                                  }                                     \
                                  p;                                    \
                               })




#define XHH_SMART_FREE(ptr,size) do {                                      \
                                   if ( (size) > XHH_VMALLOC_THRESHOLD )   {  \
                                     VFREE(ptr);                           \
                                   }                                       \
                                   else {                                  \
                                     FREE(ptr);                            \
                                   }                                       \
                                 }                                         \
                                 while(0)


#if defined(MT_KERNEL)
#define MT_IF_PCI_PHYS_ALLOC_CONSISTENT_FAILED	\
    if (bsize <= WQ_KMALLOC_LIMIT) { /* Consider using low memory (kmalloc) up to WQ_KMALLOC_LIMIT or for small vmalloc area */	\
      buf[i]= (void*)MOSAL_pci_phys_alloc_consistent(bsize,0); /* try to use kmalloc */	 \
      used_virt_alloc[i]= FALSE;	\
    }  \
    if (buf[i] == NULL)  /* failed kmalloc, or did not even try it */
#else			
#define MT_IF_PCI_PHYS_ALLOC_CONSISTENT_FAILED	
#endif

#endif


