/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/
#ifndef H_HHUL_OBJ_H
#define H_HHUL_OBJ_H

typedef struct {
	MT_virt_addr_t addr;
	MT_virt_addr_t len;
	VAPI_lkey_t lkey;
} HHUL_sg_lst_entry_t;

/* Receive Request WQE */
typedef struct HH_rr_wqe_st {
	VAPI_wr_id_t id;	/* ID provided by the user */

	MT_virt_addr_t next;	/* next wqe in struct */

	VAPI_comp_type_t comp_type;	/* Mellanox Specific {VAPI_SIGNALED, VAPI_UNSIGNALED} */
	u_int32_t total_len;	/* Current s/g list length - need to calculate it     */

	u_int32_t sg_lst_len;
	HHUL_sg_lst_entry_t sg_lst_p[1];	/* TBD is this ok to define it this way */

	/* here comes the data ...
	 * malloc(sizeof(GHQPC_rr_wqe_t)+[sg_lst_len-1]*sizeof(VAPI_sg_lst_entry_t)) 
	 */
} HHUL_rr_wqe_t;

struct HHUL_hca_obj {
	HH_hca_hndl_t hca_hndl;

	HHUL_qp_obj_st *qp_head;
	HHUL_cq_obj_st *cq_head;

	/* TBD - Add support for address vector image */
	/* TBD - Add support for RDD                  */

} HHUL_hca_obj_t;

#endif				/* H_HHUL_OBJ_H */
