/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

#include <linux/kernel.h>
#include <linux/module.h>
#include <vapi_common.h>
#include <vip.h>
#include <vipkl.h>
#if LINUX_KERNEL_2_6
#include <linux/moduleparam.h>
#endif

/* hca handle.  Default is zero */
static int  hca_hndl = 0;
#if LINUX_KERNEL_2_6
	module_param(hca_hndl, int, 0444);
	MODULE_PARM_DESC(hca_hndl, "hca handle to use");
#else
	MODULE_PARM(hca_hndl,"i");
#endif


int init_module(void)
{
       VIP_ret_t rc;
       VIPKL_debug_info_t debug_info;

       rc = VIPKL_get_debug_info((VIP_hca_hndl_t) hca_hndl, &debug_info);
       if (rc != VIP_OK) {
	   return(-1);
       }

       MTL_ERROR1("Debug Info:  allocated_hca_handles = %u\n"
		  "   allocated_pd = %u\n"
		  "   allocated_cq = %u\n"
		  "   allocated_qp = %u\n"
		  "   allocated_mr = %u\n"
		  "   allocated_fmr = %u\n"
		  "   allocated_devmm_chunks = %u\n",
		  debug_info.allocated_hca_handles, debug_info.allocated_pd,
		  debug_info.allocated_cq,debug_info.allocated_qp,debug_info.allocated_mr,
		  debug_info.allocated_fmr,debug_info.allocated_devmm_chunks);

       // return(
//	    debug_info.allocated_hca_handles + debug_info.allocated_pd +
//	    debug_info.allocated_cq + debug_info.allocated_qp + debug_info.allocated_mr +
//	    debug_info.allocated_fmr + debug_info.allocated_devmm_chunks);
        return(-1);
}

void cleanup_module(void)
{
}
