#ifndef __TYPES_H__
#define __TYPES_H__


#define CQ_SIZE                 4      /* we need a small CQ */

#define DEF_GRH_FLAG            0
#define DEF_PSN                 1       /* start psn */

#define DEF_PKEY_IX				0
#define DEF_QP_TIMEOUT			0xf		/* Transport Retry Timeout 4us*2 pow VALUE */
#define DEF_RETRY_COUNT			0x4		/* Max Number of Transport Retryes */
#define DEF_RNR_RETRY			2		/* Number of RNR retryes in Requestor */
#define DEF_MIN_RNR_TIMER		0x2		/* Min RNR Time in RNR NAK (RQPC: rnr_nak_timeout_val) */
#define DEF_QP_OUS_RD_ATOM		4
#define DEF_STATIC_RATE         0
#define DEF_SRC_PATH_BITS       0
#define DEF_SL					0		/* Service Level */

#define MR_SIZE 100000

/* structure of test configuration */
typedef struct 
{
	VAPI_hca_id_t		hca_id;
    int 	            is_daemon;
    u_int32_t           tcp_port;
	char*	            ip;
    IB_port_t 		    ib_port;
    IB_port_t 		    alt_ib_port;
} config_t;

/* a structure to holh all of the handles and props of IB objects */
typedef struct 
{
    VAPI_hca_hndl_t             hca_hndl;
    VAPI_hca_cap_t              hca_cap;
    VAPI_hca_port_t             hca_port;
    VAPI_hca_port_t             alt_hca_port;
    VAPI_pd_hndl_t              pd_hndl;
    VAPI_cq_hndl_t              cq_hndl;
    VAPI_cqe_num_t              cq_size;
    VAPI_qp_hndl_t              qp_hndl;
    VAPI_qp_prop_t              qp_prop;
    EVAPI_async_handler_hndl_t  async_handler_hndl;
    VAPI_mr_hndl_t              mr_hndl;
    void                        *buf_ptr;
    VAPI_mrw_t                  rep_mrw;
    int                         sockfd;
} resources_t;

/* structure of data that will be exchanged betwen the two sides to emulate the CM operation */
#ifdef __WIN__
#pragma pack(push, 1)   /*  packing is now 1 */
#endif
struct connection_data_t
{
    IB_lid_t                lid;
    IB_lid_t                alt_lid;
    IB_wqpn_t               qp_num;
    IB_rkey_t               rkey;
    IB_virt_addr_t          start;
} __attribute__ ((packed));
#ifdef __WIN__
#pragma pack(pop)               /*  return to default packing */
#endif

#endif
