/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/

/***
 *** This file was generated at "Sat Feb  1 17:36:07 2003"
 *** by:
 ***    % csp_bf -copyright=x -both mad_port_counters.csp
 ***/

#ifndef H_both_mad_port_counters_csp_H
#define H_both_mad_port_counters_csp_H


#if defined (_BIG_ENDIAN)




struct mad_pcounters {	/* Big Endian */
    unsigned int	BaseVersion:8;         /* Version of MAD base format. This shall be 1 */
    unsigned int	MgmtClass:8;           /* 0x4 - Performance Management Class */
    unsigned int	ClassVersion:8;        /* 1 */
    unsigned int	R:1;                   /* Response bit. */
    unsigned int	Method:7;              /* 1 - Get; 2 - Set; 0x81 - GetResp */
/* -------------- */
    unsigned int	Status:16;
    unsigned int	ClassSpecific:16;      /* This field is reserved except for the Subnet Management class */
/* -------------- */
    unsigned int	TransactionID__63_32;
/* -------------- */
    unsigned int	TransactionID__31_0;
/* -------------- */
    unsigned int	AttributeID:16;        /* 0x12 - PortCounters */
    unsigned int	reserved0:16;
/* -------------- */
    unsigned int	AttributeModifier;
/* -------------- */
    unsigned char	reserved1[40];
/* -------------- */
    unsigned int	reserved2:8;
    unsigned int	PortSelect:8;          /* Port Number */
    unsigned int	CounterSelect:16;      /* mask; when reading, this is ingnored */
/* -------------- */
    unsigned int	SymbolErrorCounter:16;
    unsigned int	LinkErrorRecoveryCounter:8;
    unsigned int	LinkDownedCounter:8;
/* -------------- */
    unsigned int	PortRcvErrors:16;
    unsigned int	PortRcvRemotePhysicalErrors:16;
/* -------------- */
    unsigned int	PortRcvSwitchRelayErrors:16;
    unsigned int	PortXmitDiscards:16;
/* -------------- */
    unsigned int	PortXmitConstraintErrors:8;
    unsigned int	PortRcvConstraintErrors:8;
    unsigned int	reserved3:8;
    unsigned int	LocalLinkIntegrityErrors:4;
    unsigned int	ExcessiveBufferOverrunErrors:4;
/* -------------- */
    unsigned int	reserved4:16;
    unsigned int	VL15Dropped:16;
/* -------------- */
    unsigned int	PortXmitData;
/* -------------- */
    unsigned int	PortRcvData;
/* -------------- */
    unsigned int	PortXmitPkts;
/* -------------- */
    unsigned int	PortRcvPkts;
/* -------------- */
    unsigned char	reserved5[152];
/* -------------- */
}; 

#else /* if not defined (_BIG_ENDIAN) */



struct mad_pcounters {	/* Little Endian */
    unsigned int	Method:7;              /* 1 - Get; 2 - Set; 0x81 - GetResp */
    unsigned int	R:1;                   /* Response bit. */
    unsigned int	ClassVersion:8;        /* 1 */
    unsigned int	MgmtClass:8;           /* 0x4 - Performance Management Class */
    unsigned int	BaseVersion:8;         /* Version of MAD base format. This shall be 1 */
/* -------------- */
    unsigned int	ClassSpecific:16;      /* This field is reserved except for the Subnet Management class */
    unsigned int	Status:16;
/* -------------- */
    unsigned int	TransactionID__63_32;
/* -------------- */
    unsigned int	TransactionID__31_0;
/* -------------- */
    unsigned int	reserved0:16;
    unsigned int	AttributeID:16;        /* 0x12 - PortCounters */
/* -------------- */
    unsigned int	AttributeModifier;
/* -------------- */
    unsigned char	reserved1[40];
/* -------------- */
    unsigned int	CounterSelect:16;      /* mask; when reading, this is ingnored */
    unsigned int	PortSelect:8;          /* Port Number */
    unsigned int	reserved2:8;
/* -------------- */
    unsigned int	LinkDownedCounter:8;
    unsigned int	LinkErrorRecoveryCounter:8;
    unsigned int	SymbolErrorCounter:16;
/* -------------- */
    unsigned int	PortRcvRemotePhysicalErrors:16;
    unsigned int	PortRcvErrors:16;
/* -------------- */
    unsigned int	PortXmitDiscards:16;
    unsigned int	PortRcvSwitchRelayErrors:16;
/* -------------- */
    unsigned int	ExcessiveBufferOverrunErrors:4;
    unsigned int	LocalLinkIntegrityErrors:4;
    unsigned int	reserved3:8;
    unsigned int	PortRcvConstraintErrors:8;
    unsigned int	PortXmitConstraintErrors:8;
/* -------------- */
    unsigned int	VL15Dropped:16;
    unsigned int	reserved4:16;
/* -------------- */
    unsigned int	PortXmitData;
/* -------------- */
    unsigned int	PortRcvData;
/* -------------- */
    unsigned int	PortXmitPkts;
/* -------------- */
    unsigned int	PortRcvPkts;
/* -------------- */
    unsigned char	reserved5[152];
/* -------------- */
}; 

#endif /* defined (_BIG_ENDIAN) */
#endif /* H_both_mad_port_counters_csp_H */
