/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
*/
#ifndef H_SOCK_H
#define H_SOCK_H

#include <stdarg.h>

#define MAX_MSG_LEN 1000

int create_tcp_connection(const char *ip, int port);
int wait_for_connection(int port);
int sock_send_msg(int socket, const char *format, ...);
int sock_get_msg(int socket, char *msg, int len);
void sock_msg2num(char *msg, char *label, long def, void *out, unsigned int len);
void sock_msg2str(char *msg, char *label, char *def, char  *out);
unsigned char sock_is_exists(char *msg, char *label);
void sock_sync_msg(int socket, int is_sender);

#endif /* H_SOCK_H */
