/*
  The ts_kcompat module contains backported code from the Linux kernel
  licensed under the GNU General Public License (GPL) Version 2.  All
  code is copyrighted by its authors.                                                                                           
  $Id$
 */

#ifndef KCOMPAT_DMA_H
#define KCOMPAT_DMA_H

#include <linux/pci.h>
#include <asm/pci.h>

#ifndef DECLARE_PCI_UNMAP_ADDR
#define DECLARE_PCI_UNMAP_ADDR(ADDR_NAME)	\
	dma_addr_t ADDR_NAME;
#endif

#ifndef DECLARE_PCI_UNMAP_LEN
#define DECLARE_PCI_UNMAP_LEN(LEN_NAME)		\
	__u32 LEN_NAME;
#endif

#ifndef pci_unmap_addr
#define pci_unmap_addr(PTR, ADDR_NAME)			\
	((PTR)->ADDR_NAME)
#endif

#ifndef pci_unmap_addr_set
#define pci_unmap_addr_set(PTR, ADDR_NAME, VAL)		\
	(((PTR)->ADDR_NAME) = (VAL))
#endif

#ifndef pci_unmap_len
#define pci_unmap_len(PTR, LEN_NAME)			\
	((PTR)->LEN_NAME)
#endif

#ifndef pci_unmap_len_set
#define pci_unmap_len_set(PTR, LEN_NAME, VAL)		\
	(((PTR)->LEN_NAME) = (VAL))
#endif

#endif /* KCOMPAT_DMA_H */
