/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Topspin Communications.  All rights reserved.

  $Id: ts_ib_pma_provider.h 396 2004-07-09 17:07:37Z roland $
*/

#ifndef _TS_IB_PMA_PROVIDER_H
#define _TS_IB_PMA_PROVIDER_H

#include "ts_ib_pma_provider_types.h"

int tsIbPmaDeviceRegister(struct ib_pma_provider *pma_dev,
                          int                 num_ports);
int tsIbPmaDeviceDeregister(struct ib_pma_provider *pma_dev);

tTS_IB_MAD_RESULT tsIbPmaMadProcess(struct ib_pma_provider *pma_dev,
                                    int                 ignore_mkey,
                                    struct ib_mad      *in_mad,
                                    struct ib_mad      *out_mad
                                   );

// A simulated device provider for example and testing.
extern struct ib_pma_provider ts_ib_pma_sim_provider;

#endif /* _TS_IB_PMA_PROVIDER_H */
