/*
  This software is available to you under a choice of one of two
  licenses.  You may choose to be licensed under the terms of the GNU
  General Public License (GPL) Version 2, available at
  <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
  license, available in the LICENSE.TXT file accompanying this
  software.  These details are also available at
  <http://openib.org/license.html>.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
  BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.

  Copyright (c) 2004 Topspin Communications.  All rights reserved.

  $Id: ts_ib_provider.h 397 2004-07-09 17:09:39Z roland $
*/

#ifndef _TS_IB_PROVIDER_H
#define _TS_IB_PROVIDER_H

#include "ts_ib_core_types.h"

#define TS_IB_DEVICE_IS_SWITCH(device) (NULL != (device)->switch_ops)

int ib_device_register  (struct ib_device *device);
int ib_device_deregister(struct ib_device *device);

void ib_completion_event_dispatch(struct ib_cq *cq);
void ib_async_event_dispatch(struct ib_async_event_record *event_record);

/* Defines to support legacy code -- don't use the tsIb names in new code. */
#define tsIbDeviceRegister               ib_device_register
#define tsIbDeviceDeregister             ib_device_deregister
#define tsIbCompletionEventDispatch      ib_completion_event_dispatch
#define tsIbAsyncEventDispatch           ib_async_event_dispatch

#endif /* _TS_IB_PROVIDER_H */

/*
  Local Variables:
  c-file-style: "linux"
  indent-tabs-mode: t
  End:
*/
