%define build_root %(if [ ! -z "${build_root}" ]; then echo -n ${build_root}; else echo -n "/var/tmp/IBGD"; fi)
%define STACK_PREFIX %(if [ ! -z "${STACK_PREFIX}" ]; then echo -n ${STACK_PREFIX}; else echo -n "/usr/local/ibgd"; fi)
%define PACKAGES %(if [ ! -z "${PACKAGES}" ]; then echo -n ${PACKAGES}; else echo -n "ib_verbs ib_ipoib ib_cm ib_sdp ib_dapl ib_srp"; fi)
%define MEMTRACK %(if [ ! -z "${MEMTRACK}" ]; then echo -n ${MEMTRACK}; else echo -n 0; fi)
%define KVERSION %(if [ ! -z "${KVERSION}" ]; then echo -n ${KVERSION}; else echo -n $(uname -r); fi)
%define TMPDIR /tmp/openib
%define VERSION XXXXXX
%define NAME YYYYYY
%define RELVER ZZZZZZ
%define krelver %(echo -n %{KVERSION} | tr -s '-' '_')
#%if %(echo -n %{KVERSION}| grep -c smp)
# %{expand:%%define ksmp -smp}
#%endif

# Select packages to build
%define build_verbs 1
%define build_ipoib %(if ( echo ${PACKAGES} | grep -w ib_ipoib > /dev/null ); then echo -n '1'; else echo -n '0'; fi)
%define build_cm %(if ( echo ${PACKAGES} | grep -w ib_cm > /dev/null ); then echo -n '1'; else echo -n '0'; fi)
%define build_sdp %(if ( echo ${PACKAGES} | grep -w ib_sdp > /dev/null ); then echo -n '1'; else echo -n '0'; fi)
%define build_dapl %(if ( echo ${PACKAGES} | grep -w ib_dapl > /dev/null ); then echo -n '1'; else echo -n '0'; fi)
%define build_srp %(if ( echo ${PACKAGES} | grep -w ib_srp > /dev/null ); then echo -n '1'; else echo -n '0'; fi)
%define build_srp_target %(if ( echo ${PACKAGES} | grep -w ib_srp_target > /dev/null ); then echo -n '1'; else echo -n '0'; fi)

%define LIB_MOD_DIR /lib/modules/%{KVERSION}/kernel/drivers/infiniband
%define NETWORK_CONF_DIR /etc/infiniband

# Define Kernel sources path
%define new_src_tree %(if [ -d /lib/modules/%{KVERSION}/source/ ]; then echo 1; else echo 0; fi)

%if %{new_src_tree}
    %define K_SRC /lib/modules/%{KVERSION}/source
%else    
    %define K_SRC /lib/modules/%{KVERSION}/build
%endif

%define KSRC %(if [ ! -z ${KSRC} ]; then echo ${KSRC}; else echo %{K_SRC}; fi)

%define KERNEL_24 %(if [ $(uname -r | cut -c -3) == "2.4" ]; then echo -n 1; else echo -n 0; fi)
%define KERNEL_26 %(if [ $(uname -r | cut -c -3) == "2.6" ]; then echo -n 1; else echo -n 0; fi)

# Disable debugging
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

Summary: Infiniband HCA Driver
BuildRequires: termcap >= 2.0.8, gcc >= 2.95, glibc-devel >= 2.2.4, readline, readline-devel, ncurses, ncurses-devel
Prereq: /sbin/ldconfig, grep
Requires: glib >= 1.2.10, glibc >= 2.2.4
Name: %{NAME}
Version: %{VERSION}
Release: %{krelver}
License: GPL
Group: System Environment/Base
Source: %{NAME}-%{RELVER}.tgz
BuildRoot: %{build_root}
Vendor: Mellanox Technologies Ltd.

%description
Infiniband Upper Layer Protocols package and HCA drivers

%package verbs
Summary: Infiniband HCA Driver
Group: System Environment/Base

%description verbs
Core support for InfiniBand

%package ipoib
Requires: ib-verbs
Summary: Infiniband IPoIB
Group: System Environment/Base

%description ipoib
Support for the IP-over-InfiniBand protocol (IPoIB).  This
transports IP packets over InfiniBand so you can use your IB
device as a fancy NIC.  To configure interfaces on multiple
InfiniBand partitions (P_Keys) you will need the ipoibcfg
utility from <http://openib.org>.

%package cm
Requires: ib-verbs, ib-ipoib
Summary: Infiniband CM
Group: System Environment/Base

%description cm
Userspace access to the kernel communication manager.
This allows userspace protocols such as uDAPL or MPI to use
the kernel's services for establishing connections.

%package sdp
Requires: ib-verbs, ib-ipoib, ib-cm
Summary: Infiniband SDP
Group: System Environment/Base

%description sdp
Support for Sockets Direct Protocol (SDP).  This provides
sockets semantics over InfiniBand via address family
AF_INET_SDP (address family 26).  You can also LD_PRELOAD the
libsdp library from <http://openib.org> to have standard
sockets applications use SDP.

%package dapl
Requires: ib-verbs, ib-ipoib, ib-cm
Summary: Infiniband DAT API
Group: System Environment/Base

%description dapl
Support for the Direct Acess Transport (DAT) API
Includes: uDAPL, kDAPL and DAT

%package srp
Requires: ib-verbs, ib-ipoib, ib-cm
Summary: Infiniband SRP initiator
Group: System Environment/Base

%description srp
Support for SCSI RDMA Protocol (SRP).  This transports SCSI
commands over InfiniBand and allows you to access storage
connected via IB.

%package srp_target
Requires: ib-verbs, ib-ipoib, ib-cm
Summary: Infiniband SRP target driver
Group: System Environment/Base

%description srp_target
Support for SCSI RDMA Protocol (SRP).  This transports SCSI
commands over InfiniBand and allows you to access storage
connected via IB.


%prep
%setup -n %{NAME}-%{RELVER}

###
### install
###
%install
rm -rf $RPM_BUILD_ROOT

# W/A: case where Gen-1 sources are not in kernel tree and Gen-2 sources were moved
if ! test -d %{KSRC}/drivers/infiniband; then
    if test -d %{KSRC}/drivers/infiniband-gen2; then
        mv %{KSRC}/drivers/infiniband-gen2 %{KSRC}/drivers/infiniband
    fi
fi        
	
cd $RPM_BUILD_DIR/%{NAME}-%{RELVER}
INSTALL_PARAMS=""
%if %{MEMTRACK}
	INSTALL_PARAMS="--memtrack"
%endif

./install.sh --batch --build_only --prefix %{STACK_PREFIX} --tmpdir $RPM_BUILD_ROOT/%{TMPDIR} -kver %{KVERSION} --ksrc %{KSRC} --packages %{PACKAGES} -- --build_root $RPM_BUILD_ROOT ${INSTALL_PARAMS}
	
if ! test -d $RPM_BUILD_ROOT/%{STACK_PREFIX}/include; then
	mkdir -p $RPM_BUILD_ROOT/%{STACK_PREFIX}/include
fi

if ! test -d $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc; then
	mkdir -p $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc
fi

# Remove extra link
rm -f $RPM_BUILD_ROOT/%{STACK_PREFIX}/driver/infinihost/include/mpga
	
# Copy infiniband configuration
install -d $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}
install -m 0644 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/openib.conf $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}
	
%if %{build_dapl}
# udapl configuration file
perl -ni -e  "s@/usr/local/ibgd@%{STACK_PREFIX}@;print" $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc/dat.conf
install -m 0644 $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc/dat.conf $RPM_BUILD_ROOT/etc/dat.conf
rm -f $RPM_BUILD_ROOT/%{STACK_PREFIX}/etc/dat.conf
%endif	

%if %{build_srp}
# srp utilities
perl -ni -e "s@/usr/local/ibgd@%{STACK_PREFIX}@;print" $RPM_BUILD_ROOT/%{STACK_PREFIX}/utils/srp_persistent_bind.sh
perl -ni -e "s@/usr/local/ibgd@%{STACK_PREFIX}@;print" $RPM_BUILD_ROOT/%{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh
%endif	
	
%if %{build_ipoib}
	DEVICES="ib0 ib1"
	
	for DEVICE in $DEVICES
	do
		if [ -f /etc/SuSE-release ]; then        
	
			echo BOOTPROTO=\'dhcp\' 	>> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
			echo REMOTE_IPADDR=\'\' 	>> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
			echo STARTMODE=\'onboot\' 	>> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
			echo WIRELESS=\'no\' 		>> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
	
		else
	
			echo DEVICE=${DEVICE} 	    >> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
			echo BOOTPROTO=dhcp 	    >> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
			echo ONBOOT=no 		    >> $RPM_BUILD_ROOT/%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
	
		fi
	done
%endif

# Install openib service script
install -d $RPM_BUILD_ROOT/etc/init.d
install -m 0755 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/openibd $RPM_BUILD_ROOT/etc/init.d
perl -ni -e "s@(STACK_PREFIX=).*@\$1%{STACK_PREFIX}@; print" $RPM_BUILD_ROOT/etc/init.d/openibd
	
%clean
#Remove installed driver after rpm build finished
# Leave $RPM_BUILD_ROOT in order to build dependent packages
rm -rf $RPM_BUILD_DIR/%{NAME}-%{RELVER}

###
### pre section
###
%pre verbs
# Save Gen2 sources
if test -d  %{KSRC}/drivers/infiniband/hw/mthca; then
        mv %{KSRC}/drivers/infiniband %{KSRC}/drivers/infiniband-gen2
else
	/bin/rm -rf %{KSRC}/drivers/infiniband
fi

# Save Gen2 modules
if [ -e %{LIB_MOD_DIR}/hw/mthca/ib_mthca.ko ]; then
	find %{LIB_MOD_DIR} -name "*.ko" -exec mv {} {}.gen2 \;
	mv %{LIB_MOD_DIR} %{LIB_MOD_DIR}-gen2 
else
	rm -rf %{LIB_MOD_DIR}
fi

###
### post section
###
%post verbs
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time

if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed

count_ib_ports()
{
    local cnt=0
    local tmp_cnt=0
    
    tmp_cnt=$(/sbin/lspci -n | grep "15b3:6282" | wc -l | tr -d '[:space:]') # Arbel mode
    cnt=$[ $cnt + 2*${tmp_cnt} ]
    
    tmp_cnt=$(/sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" | wc -l | tr -d '[:space:]') # Sinai
    cnt=$[ $cnt + ${tmp_cnt} ]

    tmp_cnt=$(/sbin/lspci -n | grep -E "15b3:5a44|15b3:6278" | wc -l | tr -d '[:space:]') # Tavor mode
    cnt=$[ $cnt + 2*${tmp_cnt} ]
    
    return $cnt
}

count_ib_ports
ports_num=$?

# Set default number of ports to 2 if no HCAs found
if [ $ports_num -eq 0 ]; then
    ports_num=2
fi    
#############################################################################################################
#                                       Modules configuration                                               #
#############################################################################################################

if [ "$(echo %{KVERSION} | cut -c -3)" == "2.6" ]; then # 3 : Kernel 2.6

# Update /etc/modprobe.conf
# Remove previous configuration if exist
perl -ni -e 'if (/\#\# BEGIN OpenIB \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END OpenIB \#\#$/){ $filter = 0 }' /etc/modprobe.conf

if [ "x$(uname -m)" == "xx86_64" ] && cat /proc/cpuinfo | grep 'Intel' > /dev/null ; then # 4 : EM64T arch - enable MSI-X
	disable_msix=0
else # 4
	disable_msix=1
fi # 4 - closed

cat >> /etc/modprobe.conf << EOF
## BEGIN OpenIB ##
#
# InfiniBand module loading configuration
#

EOF

for (( i=0 ; i < $ports_num ; i++ ))
do
cat >> /etc/modprobe.conf << EOF
alias ib${i} ib_ipoib
EOF
done

cat >> /etc/modprobe.conf << EOF

alias net-pf-26 ib_sdp
alias kdapl dat_registry
alias kdapltest kdapltest_module
alias /dev/mosal mlxsys
alias /dev/vipkl mod_vip

options mod_thh disable_msix=${disable_msix}
options mod_rhh disable_msix=${disable_msix}
options ib_mad ib_outs_mad_recv_entries=1024
options ib_client_query ib_query_throttle_threshhold=0 ib_query_throttle_waitqueue_limit=10000
options ib_ipoib ipoib_use_interrupt_context=0

# mod_thh/mod_rhh
install mod_thh /usr/bin/mst start > /dev/null 2>&1 ; /sbin/modprobe -q --ignore-install mod_thh
install mod_rhh /usr/bin/mst start > /dev/null 2>&1 ; /sbin/modprobe -q --ignore-install mod_rhh

# mlxsys
install mlxsys /sbin/modprobe -q --ignore-install mlxsys && { rm -f /dev/mosal;  [ "x\$(awk '(\$2=="mosal") {print \$1}' /proc/devices)" != "x" ] && mknod /dev/mosal c \`awk '(\$2=="mosal") {print \$1}' /proc/devices\` 0; }
remove mlxsys /sbin/modprobe -r -q --ignore-remove mlxsys && { /bin/rm -f /dev/mosal; }

# mod_vapi
install mod_vip /sbin/modprobe -q --ignore-install mod_vip && { rm -f /dev/vipkl; mknod /dev/vipkl c \`awk '(\$2=="mellanox_vipkl") {print \$1}' /proc/devices\` 1; }
remove mod_vip /sbin/modprobe -r -q --ignore-remove mod_vip && { /bin/rm -f /dev/vipkl; }

# Close HCAs after removing mod_thh/mod_rhh
remove mod_thh close_hcas && /sbin/modprobe -r -q --ignore-remove mod_thh
remove mod_rhh close_hcas && /sbin/modprobe -r -q --ignore-remove mod_rhh

install ib_ipoib /sbin/modprobe -i ib_ipoib && %{STACK_PREFIX}/utils/update_ipoib_intfs
install ib_ip2pr /sbin/modprobe -i ib_ip2pr && %{STACK_PREFIX}/utils/create_devs ib_ip2pr

install ib_dapl_srv /sbin/modprobe -i ib_dapl_srv && %{STACK_PREFIX}/utils/create_devs ib_udapl

install ib_useraccess /sbin/modprobe -i ib_useraccess && %{STACK_PREFIX}/utils/create_devs ib_useraccess
install ib_useraccess_cm /sbin/modprobe -i ib_useraccess_cm && %{STACK_PREFIX}/utils/create_devs ib_useraccess_cm


install kdapltest_module /sbin/modprobe -i kdapltest_module && %{STACK_PREFIX}/utils/create_devs kdapltest_module

# SRP
# install ib_srp /sbin/modprobe -i ib_srp && { %{STACK_PREFIX}/utils/srp_persistent_bind.sh & }
# remove ib_srp %{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh && /sbin/modprobe -r -q --ignore-remove ib_srp
## END OpenIB ##
EOF
            
#          # Add modprobe-openib.conf to the /etc/modprobe.conf
#          perl -ni -e "print unless (m@include /etc/modprobe-openib.conf@)" /etc/modprobe.conf
#          echo "include /etc/modprobe-openib.conf" >> /etc/modprobe.conf

	  /sbin/depmod -r -ae %{KVERSION}

else # 3: Kernel = 2.4

## Update /etc/modules.conf
# Remove previous configuration if exist
perl -ni -e 'if (/\#\# BEGIN OpenIB \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END OpenIB \#\#$/){ $filter = 0 }' /etc/modules.conf

cat >> /etc/modules.conf << EOF
## BEGIN OpenIB ##
#
# InfiniBand module loading configuration
#

EOF

for (( i=0 ; i < $ports_num ; i++ ))
do
cat >> /etc/modules.conf << EOF
alias ib${i} ib_ipoib
EOF
done

cat >> /etc/modules.conf << EOF

alias net-pf-26 ib_sdp

alias /dev/mosal mlxsys
alias /dev/vipkl mod_vapi
alias kdapl dat_registry
alias kdapltest kdapltest_module

options ib_mad ib_outs_mad_recv_entries=1024
options ib_client_query ib_query_throttle_threshhold=0 ib_query_throttle_waitqueue_limit=10000
options ib_ipoib ipoib_use_interrupt_context=0

post-install mlxsys { rm -f /dev/mosal; mknod /dev/mosal c \`awk '(\$2=="mosal") {print \$1}' /proc/devices\` 0 ; }
post-remove mlxsys /bin/rm -f /dev/mosal

post-install mod_vip { rm -f /dev/vipkl; mknod /dev/vipkl c \`awk '(\$2=="mellanox_vipkl") {print \$1}' /proc/devices\` 1 ; }
post-remove mod_vip /bin/rm -f /dev/vipkl

post-install mod_thh open_hcas
pre-remove mod_thh close_hcas
post-install mod_rhh open_hcas
pre-remove mod_rhh close_hcas

post-install ib_useraccess %{STACK_PREFIX}/utils/create_devs ib_useraccess 
post-install ib_ipoib %{STACK_PREFIX}/utils/update_ipoib_intfs 
# add above ib_ipoib ib_useraccess
# add above ib_ipoib ib_ip2pr 
post-install ib_ip2pr %{STACK_PREFIX}/utils/create_devs ib_ip2pr 
# add above ib_ip2pr ib_dapl_srv
post-install ib_dapl_srv %{STACK_PREFIX}/utils/create_devs ib_udapl 
# add above ib_dapl_srv ib_useraccess_cm 
post-install ib_useraccess_cm %{STACK_PREFIX}/utils/create_devs ib_useraccess_cm 
# add above ib_sa_client ib_useraccess 
add below ib_ipoib ib_tavor
# post-install ib_srp { %{STACK_PREFIX}/utils/srp_persistent_bind.sh & }
# pre-remove ib_srp %{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh 
post-install dat_registry /sbin/modprobe ib_kdapl 
post-install kdapltest_module %{STACK_PREFIX}/utils/create_devs kdapltest_module
## END OpenIB ##
EOF
            
# # Add modules-openib.conf to the /etc/modules.conf
# perl -ni -e "print unless (m@include /etc/modules-openib.conf@)" /etc/modules.conf
# echo "include /etc/modules-openib.conf" >> /etc/modules.conf

/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}

fi # 3 : closed

#############################################################################################################

        
# Update /etc/ld.so.conf
%ifarch x86_64
	perl -ni -e "print unless (m@%{STACK_PREFIX}/driver/infinihost/lib64@)" /etc/ld.so.conf
	echo "%{STACK_PREFIX}/driver/infinihost/lib64" >> /etc/ld.so.conf
%else
	perl -ni -e "print unless (m@%{STACK_PREFIX}/driver/infinihost/lib@)" /etc/ld.so.conf
	echo "%{STACK_PREFIX}/driver/infinihost/lib" >> /etc/ld.so.conf
%endif
perl -ni -e "print unless (m@%{STACK_PREFIX}/lib@)" /etc/ld.so.conf
echo "%{STACK_PREFIX}/lib" >> /etc/ld.so.conf
%ifarch x86_64
	perl -ni -e "print unless (m@%{STACK_PREFIX}/lib64@)" /etc/ld.so.conf
	echo "%{STACK_PREFIX}/lib64" >> /etc/ld.so.conf
%endif
/sbin/ldconfig
	  

# Create links to bin files from /usr/bin
cd /usr/bin
for bin in %{STACK_PREFIX}/driver/infinihost/bin/*
do
	[ "$bin" != "%{STACK_PREFIX}/driver/infinihost/bin/*" ] && ln -s -f ${bin}
done

# # Create links to bin files from /usr/bin
# if [ -d %{STACK_PREFIX}/bin ]; then
#         for bin in %{STACK_PREFIX}/bin/*
#         do
#                 [ "$bin" != "%{STACK_PREFIX}/bin/*" ] && ln -s -f ${bin}
#         done
# fi

if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
perl -i -ne 'if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
#
# Bring up/down openib
#
# chkconfig: 2345 15 85
# description: Activates/Deactivates InfiniBand Driver to \
#              start at boot time.
#
### BEGIN INIT INFO
# Provides:       openibd
### END INIT INFO
@;
                 } else {
                     print;
                 }' /etc/init.d/openibd

        /sbin/chkconfig --del openibd 
        /sbin/chkconfig --add openibd 
fi

if [ -f /etc/SuSE-release ]; then
        perl -i -ne 'if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
### BEGIN INIT INFO
# Provides:       openibd
# Required-Start: $local_fs $network
# Required-Stop: opensmd
# Default-Start:  2 3 5
# Default-Stop: 0 1 2 6
# Description:    Activates/Deactivates InfiniBand Driver to \
#                 start at boot time.
### END INIT INFO
@;
                 } else {
                     print;
                 }' /etc/init.d/openibd

        /sbin/insserv openibd
fi

	# Add mod_thh/mod_rhh to the hotplug blacklist if exists
	if [ -e /etc/hotplug/blacklist ]; then
	    perl -i.orig -ne 'print unless (m@mod_thh@)' /etc/hotplug/blacklist
	    perl -i.orig -ne 'print unless (m@mod_rhh@)' /etc/hotplug/blacklist
	    echo mod_thh >> /etc/hotplug/blacklist
	    echo mod_rhh >> /etc/hotplug/blacklist
	fi


fi # 1 : closed
# End post verbs

%post ipoib
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time

if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed


# Change IPoIB configuration

if [ -f /etc/redhat-release ]; then
    DISTRIBUTION="RedHat"
elif [ -f /etc/rocks-release ]; then
    DISTRIBUTION="Rocks"
elif [ -f /etc/SuSE-release ]; then
    DISTRIBUTION="SuSE"
else
    DISTRIBUTION=`ls /etc/*-release | head -n 1 | xargs -iXXX basename XXX -release 2> /dev/null`
fi

INTERFACES=`/sbin/ifconfig | grep eth | awk '{print$1}' | sort -n | tr -s '\n' '\ '`
for INTERFACE in $INTERFACES
do
	ADDRS=`/sbin/ifconfig $INTERFACE | grep "inet addr"`
  	if [[ -n $ADDRS ]]; then
	      LAN_INTERFACE=$INTERFACE
	      break
	fi
done

LAN_INTERFACE=${LAN_INTERFACE:-eth0}

count_ib_ports()
{
    local cnt=0
    local tmp_cnt=0
    
    tmp_cnt=$(/sbin/lspci -n | grep "15b3:6282" | wc -l | tr -d '[:space:]') # Arbel mode
    cnt=$[ $cnt + 2*${tmp_cnt} ]
    
    tmp_cnt=$(/sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" | wc -l | tr -d '[:space:]') # Sinai
    cnt=$[ $cnt + ${tmp_cnt} ]

    tmp_cnt=$(/sbin/lspci -n | grep -E "15b3:5a44|15b3:6278" | wc -l | tr -d '[:space:]') # Tavor mode
    cnt=$[ $cnt + 2*${tmp_cnt} ]
    
    return $cnt
}

count_ib_ports
ports_num=$?

DEVICES=""

for (( i=0 ; i < $ports_num ; i++ ))
do
    DEVICES="$DEVICES ib${i}"
done    

[ "$DEVICES" == "" ] && DEVICES="ib0 ib1"

high_IP=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*inet addr:\([0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${high_IP}" == "" ]; then
	high_IP=10
fi	
let high_IP++
low_IP=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*inet addr:[0-9]*\.\([0-9]*\.[0-9]*\.[0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${low_IP}" == "" ]; then
	low_IP=0.0.1
fi
IPADDR=${high_IP}.${low_IP}

NETMASK=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*Mask:\([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${NETMASK}" == "" ]; then
	NETMASK=255.0.0.0
fi
	
low_Bcast=`/sbin/ifconfig | sed -e "/\($LAN_INTERFACE\).*/{ N; s/.*Bcast:[0-9]*\.\([0-9]*\.[0-9]*\.[0-9]*\).*/\1/; }" | grep ^[0-9] | head -1`
if [ "${low_Bcast}" == "" ]; then
	low_Bcast=0.255.255
fi	
BROADCAST=${high_IP}.${low_Bcast}
ONBOOT=1


IP_A=`echo ${IPADDR} | cut -d '.' -f 1 | tr -d '[:space:]'`
IP_B=`echo ${IPADDR} | cut -d '.' -f 2 | tr -d '[:space:]'`
IP_C=`echo ${IPADDR} | cut -d '.' -f 3 | tr -d '[:space:]'`
IP_D=`echo ${IPADDR} | cut -d '.' -f 4 | tr -d '[:space:]'`

NM_A=`echo ${NETMASK} | cut -d '.' -f 1 | tr -d '[:space:]'`
NM_B=`echo ${NETMASK} | cut -d '.' -f 2 | tr -d '[:space:]'`
NM_C=`echo ${NETMASK} | cut -d '.' -f 3 | tr -d '[:space:]'`
NM_D=`echo ${NETMASK} | cut -d '.' -f 4 | tr -d '[:space:]'`

NW_A=$[ $IP_A & $NM_A ]
NW_B=$[ $IP_B & $NM_B ]
NW_C=$[ $IP_C & $NM_C ]
NW_D=$[ $IP_D & $NM_D ]

NETWORK=${NW_A}.${NW_B}.${NW_C}.${NW_D}

IP_BCD=${IPADDR#*.}


NET_BCD=${NETWORK#*.}
BR_BCD=${BROADCAST#*.}

for DEVICE in $DEVICES
do
target=%{NETWORK_CONF_DIR}/ifcfg-${DEVICE}
cat $NULL > $target

if [ "$DISTRIBUTION" == "SuSE" ]; then
cat >> $target << EOF
BOOTPROTO='static'
IPADDR='${IP_A}.${IP_BCD}'
NETMASK='${NETMASK}'
NETWORK='${IP_A}.${NET_BCD}'
BROADCAST='${IP_A}.${BR_BCD}'
REMOTE_IPADDR=''
STARTMODE='onboot'
WIRELESS='no'
EOF
else
cat >> $target << EOF
DEVICE=$DEVICE
BOOTPROTO=static
IPADDR=${IP_A}.${IP_BCD}
NETMASK=${NETMASK}
NETWORK=${IP_A}.${NET_BCD}
BROADCAST=${IP_A}.${BR_BCD}
ONBOOT=yes
EOF
fi

    let IP_A++

done


## Use saved configuration files if exists (rpmsave)
#CONFIGS="%{NETWORK_CONF_DIR}/openib.conf %{NETWORK_CONF_DIR}/ifcfg-ib0 %{NETWORK_CONF_DIR}/ifcfg-ib1"
for conf in %{NETWORK_CONF_DIR}/ifcfg-ib*[0-9]
do
    if [ -e ${conf}.rpmsave ]; then
        cp -f ${conf}.rpmsave ${conf}
    fi    
done	

echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load IPoIB" >> %{NETWORK_CONF_DIR}/openib.conf
echo "IPOIB_LOAD=yes" >> %{NETWORK_CONF_DIR}/openib.conf

    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    
fi # 1 : Closed

# End post ib_ipoib

%post cm
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time
if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed

echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load USER ACCESS CM module" >> %{NETWORK_CONF_DIR}/openib.conf
echo "USER_ACCESS_CM_LOAD=no" >> %{NETWORK_CONF_DIR}/openib.conf

    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    /sbin/ldconfig
	
fi # 1 : Closed
		
%post sdp
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time
if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed

echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load SDP module" >> %{NETWORK_CONF_DIR}/openib.conf
echo "SDP_LOAD=no" >> %{NETWORK_CONF_DIR}/openib.conf

    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    /sbin/ldconfig
	
fi # 1 : Closed

%post dapl
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time

if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed

# Update dat.conf
if ( /sbin/lspci -n | grep "15b3:6282" > /dev/null ); then #Found Arbel memfree
	perl -ni -e  "s@InfiniHost0@InfiniHost_III_Ex0@;print" /etc/dat.conf
fi
if ( /sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" > /dev/null ); then #Found Sinai
	perl -ni -e  "s@InfiniHost0@InfiniHost_III_Lx0@;print" /etc/dat.conf
fi

# Create links to bin files from /usr/bin
# cd /usr/bin
# if [ -d %{STACK_PREFIX}/bin ]; then
#         for bin in %{STACK_PREFIX}/bin/*
#         do
#                 [ "$bin" != "%{STACK_PREFIX}/bin/*" ] && ln -s -f ${bin}
#         done
# fi

if [ -x %{STACK_PREFIX}/bin/dapltest ]; then
    ln -snf %{STACK_PREFIX}/bin/dapltest /usr/bin/dapltest
fi

if [ -x %{STACK_PREFIX}/bin/kdapltest ]; then
    ln -snf %{STACK_PREFIX}/bin/kdapltest /usr/bin/kdapltest
fi

echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load UDAPL module" >> %{NETWORK_CONF_DIR}/openib.conf
echo "UDAPL_LOAD=no" >> %{NETWORK_CONF_DIR}/openib.conf
echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load KDAPL module" >> %{NETWORK_CONF_DIR}/openib.conf
echo "KDAPL_LOAD=no" >> %{NETWORK_CONF_DIR}/openib.conf

    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    /sbin/ldconfig

fi # 1 : Closed

# End post dapl
 
%post srp
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time
if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed

echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load SRP initiator module" >> %{NETWORK_CONF_DIR}/openib.conf
echo "SRP_LOAD=no" >> %{NETWORK_CONF_DIR}/openib.conf

    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
	
fi # 1 : Closed

%post srp_target
if [ $1 = 1 ]; then # 1 : This package is being installed for the first time
if [ `uname -r` != "%{KVERSION}" ]; then # 2 : Check that RPM was build for the same kernel version
	echo "WARNING: This rpm supports only %{KVERSION} kernel..."
fi # 2 : Closed

echo >> %{NETWORK_CONF_DIR}/openib.conf                                                
echo "# Load SRP target module" >> %{NETWORK_CONF_DIR}/openib.conf
echo "SRP_TARGET_LOAD=no" >> %{NETWORK_CONF_DIR}/openib.conf

    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
	
fi # 1 : Closed


###
### preun section
###
%preun verbs
if [ $1 = 0 ]; then  # 1 : Erase, not upgrade

   if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
        /sbin/chkconfig --del openibd 
   fi
   if [ -f /etc/SuSE-release ]; then
        /sbin/insserv -r openibd
   fi

   if [ -d  %{STACK_PREFIX}/driver/infinihost/bin ]; then
     cd %{STACK_PREFIX}/driver/infinihost/bin
     for bin in *
     do
        [ "$bin" != "*" ] && /bin/rm -f /usr/bin/$bin || break
     done
   fi

   if [ -d  %{STACK_PREFIX}/bin ]; then
     cd %{STACK_PREFIX}/bin
     for bin in *
     do
        [ "$bin" != "*" ] && /bin/rm -f /usr/bin/$bin || break
     done
   fi

fi
# End preun verbs

###
### post uninstall section
###
%postun -n ib-verbs
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    # Clean Environment Files
    
       if (grep -v %{STACK_PREFIX} /etc/ld.so.conf > /tmp/tmp.file.OpenIB); then
            mv -f /tmp/tmp.file.OpenIB /etc/ld.so.conf
       fi
       rm -f /tmp/tmp.file.OpenIB
       /sbin/ldconfig
    
    # Restore Gen2 sources
    if test -d %{KSRC}/drivers/infiniband-gen2; then
            mv %{KSRC}/drivers/infiniband-gen2 %{KSRC}/drivers/infiniband
    fi
    
    # Restore Gen2 modules
    if [ -d %{LIB_MOD_DIR}-gen2 ]; then
    	rm -rf  %{LIB_MOD_DIR}
    	mv %{LIB_MOD_DIR}-gen2 %{LIB_MOD_DIR}
    	for mod in `find %{LIB_MOD_DIR} -name "*.ko.gen2"`
    	do
    		mv ${mod} ${mod%*.*}
    	done 
    fi
    
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	# Clean /etc/modprobe.conf   
#    	perl -ni -e "print unless (m@include /etc/modprobe-openib.conf@)" /etc/modprobe.conf
#    	rm -f /etc/modprobe-openib.conf

	# Remove previous configuration if exist
	perl -ni -e 'if (/\#\# BEGIN OpenIB \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END OpenIB \#\#$/){ $filter = 0 }' /etc/modprobe.conf
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	# Clean /etc/modules.conf   
#    	perl -ni -e "print unless (m@include /etc/modules-openib.conf@)" /etc/modules.conf
#    	rm -f /etc/modules-openib.conf

	# Remove previous configuration if exist
	perl -ni -e 'if (/\#\# BEGIN OpenIB \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END OpenIB \#\#$/){ $filter = 0 }' /etc/modules.conf
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    
	# Remove mod_thh/mod_rhh from the hotplug blacklist if exists
        if [ -e /etc/hotplug/blacklist ]; then
            perl -i.orig -ne 'print unless (m@mod_thh@)' /etc/hotplug/blacklist
            perl -i.orig -ne 'print unless (m@mod_rhh@)' /etc/hotplug/blacklist
	fi

fi # 1 : End
# End postun verbs

%postun -n ib-ipoib
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
fi # 1 : End
# End postun ipoib

%postun -n ib-cm
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    /sbin/ldconfig
fi # 1 : End
# End postun cm

%postun -n ib-sdp
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    /sbin/ldconfig
fi # 1 : End
# End postun sdp

%postun -n ib-dapl
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
    rm -f /usr/bin/dapltest
    rm -f /usr/bin/kdapltest
    /sbin/ldconfig

fi # 1 : End
# End postun dapl

%postun -n ib-srp
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
fi # 1 : End
# End postun srp

%postun -n ib-srp_target
if [ $1 = 0 ]; then # 1 : Erase, not upgrade
    if [ `uname -r | cut -c -3` == "2.6" ]; then
    	/sbin/depmod -r -ae %{KVERSION}
    else
    	/sbin/depmod -r -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
    fi
fi # 1 : End
# End postun srp_target

###
### Files
###
%if %{build_verbs}
%files verbs
%defattr(-,root,root)
%dir %{STACK_PREFIX}
%{STACK_PREFIX}/driver
%dir %{STACK_PREFIX}/include
%dir %{STACK_PREFIX}/bin
%dir %{STACK_PREFIX}/utils
%{STACK_PREFIX}/utils/create_devs
%dir %{STACK_PREFIX}/src
%{STACK_PREFIX}/src/ib_verbs
%dir %{STACK_PREFIX}/etc
%dir %{LIB_MOD_DIR}
%{LIB_MOD_DIR}/mod_vip.*o
%{LIB_MOD_DIR}/mod_thh.*o
%{LIB_MOD_DIR}/mod_rhh.*o
%{LIB_MOD_DIR}/mlxsys.*o
%{LIB_MOD_DIR}/ib_tavor.*o
%if %{KERNEL_24}
%{LIB_MOD_DIR}/ib_kcompat.*o
%endif
%{LIB_MOD_DIR}/ib_useraccess.*o
%{LIB_MOD_DIR}/ib_services.*o
%{LIB_MOD_DIR}/ib_sa_client.*o
%{LIB_MOD_DIR}/ib_poll.*o
%{LIB_MOD_DIR}/ib_mad.*o
%{LIB_MOD_DIR}/ib_dm_client.*o
%{LIB_MOD_DIR}/ib_core.*o
%{LIB_MOD_DIR}/ib_client_query.*o
%if %{MEMTRACK} && %{KERNEL_26}
%{LIB_MOD_DIR}/memtrack.*o
%endif
%dir %{KSRC}/drivers/infiniband
%{KSRC}/drivers/infiniband/ib_verbs
%{KSRC}/drivers/infiniband/include
%{KSRC}/drivers/infiniband/Makefile
%{KSRC}/drivers/infiniband/Kconfig

%dir %{NETWORK_CONF_DIR}
%config %{NETWORK_CONF_DIR}/openib.conf
/etc/init.d/openibd
%endif

%if %{build_ipoib}
%files ipoib
%defattr(-,root,root)
%{LIB_MOD_DIR}/ib_ipoib.*o
%{LIB_MOD_DIR}/ib_ip2pr.*o
%{KSRC}/drivers/infiniband/ib_ipoib
%{STACK_PREFIX}/utils/update_ipoib_intfs
%config %{NETWORK_CONF_DIR}/ifcfg-ib*[0-9]
%endif

%if %{build_cm}
%files cm
%defattr(-,root,root)
%{LIB_MOD_DIR}/ib_cm.*o
%{LIB_MOD_DIR}/ib_useraccess_cm.*o
%{KSRC}/drivers/infiniband/ib_cm
%{STACK_PREFIX}/src/ib_cm
%{STACK_PREFIX}/lib/libcm.*
%endif

%if %{build_sdp}
%files sdp
%defattr(-,root,root)
%{LIB_MOD_DIR}/ib_sdp.*o
%{KSRC}/drivers/infiniband/ib_sdp
%{STACK_PREFIX}/src/ib_sdp
%{STACK_PREFIX}/etc/libsdp.conf
%{STACK_PREFIX}/lib/libsdp.*
%ifarch x86_64
%{STACK_PREFIX}/lib64/libsdp.*
%endif
%endif

%if %{build_dapl}
%files dapl
%defattr(-,root,root)
%{LIB_MOD_DIR}/dat_registry.*o
%{LIB_MOD_DIR}/ib_dapl_srv.*o
%{LIB_MOD_DIR}/ib_kdapl.*o
%{LIB_MOD_DIR}/kdapltest_module.*o
%{KSRC}/drivers/infiniband/ib_dapl
%{STACK_PREFIX}/include/dat
%{STACK_PREFIX}/src/ib_dapl
%{STACK_PREFIX}/utils/DaplRegress.sh
%{STACK_PREFIX}/bin/dapltest
%{STACK_PREFIX}/bin/kdapltest
%{STACK_PREFIX}/lib/libdapl.a
%{STACK_PREFIX}/lib/libdapl.so
%{STACK_PREFIX}/lib/libdat.a
%{STACK_PREFIX}/lib/libdat.so
%config /etc/dat.conf
%endif

%if %{build_srp}
%files srp
%defattr(-,root,root)
%{LIB_MOD_DIR}/ib_srp.*o
%{KSRC}/drivers/infiniband/ib_srp
%{STACK_PREFIX}/bin/scsidev
%{STACK_PREFIX}/utils/srp_persistent_bind.sh
%{STACK_PREFIX}/utils/remove_srp_bind_persistent.sh
%{STACK_PREFIX}/utils/rescan-scsi-bus.sh
%{STACK_PREFIX}/utils/srp_persistent_bind.conf
%{STACK_PREFIX}/man/man8
%endif

%if %{build_srp_target}
%files srp_target
%defattr(-,root,root)
%{LIB_MOD_DIR}/ib_srp_target.*o
%{LIB_MOD_DIR}/scsi_target.*o
%{KSRC}/drivers/infiniband/ib_srp_target
%endif

# END Files

%changelog
* Wed Nov  2 2005 Vladimir Sokolovsky <vlad@mellanox.co.il>
- moved modules parameters from modprobe-openib.conf to modprobe.conf
 
* Mon May 23 2005 Vladimir Sokolovsky <vlad@mellanox.co.il>
- openib divided into packages

* Sun Jul 11 2004 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Initial packaging
