%define build_root %(if [ ! -z ${build_root} ]; then echo ${build_root}; else echo "/var/tmp/IBGD"; fi)
%define STACK_PREFIX %(if [ ! -z ${STACK_PREFIX} ]; then echo ${STACK_PREFIX}; else echo "/usr/local/ibgd"; fi)
%define IBADMHOME %(if [ ! -z ${IBADMHOME} ]; then echo ${STACK_PREFIX}/apps/ibadm; else echo "/usr/local/ibgd/apps/ibadm"; fi)
%define STACK %(if [ ! -z ${STACK} ]; then echo ${STACK}; else echo "ibgd"; fi)
%define kunamer %(uname -r)
%define VERSION XXXXXX
%define NAME YYYYYY
%define RELVER ZZZZZZ
%define krelver %(echo $(uname -r) | tr -s '-' '_')
%if %(echo -n %{kunamer}| grep -c smp)
 %{expand:%%define ksmp -smp}
%endif

# Disable debugging
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-compress and brp-strip
%define __os_install_post %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

Summary: IBADM Tools
BuildRequires: automake 
Prereq: grep
Requires: opensm 
Name: %{NAME}
Version: %{VERSION}
Release: %{krelver}
License: GPL
Group: System Environment/Base
Source: %{NAME}-%{RELVER}.tgz
BuildRoot: %{build_root}
Vendor: Mellanox Technologies Ltd.
AutoReq: no

%description
Infiniband Administration Package

%prep
%setup -n %{NAME}-%{RELVER}

%install

#Install ibadm
echo y | ./install.sh --build_root $RPM_BUILD_ROOT --prefix $RPM_BUILD_ROOT/%{IBADMHOME} -ss %{STACK_PREFIX} -d $RPM_BUILD_ROOT/%{IBADMHOME} -b %{STACK} --build_only -nc --batch

# Delete links to temporary build area
for ll in `find $RPM_BUILD_ROOT/%{IBADMHOME} -type l` 
do 
	if ( \ls -l $ll | grep "/tmp/ibadm_install_tmp" > /dev/null ); then 
		rm -f $ll 
	fi 
done

install -m 0755 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/ibadmd  $RPM_BUILD_ROOT/etc/init.d/ibadmd
install -m 0644 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/LICENSE.txt $RPM_BUILD_ROOT/%{IBADMHOME}/LICENSE.txt
install -m 0644 $RPM_BUILD_ROOT/%{IBADMHOME}/lib/ibadm/ibconf1.0/ibadm.conf $RPM_BUILD_ROOT/etc/ibadm.conf
install -m 0755 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/ibadm.topo  $RPM_BUILD_ROOT/etc/ibadm.topo
touch $RPM_BUILD_ROOT/etc/ibadm.hosts

if [ -f $RPM_BUILD_ROOT/%{IBADMHOME}/sbin/daemonize ]; then
	install -m 0755 $RPM_BUILD_ROOT/%{IBADMHOME}/sbin/daemonize $RPM_BUILD_ROOT/%{IBADMHOME}/bin/daemonize
fi

# Copy man files
install -d $RPM_BUILD_ROOT/%{_mandir}/man1

MANFILES="ibadm.1 ibadm.conf.1 ibcon.1 ibmon.1 ibls.1 ibfwmgr.1 ibtopogen.1 mlxburn.1"

for mf in $MANFILES
do
    install -m 0644 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/man/${mf}.gz $RPM_BUILD_ROOT/%{_mandir}/man1
done

%clean

rm -rf $RPM_BUILD_DIR/%{NAME}-%{RELVER}

%pre
	
%post
if [ $1 = 1 ]; then #This package is being installed for the first time

	if [ `uname -r` != "%{kunamer}" ]; then
	   echo This rpm supports only %{kunamer} kernel...
	   rpm -e %{NAME} 
	else
	
	# Edit /etc/ibadm.conf
	# Change Default servers from 127.0.0.1 to 0.0.0.0
	sed -e 's/127.0.0.1/0.0.0.0/g' /etc/ibadm.conf > /tmp/ibadm.conf.tmp
	mv -f /tmp/ibadm.conf.tmp /etc/ibadm.conf
	
	echo "# To cancel IBADM start on boot automatically set ONBOOT=no" >> /etc/ibadm.conf
	echo "ONBOOT=yes" >> /etc/ibadm.conf
		
if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
        perl -i -ne 'if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
#
# Bring up/down ibadm
#
# chkconfig: 235 60 75
# description: ibadm startup script
#
### BEGIN INIT INFO
# Provides:       ibadmd
### END INIT INFO
@;
                 } else {
                     print;
                 }' /etc/init.d/ibadmd

        /sbin/chkconfig --del ibadmd 
        /sbin/chkconfig --add ibadmd 
fi

if [ -f /etc/SuSE-release ]; then
        perl -i -ne 'if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
### BEGIN INIT INFO
# Provides:       ibadmd
# Required-Start: $network openibd opensmd
# Required-Stop:
# Default-Start:  2 3 5
# Default-Stop: 0 1 2 6
# Short-Description:    ibadm startup script
# Description:          ibadm startup script
### END INIT INFO
@;
                 } else {
                     print;
                 }' /etc/init.d/ibadmd

        /sbin/insserv ibadmd
fi

	if ! ( grep "`hostname -i | cut -d ' ' -f 1`" /etc/ibadm.hosts > /dev/null ); then
		echo `hostname -i | cut -d ' ' -f 1` >> /etc/ibadm.hosts
	fi

	    # Update /etc/ld.so.conf
	    perl -ni -e 'print unless (m@%{IBADMHOME}/lib\b@)' /etc/ld.so.conf
	    echo %{IBADMHOME}/lib >> /etc/ld.so.conf
		
	    /sbin/ldconfig

            # Create links to bin files from /usr/bin
            cd /usr/bin
                for bin in %{IBADMHOME}/bin/*
                do
                        ln -s -f ${bin}
                done
            # cd -
		
	    # Create links to lib directories from /usr/lib
	    cd /usr/lib
	    	for lib in %{IBADMHOME}/lib/*
    		do 
			    [ -d $lib ] && ln -snf $lib
	    	done
	    # cd -

    # Use saved configuration files if exists (rpmsave)
    CONFIGS="/etc/ibadm.conf /etc/ibadm.topo /etc/ibadm.hosts"
    for conf in $CONFIGS
    do
            if [ -e ${conf}.rpmsave ]; then
		[ -e ${conf} ] && cp -f ${conf} ${conf}.rpmnew
                cp -f ${conf}.rpmsave ${conf}
            fi    
    done

	fi
fi	
	
%files
%defattr(-,root,root)
%{IBADMHOME}
# %{IBADMHOME}/BUILD_ID  
# %{IBADMHOME}/ibdm  
# %{IBADMHOME}/ibis  
# %{IBADMHOME}/ibfw
# %{IBADMHOME}/ibos
# %{IBADMHOME}/README
# %{IBADMHOME}/LICENSE.txt
# %{IBADMHOME}/tools
# %{IBADMHOME}/lib
# %{IBADMHOME}/libs
# %{IBADMHOME}/bin
# %{IBADMHOME}/thread
# %{IBADMHOME}/include

%config /etc/ibadm.conf
%config /etc/ibadm.topo
%config /etc/ibadm.hosts

/etc/init.d/ibadmd

%{_mandir}/man1/ibadm.1.gz
%{_mandir}/man1/ibcon.1.gz
%{_mandir}/man1/ibmon.1.gz
%{_mandir}/man1/ibls.1.gz
%{_mandir}/man1/ibadm.conf.1.gz
%{_mandir}/man1/ibfwmgr.1.gz
%{_mandir}/man1/ibtopogen.1.gz
%{_mandir}/man1/mlxburn.1.gz


%preun

if [ $1 = 0 ]; then  # Erase, not upgrade
	if [ -d %{IBADMHOME}/bin ]; then
	   cd %{IBADMHOME}/bin
	   for bin in *
           do
             [ "$bin" != "*" ] && rm -f /usr/bin/$bin
           done
           # cd -
	fi
	if [ -d %{IBADMHOME}/lib ]; then
	   cd %{IBADMHOME}/lib
	   for lib in *
       	   do
         	[ "$lib" != "*" ] && [ -d $lib ] && rm -rf /usr/lib/$lib
           done
           # cd -
	fi

        if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
           /sbin/chkconfig --del ibadmd 
        fi
        if [ -f /etc/SuSE-release ]; then
           /sbin/insserv -r ibadmd
        fi

fi
 
%postun
if [ $1 = 0 ]; then # Erase, not upgrade
   # Update /etc/ld.so.conf
   perl -ni -e 'print unless (m@%{IBADMHOME}/lib@)' /etc/ld.so.conf
fi

%changelog
* Tue Jul 27 2004 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Initial packaging for openib stack
