#!/bin/bash 
#
# This software is available to you under a choice of one of two
# licenses.  You may choose to be licensed under the terms of the GNU
# General Public License (GPL) Version 2, available at
# <http://www.fsf.org/copyleft/gpl.html>, or the OpenIB.org BSD
# license, available in the LICENSE.TXT file accompanying this
# software.  These details are also available at
# <http://openib.org/license.html>.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# Copyright (c) 2004 Mellanox Technologies Ltd.  All rights reserved.
#

function cleanup_ibgcvs_files() {
    echo "Cleaning up previous IBGCVS installation in:$CONFIG_ROOT"
    # Clean old distribution
    binApps="ibgcvs" 
    echo " Removing Executables from : .......... $CONFIG_ROOT/bin." 
    for f in $binApps; do 
        rm -f ${CONFIG_ROOT}/bin/$f 2&>1 > /dev/null
    done

    echo " Removing Libs from : ................. $CONFIG_ROOT/lib."
    rm -rf ${CONFIG_ROOT}/lib/ibgdcsv1.0 2&>1 > /dev/null

    echo " Removing Man Pages from : ............ $CONFIG_ROOT/share/man/man1."
    mans="ibgdcvs"
    for f in $mans; do 
        rm -rf $CONFIG_ROOT/share/man/man1/$f.1.* 2&>1 > /dev/null
    done
}

CONFIG_ROOT=/usr

if test ! -z "$1"; then
 if test -d "$1"; then
    CONFIG_ROOT=$1
 else
    echo "-E- Given install directory:$1 does not exist"
    exit 1;
 fi
fi

cleanup_ibgcvs_files
exit 0
