

/*                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) June 2000, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 */                                                                                   
 
 
 
/*-------------------------------------------------------------------
 * Command line Arguments processing definition 
 *-------------------------------------------------------------------								 
 * $Id: cmd_pars.h,v 1.1 2003/10/29 17:10:11 dotanb Exp $
 * Dotan Barak 29.10.2003
 *-------------------------------------------------------------------
*/

#ifndef CMD_PARS_H_INCLUDED
#define CMD_PARS_H_INCLUDED 

#ifdef CMD_PARS_MODULE
#undef EXTERN
 #define EXTERN
#else
 #define EXTERN extern
#endif

//-----------------------------------------------------------------------------
// Types Definition
//-----------------------------------------------------------------------------
typedef struct option_descriptor {
	char m_option;			// One character option
	char* mm_option;		// String option
	char* equ_alias;		// Alias for rvalue. Enables '=' 
	char* help_desc;		// Help string
	unsigned int case_code;
} usage_descriptor_t; 

//-----------------------------------------------------------------------------
// Constants
//-----------------------------------------------------------------------------

//
// Usage descriptor
//
	#ifndef CMD_PARS_MODULE
extern usage_descriptor_t usage_descriptor[]; 
	#else
		// Next Free 19
	usage_descriptor_t usage_descriptor[]={
// common options

		{	
			'h', "help", "", 
			"Print this message and exit",
			#define HELP_CMD_CASE 			0
			HELP_CMD_CASE
		},

        {
			'H', "hca", "HCA_NAME",
			"Hca to use. Default InfiniHost0",
			#define HCA_N_CMD_CASE			1
			HCA_N_CMD_CASE
		},

		{
			'd', "daemon", "",
			"Run in daemon mode (wait connect)",
			#define DAEMON_CMD_CASE			2
			DAEMON_CMD_CASE
		},

		{
			' ', "tcp", "TCP_PORT",
			"TCP/IP Port Number.",
			#define IP_PORT_CMD_CASE		3
			IP_PORT_CMD_CASE
		},

        {	
			' ', "ip", "IP_ADDR", 
			"IP address of daemon (client only)",
			#define IP_ADDR_CMD_CASE 		4
			IP_ADDR_CMD_CASE
		},

		{
			'p', "port", "IB_PORT",
			"Specify HCA Port (default 1)",
			#define PORT_CMD_CASE			5
			PORT_CMD_CASE			
		},

		{
			' ', "alt_port", "IB_PORT",
			"Specify alternate HCA Port (default 2)",
			#define ALT_PORT_CMD_CASE			6
			ALT_PORT_CMD_CASE			
		}
    };

#endif

#define OPTIONS_N	(sizeof(usage_descriptor)/sizeof(struct option_descriptor))


//-----------------------------------------------------------------------------
// Global Variables
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Global Function Definition
//-----------------------------------------------------------------------------
int parse_argv( int my_argc, char** my_argv );

//-----------------------------------------------------------------------------
// Local Function Definition
//-----------------------------------------------------------------------------

#endif /*CMD_PARS_H_INCLUDED*/

