/*                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) Jan. 2004, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 *  End of legal section ......................................................
 *
 *
 *  Creation date:
 *
 *  Description: This file implements a kernel utility to cause fatal error to occur
 *               in the driver.
 *
 *  Version: $Id: genfatal.c,v 1.2 2004/02/02 08:34:29 jackm Exp $
 *  Authors:
 *    jack morgenstein
 *
 *  Changes:
 */           

#include <linux/kernel.h>
#include <linux/module.h>
#include <hh.h>
extern HH_ret_t THH_hob_external_fatal(HH_hca_hndl_t hca_hndl);

static int  infinihost_num = 0;
MODULE_PARM(infinihost_num,"i");
                    
int init_module(void)
{
   char hca_name[50];
   HH_hca_hndl_t hca_hndl;
   HH_ret_t      rc;

   memset(hca_name,0,50);
   sprintf(hca_name,"InfiniHost%d", infinihost_num);
   rc = HH_lookup_hca(hca_name,&hca_hndl);
   if (rc != HH_OK) {
      MTL_ERROR1("%s: HCA [%s] was not found (%d : %s)\n", __func__,
                 hca_name, rc, HH_strerror_sym(rc));
      return 1;
   }

   rc = THH_hob_external_fatal(hca_hndl);
   if (rc != HH_OK) {
      MTL_ERROR1("%s: Generation of fatal error for HCA [%s] failed (%d : %s)\n", __func__,
                 hca_name, rc, HH_strerror_sym(rc));
      return 1;
   }
   
    MTL_ERROR1("%s: Generated FATAL ERROR for HCA [%s]\n", __func__,hca_name);
    /* return failure on purpose to avoid need for rmmod*/
    return 1;
}

int cleanup_module(void)
{
    return 0;
}
